﻿//mw
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.IO;
using System.Windows.Controls.Primitives;  // PopupMenu Strg+Space
using Microsoft.Win32;
using System.Collections;
using System.Windows.Threading;
using HtmlWpfRtf.ColorText;
using static HtmlWpfRtf.ColorText.SplitColorTextBox;
using System.Diagnostics;
using System.Threading;

namespace HtmlWpfRtf {
    /// <summary>
    /// Interaction logic for MyTextBox.xaml
    /// </summary>
    public partial class MyTextBox : UserControl {


        private class ClassUndo {
            public List<Block> blockListe = new List<Block>();
            public Block activeBlock = null;
        }

        private List<ClassUndo> undoRedoListe = new List<ClassUndo>();
        private int undoRedoIndex = -1;
        private String undoText = "";


        private DispatcherTimer dispatcherTimerUndo = new DispatcherTimer();

        bool pasteKey = false;
        bool modifiedUndo = false;

        private class TextBlockIntellisense : TextBlock, IComparable {
            public Intellisense intellisense = null;

            public int CompareTo(object obj) {
                TextBlockIntellisense block = (TextBlockIntellisense)obj;
                int retcode = intellisense.showtext.CompareTo(block.intellisense.showtext);
                return retcode;
            }

        }

        private DispatcherTimer dispatcherTimer = new DispatcherTimer();

        SplitColorTextBox splitColorTextBox = new SplitColorTextBox();


        Brush brushHTML = new SolidColorBrush(Colors.Blue);
        Brush brushNormalText = new SolidColorBrush(Colors.Black);
        Brush brushSpecialChars = new SolidColorBrush(Colors.Red);
        Brush brushComment = new SolidColorBrush(Colors.LightYellow);
        Brush brushLightBlue = new SolidColorBrush(Colors.LightBlue);
        Brush brushLinenumber = new SolidColorBrush(Colors.LightBlue);
        Brush brushBackground = new SolidColorBrush(Colors.White);


        private int indexBlockSuchen = -1;
        private int indexInlinesSuchen = -1;

        private bool createRtf = false;

        FlowDocument flowdoc = null;

        public enum TextBoxTyp { KeinEditor, HTML, CSS };


        private int active = 0;
        private int id = 0;

        private TextBoxTyp editorTyp;

        private Modell modell = null;

        private ISetMainWindows mainParent;  // textBox1_TextChanged
        StringBuilder sb = new StringBuilder();


        public Modell getModell() {
            return modell;
        }


        public String Filename {
            set {
                modell.Filename = value;
            }
            get { return modell.Filename; }
        }


        public Boolean isActive() {
            return active == id;
        }


        public Boolean Modified {
            get { return modell.Modified; }
            set { modell.Modified = value; }
        }



        public String EditorText {
            get {
                TextRange textRange = new TextRange(editor.Document.ContentStart, editor.Document.ContentEnd);
                String text = textRange.Text;
                //while (text.EndsWith("\r\n")) {
                //    text = text.Substring(0, text.Length - 2);
                //}
                if (text.EndsWith("\r\n")) {
                    text = text.Substring(0, text.Length - 2);
                }
                return text;

            }
            set {
                TextRange range = new TextRange(editor.Document.ContentStart, editor.Document.ContentEnd);
                range.Text = value;
            }
        }


        public void setFontsize(int size) {
            editor.FontSize = size;
            if (editorTyp != TextBoxTyp.KeinEditor) {
                lRowNr.FontSize = size;
                lColumnNr.FontSize = size;
                lDatei.FontSize = size;
                mainMenu.FontSize = size;
                foreach (Object obj in mainMenu.Items) {
                    if (obj is MenuItem) {
                        setFontsize((MenuItem)obj, size);
                    }
                }
            }
            editorRownr.FontSize = size;
        }

        public void setFontsize(MenuItem mn, int size) {
            mn.FontSize = size;
            foreach (Object obj in mn.Items) {
                if (obj is MenuItem) {
                    setFontsize((MenuItem)obj, size);
                }
            }
        }

        public void replaceTab(String tabold, String tabnew) {
            //editor.Text = editor.Text.Replace(tabold, tabnew);
        }



        public MenuItem createMenuItem(MenuItem parent, String name, String title) {
            MenuItem mn = new MenuItem();
            mn.Name = name;
            mn.Header = title;
            mn.IsTabStop = false;
            mn.Click += new RoutedEventHandler(mn_Click);
            if (parent != null) parent.Items.Add(mn);
            mn.FontSize = 13;
            if (name.StartsWith("main"))
                mn.Foreground = Brushes.Blue;
            else
                mn.Foreground = Brushes.Black;

            //sb.AppendLine("\t\t\tif (mnName == \"" + name + "\")\tHTML_Middleware.");
            return mn;
        }

        

        private void dispatcherTimerUndo_Tick(object sender, EventArgs e) {
            CommandManager.InvalidateRequerySuggested();
            if (modifiedUndo) {
                setUndo();
                saveData();
            }
            
        }

        private void saveData() {
            if (modell != null && !createRtf) {
                modell.Modified = true;
                String lines = EditorText;  // nun die Leerzeilen am Ende löschen
                String crlf = "\r\n\r\n\r\n";
                bool mitLeerzeilen = lines.EndsWith(crlf);
                while (mitLeerzeilen) {
                    int i = lines.LastIndexOf(crlf);
                    if (i>0) {
                        lines = lines.Remove(i);
                    }
                    mitLeerzeilen = lines.EndsWith(crlf);
                }
                // EditorText = lines;  
                modell.EditText = lines;
                if (File.Exists(modell.Filename)) {
                    String name = modell.Filename.ToLower();
                    modell.saveFile1();

                    // setUndo();  // UndoUndo
                    // modifiedUndo = true;

                    //undoRedoListe.Add(EditorText);
                    //undoRedoIndex = undoRedoListe.Count - 1;

                    if (name.EndsWith("html") || name.EndsWith("htm")) {
                        // setzt den internen Browser
                        this.mainParent.setFile2Browser(modell.Filename);
                    }
                    else {
                        if (name.EndsWith("css")) {
                            // setzt den internen Browser
                            this.mainParent.setFile2Browser(modell.Htmlfilename);
                        }
                    }
                }
                mainParent.editorIsModfied();
            }
        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            CommandManager.InvalidateRequerySuggested();
            if (editorRownr.VerticalOffset != editor.VerticalOffset) {
                double vo = editor.VerticalOffset;
                editorRownr.ScrollToVerticalOffset(vo);
            }

        }

        public MyTextBox(ISetMainWindows mainParent, int id, TextBoxTyp editorTyp, Modell modell = null) {
            InitializeComponent();

            this.mainParent = mainParent;
            //this.LastChildFill = true;
            this.editorTyp = editorTyp;

            this.HorizontalAlignment = HorizontalAlignment.Stretch;
            this.VerticalAlignment = VerticalAlignment.Stretch;

            flowdoc = new FlowDocument();
            editor.Document = flowdoc;

            if (editorTyp != TextBoxTyp.KeinEditor) {
                this.modell = modell;

                int n = 999;


                sb.Clear();
                for (int i = 1; i < n; i++) {
                    sb.Append(i.ToString("000"));
                    sb.AppendLine(" ");
                }
                editorRownr.Text = sb.ToString();  //             editor.Foreground = new SolidColorBrush(Color.FromRgb((byte)SingVar.FontcolorRed, (byte)SingVar.FontcolorGreen, (byte)SingVar.FontcolorBlue));

                createmenus(editorTyp);

                DockPanel.SetDock(wrapPanel, Dock.Bottom);
            }
            else {
                //this.Children.Add(this.editor);
            }
            this.id = id;

            this.editor.FontSize = 12;
            this.editor.FontFamily = new System.Windows.Media.FontFamily(SingVar.Fontfamily);  // Courier New  "Consolas"

            //  this.editor.MaxLength = 327670;

            this.editor.LostFocus += this.textBox1_LostFocus;
            this.editor.GotFocus += this.textBox1_GotFocus;
            this.editor.PreviewKeyUp += editor_PreviewKeyUp;  // ????
            this.editor.TextChanged += textBox1_TextChanged;

            this.editorRownr.FontSize = 12;
            this.editorRownr.FontFamily = new System.Windows.Media.FontFamily(SingVar.Fontfamily);  // Courier New  "Consolas"

            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(100);
            dispatcherTimer.Start();


            dispatcherTimerUndo.Tick += new EventHandler(dispatcherTimerUndo_Tick);
            dispatcherTimerUndo.Interval = TimeSpan.FromMilliseconds(1000);
            dispatcherTimerUndo.Start();


            setColors(false); // ohne Formatierung, da noch nicht geladen !
        }

        public void setFontFamily(FontFamily font) {
            this.editor.FontFamily = font;
            this.editorRownr.FontFamily = font;

        }

        public void setColors(bool mitFormat = true) {
            brushBackground = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.FontcolordialogBackgroundRed, (byte)SingVar.FontcolordialogBackgroundGreen, (byte)SingVar.FontcolordialogBackgroundBlue));

            editor.Foreground = new SolidColorBrush(Color.FromRgb((byte)SingVar.FontcolorRed, (byte)SingVar.FontcolorGreen, (byte)SingVar.FontcolorBlue));
            editor.Background = brushBackground;

            brushLinenumber = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.LineNumberColordialogForegroundRed, (byte)SingVar.LineNumberColordialogForegroundGreen, (byte)SingVar.LineNumberColordialogForegroundBlue));
            editorRownr.Background = brushBackground;
            editorRownr.Foreground = brushLinenumber;

            wrapPanel.Background = brushBackground;

            lRowNr.Foreground = new SolidColorBrush(Color.FromRgb((byte)SingVar.FontcolorRed, (byte)SingVar.FontcolorGreen, (byte)SingVar.FontcolorBlue));
            lRowNr.Background = brushBackground;
            lColumnNr.Foreground = new SolidColorBrush(Color.FromRgb((byte)SingVar.FontcolorRed, (byte)SingVar.FontcolorGreen, (byte)SingVar.FontcolorBlue));
            lColumnNr.Background = brushBackground;
            lDatei.Foreground = new SolidColorBrush(Color.FromRgb((byte)SingVar.FontcolorRed, (byte)SingVar.FontcolorGreen, (byte)SingVar.FontcolorBlue));
            lDatei.Background = brushBackground;

            //backgroundColor = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.FontcolordialogBackgroundRed, (byte)SingVar.FontcolordialogBackgroundGreen, (byte)SingVar.FontcolordialogBackgroundBlue));
            //penLinenumber = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.LineNumberColordialogForegroundRed, (byte)SingVar.LineNumberColordialogForegroundGreen, (byte)SingVar.LineNumberColordialogForegroundBlue));
            brushHTML = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.HtmlColordialogForegroundRed, (byte)SingVar.HtmlColordialogForegroundGreen, (byte)SingVar.HtmlColordialogForegroundBlue));
            brushNormalText = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.NormalTextColordialogForegroundRed, (byte)SingVar.NormalTextColordialogForegroundGreen, (byte)SingVar.NormalTextColordialogForegroundBlue));
            brushSpecialChars = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.SpecialCharactersColordialogForegroundRed, (byte)SingVar.SpecialCharactersColordialogForegroundGreen, (byte)SingVar.SpecialCharactersColordialogForegroundBlue));
            brushComment = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.CommentColordialogForegroundRed, (byte)SingVar.CommentColordialogForegroundGreen, (byte)SingVar.CommentColordialogForegroundBlue));
            brushLightBlue = new SolidColorBrush(Color.FromArgb((byte)255, (byte)SingVar.HtmlColordialogForegroundRed, (byte)SingVar.HtmlColordialogForegroundGreen, (byte)SingVar.HtmlColordialogForegroundBlue));


            if (mitFormat) {
                format();
            }
        }



        // <form>
        public void InsertZeile(string sText, int offset = 0) {
            String s1 = Clipboard.GetText();

            Clipboard.Clear();
            Clipboard.SetText(sText);
            createRtf = true;
            editor.Paste();
            // setUndo1();   // UndoUndo
            createRtf = false;
            modifiedUndo = true;

            Modified = true;
            Clipboard.SetText(s1);
            //format();
        }





        public void InsertText(string sText) {
            String s1 = Clipboard.GetText();

            Clipboard.Clear();
            Clipboard.SetText(sText);
            createRtf = true;
            editor.Paste();
            // setUndo1();// UndoUndo
            modifiedUndo = true;
            createRtf = false;

            Modified = true;
            Clipboard.SetText(s1);
            // format();
        }

        public int getLineNummer() {
            return 0;
        }


        public void setLineNummer() {
        }



        private void textBox1_LostFocus(object sender, RoutedEventArgs e) {
            if (active == id) active = 0;
        }

        private void textBox1_GotFocus(object sender, RoutedEventArgs e) {
            active = id;
        }


        public void changeCSSFile(String oldHTMLFilename, String newHTMLFilename) {
            //String path, oldName, newName, ext;
            //Basis.splitFilename(oldHTMLFilename, out path, out oldName, out ext);
            //Basis.splitFilename(newHTMLFilename, out path, out newName, out ext);
            //// suche   href="Vorl_jq8.css"    ersetze  durch href="Vorl_jq9.css"
            //int i = editor.Text.IndexOf("href=\"" + oldName + ".css\"");
            //if (i > 0) {
            //    editor.Text = editor.Text.Replace("href=\"" + oldName + ".css\"", "href=\"" + newName + ".css\"");
            //    modell.Modified = true;
            //    modell.EditText = editor.Text;
            //}   
        }

     

        // interner Klick: Ausgabe aller Undo-Blöcke 
        private void AusgabeAllerUndoBloecke_Click(Object sender, RoutedEventArgs e) {
            StringBuilder sb = new StringBuilder();
            int index = 0;
            foreach (ClassUndo undo in undoRedoListe) {
                sb.AppendLine("index: " + index);
                sb.Append("   ");
                foreach (Block block in undo.blockListe) {
                    Paragraph paragraph = (Paragraph)block;
                    foreach (Inline inline in paragraph.Inlines) {
                        Run run = (Run)inline;
                        String text = run.Text;
                        sb.Append(text);
                        sb.Append(" ");
                    }

                }
                sb.AppendLine();
                sb.AppendLine();
                index++;
            }
            Clipboard.SetText(sb.ToString());
        }

        private void firstUndo() {
            undoRedoListe.Clear();
            undoRedoIndex = -1;
            undoText = "";
            setUndo();
            modifiedUndo = false;
        }

        private void setUndo() {
            modifiedUndo = false; ;
            if (undoRedoIndex < undoRedoListe.Count - 1) {
                // löschen der oberen Elemente  RÜCKWÄRTS !
                for (int i= undoRedoListe.Count - 1; i> undoRedoIndex; i--) {
                    undoRedoListe.RemoveAt(i);
                }
            }
            ClassUndo undo = new ClassUndo();
            for (int i = 0; i < flowdoc.Blocks.Count; i++) {
                Paragraph paragraph = (Paragraph)flowdoc.Blocks.ElementAt(i);
                Paragraph newParagraph = new Paragraph();
                foreach (Inline inline in  paragraph.Inlines) {
                    try {
                        if (inline is Run) {
                            Run run = (Run)inline;  // 
                            String text = run.Text;
                            newParagraph.Inlines.Add(new Run(text));
                        }
                        else if (inline is Span) {
                            Span span = (Span)inline;  // 
                            String text = span.ToString();
                            newParagraph.Inlines.Add(new Run(text));
                        }
                    }
                    catch (Exception) {
                        Type t = inline.GetType();
                        Basis.ErrorMsg("Type "+t.ToString(), "Fehler");
                    }
                }
                undo.blockListe.Add(newParagraph);
            }

            undoRedoListe.Add(undo);
            undoRedoIndex = undoRedoListe.Count - 1;
            lRowNr.Content = undoRedoIndex.ToString();
        }
        public void undoClick() {  // Strg+Z
            if (undoRedoListe.Count > 0 && undoRedoIndex >= 0 && undoRedoIndex < undoRedoListe.Count) {
                ClassUndo undo = undoRedoListe[undoRedoIndex];
                undoRedoIndex--;
                createRtf = true;
                flowdoc.Blocks.Clear();
                flowdoc.Blocks.AddRange(undo.blockListe);

                modell.Modified = false;
                createRtf = false;
                lRowNr.Content = undoRedoIndex.ToString();
            }
            //editor.Undo();
        }

        public void redoClick() {
            if (undoRedoListe.Count > 0 && undoRedoIndex >= 0 && undoRedoIndex < undoRedoListe.Count-1) {
                ClassUndo undo = undoRedoListe[undoRedoIndex];
                undoRedoIndex++;
                createRtf = true;
                flowdoc.Blocks.Clear();
                flowdoc.Blocks.AddRange(undo.blockListe);

                modell.Modified = false;
                createRtf = false;
                lRowNr.Content = undoRedoIndex.ToString();
            }
            //editor.Redo();
        }

        public void saveFile() {
            //undoRedoListe.Add(EditorText);
            //undoRedoIndex = undoRedoListe.Count - 1;
            modell.saveFile1();
        }

        // <form>
        private void textBox1_TextChanged(object sender, TextChangedEventArgs e) {
            modifiedUndo = true;
            //if (modell != null && !createRtf) {
            //    modell.Modified = true;
            //    modell.EditText = EditorText;
            //    if (File.Exists(modell.Filename)) {
            //        String name = modell.Filename.ToLower();
            //        modell.saveFile1();

            //        // setUndo();  // UndoUndo
            //        // modifiedUndo = true;

            //        //undoRedoListe.Add(EditorText);
            //        //undoRedoIndex = undoRedoListe.Count - 1;

            //        if (name.EndsWith("html") || name.EndsWith("htm")) {
            //            // setzt den internen Browser
            //            this.mainParent.setFile2Browser(modell.Filename);
            //        }
            //        else {
            //            if (name.EndsWith("css")) {
            //                // setzt den internen Browser
            //                this.mainParent.setFile2Browser(modell.Htmlfilename);
            //            }
            //        }
            //    }
            //    mainParent.editorIsModfied();
            //}
        }

        private String getTabs(int tablength) {
            String sErg = "";
            for (int i = 0; i < tablength; i++) {
                //sErg += "\t";
                sErg += Konst.C_TAB;
            }
            return sErg;
        }

        private void parseText(String text) {
            splitColorTextBox.splitText(text);
            List<StringList> gesamtliste = splitColorTextBox.gesamtliste;

            Paragraph paragraph = null;

            flowdoc.Blocks.Clear();

            Brush brush;
            foreach (StringList slist in gesamtliste) {
                int anzTab = slist.anzTabs;
                String sPrefix = getTabs(anzTab);
                paragraph = new Paragraph();
                if (slist.colorstrings.Count > 0) {
                    paragraph.Inlines.Add(new Run(sPrefix) {
                        Foreground = brushSpecialChars
                    });
                }
                foreach (ColorString cString in slist.colorstrings) {
                    switch (cString.colortyp) {
                        case ColorTyp.html:
                            brush = brushHTML;
                            break;
                        case ColorTyp.space:
                            brush = brushSpecialChars;
                            break;
                        case ColorTyp.specialchars:
                            brush = brushSpecialChars;
                            break;
                        case ColorTyp.text:
                            brush = brushNormalText;
                            break;
                        case ColorTyp.comments:
                            brush = brushComment;
                            break;
                        default:
                            brush = brushNormalText;
                            break;
                    }  // switch
                    paragraph.Inlines.Add(new Run(cString.sb.ToString()) {
                        Foreground = brush
                    });
                }
                flowdoc.Blocks.Add(paragraph);
            }
        }  // parseText


        public void createColorText() {
            int caretIntPosition = GetIntPosition(editor.CaretPosition, editor);
            parseText(EditorText);

            if (caretIntPosition >= 0) {
                try {
                    SetIntPosition(caretIntPosition + 1, editor);
                }
                catch (Exception ) {
                    SetIntPosition(caretIntPosition, editor);
                }
            }
        }

        int GetIntPosition(TextPointer pointerPosition, RichTextBox rtb) {
            int intPosition = -1;
            try {
                TextPointer currentPosition = rtb.Document.ContentStart;
                while (currentPosition.CompareTo(pointerPosition) != 0) {
                    intPosition++;
                    currentPosition = currentPosition.GetNextInsertionPosition(LogicalDirection.Forward);
                }
            }
            catch (Exception ) {
            }
            return intPosition;
        }

        void SetIntPosition(int intPosition, RichTextBox rtb) {
            TextPointer currentOldPosition = null;

            try {
                TextPointer currentPosition = rtb.Document.ContentStart;

                for (int i = 1; i <= intPosition; i++) {
                    currentPosition = currentPosition.GetNextInsertionPosition(LogicalDirection.Forward);  // Absturz
                    currentOldPosition = currentPosition;
                }
                rtb.CaretPosition = currentPosition;
            }
            catch (Exception ) {
                // Basis.ErrorMsg("Posi:" + intPosition, "Absturz");
                if (currentOldPosition != null) {
                    rtb.CaretPosition = currentOldPosition;
                }

            }
        }

        // mycolortextbox2
        public void loadFile(String filename) {
            createRtf = true;
            String text = modell.loadFile(filename);// 1234
            parseText(text);

            modell.Modified = false;
            lDatei.Content = Basis.getFilename(filename).Replace("_", "__");
            createRtf = false;
            firstUndo();
            // editor.CaretPosition

        }

        public void setMainMenu(Visibility v) {
            mainMenu.Visibility = v;
        }

        private void MnPaste_Click(Object sender, RoutedEventArgs e) {
            Paste();
        }

        private void MnCopy_Click(Object sender, RoutedEventArgs e) {
            Copy();
        }

        private void MnCut_Click(Object sender, RoutedEventArgs e) {
            Cut();
        }
        private void MnSelectAll_Click(Object sender, RoutedEventArgs e) {
            SelectAll();
        }


        public void Copy() {
            // editor ist in xaml            
            editor.Copy();
            Thread.Sleep(50);
            String s1 = Clipboard.GetText();
            String s = s1.Replace(Konst.C_TAB, "\t");
            Clipboard.Clear();
            Clipboard.SetText(s);
            modifiedUndo = true;
        }
        public void Cut() {
            editor.Cut();
            Modified = true;
            modifiedUndo = true;
        }

        public void Paste() {
            String s1 = Clipboard.GetText();
            String s = s1.Replace(Konst.C_TAB, "  ");
            s = s.Replace("\t", "  ");  

            Clipboard.SetText(s, TextDataFormat.UnicodeText);
            //String s2 = Clipboard.GetText();
            editor.Paste();
            Modified = true;
            //format();
            //Clipboard.SetText(s+"1", TextDataFormat.Text);
            //pasteKey = true;  // siehe editor_PreviewKeyDown
            modifiedUndo = true;
        }

        public void SelectAll() {
            editor.SelectAll();
        }

        public void select(int index, int length) {
            // xxxx
            //editor.Select(index, length);
            //editor.SelectionStart = index;
        }

        // suchen
        public void searchText(String search) {
            indexBlockSuchen = -1;
            indexInlinesSuchen = -1;
            String searchText = "";
            if (SingVar.ignoreCase1)
                searchText = search.ToLower();
            else
                searchText = search;
            //position = 0;
            //BlockCollection
            Paragraph paragraph = null;
            Run run = null;
            String s = "";

            for (int i = 0; i < flowdoc.Blocks.Count; i++) {
                indexBlockSuchen = i;
                paragraph = (Paragraph)flowdoc.Blocks.ElementAt(i);
                //String s = paragraph.ToString();
                for (int j = 0; j < paragraph.Inlines.Count; j++) {
                    indexInlinesSuchen = j;
                    run = (Run)paragraph.Inlines.ElementAt(j);
                    if (SingVar.ignoreCase1)
                        s = run.Text.ToLower();
                    else
                        s = run.Text.ToLower();
                    if (SingVar.wholeword) {
                        if (s.Equals(searchText)) {
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            editor.CaretPosition = run.ContentStart;
                            return;
                        }
                    }
                    else {
                        if (s.Contains(searchText)) {
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            editor.CaretPosition = run.ContentStart;
                            return;
                        }
                    }
                }
            }

            MessageBox.Show("Die Suche war nicht erfolgreich.\r\nSuchwert: " + SingVar.search,
                    "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
        } // Start search


        public void searchAgain() {
            if (indexBlockSuchen < 0) {
                indexBlockSuchen = 0;
            }
            if (indexInlinesSuchen < 0) {
                indexInlinesSuchen = 0;
            }
            String searchText = "";
            if (SingVar.ignoreCase1)
                searchText = SingVar.search.ToLower();
            else
                searchText = SingVar.search;

            //BlockCollection
            Paragraph paragraph = null;
            Run run = null;
            String s = "";
            int startIndexInlines = indexInlinesSuchen + 1;

            for (int i = indexBlockSuchen; i < flowdoc.Blocks.Count; i++) {
                indexBlockSuchen = i;
                paragraph = (Paragraph)flowdoc.Blocks.ElementAt(i);
                //String s = paragraph.ToString();
                for (int j = startIndexInlines; j < paragraph.Inlines.Count; j++) {
                    indexInlinesSuchen = j;
                    run = (Run)paragraph.Inlines.ElementAt(j);
                    if (SingVar.ignoreCase1)
                        s = run.Text.ToLower();
                    else
                        s = run.Text.ToLower();
                    if (SingVar.wholeword) {
                        if (s.Equals(searchText)) {
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            editor.CaretPosition = run.ContentStart;
                            return;
                        }
                    }
                    else {
                        if (s.Contains(searchText)) {
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            editor.CaretPosition = run.ContentStart;
                            return;
                        }
                    }
                }
                startIndexInlines = 0;// beim zweiten Mal: Start mit null
            }
            MessageBox.Show("Die Suche war nicht erfolgreich.\r\nSuchwert: " + SingVar.search,
                    "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
        } // searchAgain


        public void replaceText(String search, String replace) {
            indexBlockSuchen = -1;
            indexInlinesSuchen = -1;
            String searchText = "";
            if (SingVar.ignoreCase1)
                searchText = search;
            else
                searchText = search.ToLower();
            int anzErsetzt = 0;

            //BlockCollection
            Paragraph paragraph = null;
            Run run = null;
            String s = "";
            StringBuilder sb = new StringBuilder();

            for (int i = 0; i < flowdoc.Blocks.Count; i++) {
                indexBlockSuchen = i;
                paragraph = (Paragraph)flowdoc.Blocks.ElementAt(i);
                //String s = paragraph.ToString();
                for (int j = 0; j < paragraph.Inlines.Count; j++) {
                    indexInlinesSuchen = j;
                    run = (Run)paragraph.Inlines.ElementAt(j);
                    if (SingVar.ignoreCase1)
                        s = run.Text.ToLower();
                    else
                        s = run.Text.ToLower();
                    if (SingVar.wholeword) {
                        if (s.Equals(searchText)) {
                            run.Text = replace;
                            anzErsetzt++;
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            //editor.CaretPosition = run.ContentStart;
                            //return;
                        }
                    }
                    else {
                        if (s.Contains(searchText)) {
                            anzErsetzt++;
                            int n = searchText.Length;
                            int index = s.IndexOf(searchText);
                            // Abfrage auf ignoreCase !
                            if (SingVar.ignoreCase1) {
                                sb.Clear();
                                if (index > 0) {
                                    String d1 = s.Substring(0, index);
                                    sb.Append(s.Substring(0, index));
                                }
                                if (s.Length > (searchText.Length + index)) {
                                    sb.Append(replace);
                                    String d2 = s.Substring(index + searchText.Length);
                                    sb.Append(s.Substring(index + searchText.Length));
                                }
                                else {
                                    // nun  gleich
                                    sb.Append(replace);
                                }
                                run.Text = sb.ToString();
                                anzErsetzt++;
                            }
                            else {
                                run.Text = run.Text.Replace(SingVar.search, replace);
                                run.Text = replace;
                                anzErsetzt++;
                            }
                            // editor.CaretPosition = paragraph.ContentStart;  // Zeilenanfang
                            //editor.CaretPosition = run.ContentStart;
                            // return;
                        }
                    }
                }
            }
            if (anzErsetzt == 0) {
                MessageBox.Show("Das Ersetzen war nicht erfolgreich.\r\nSuchwert: " + SingVar.search +
                    "\r\nErsetzt durch: " + SingVar.replace,
                    "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
        } // Start replace


        // neu   
        /*
        @keyframes slidein1 {
            from {
            }
        }
        */
        public void formatCSSFile() {
            StringBuilder output = new StringBuilder();  // schneller als ein String                
            String line;
            String[] lines = Basis.getLines(EditorText);
            int anzSpitzAuf = 0;
            int anzSpitzZu = 0;
            int offset = 0;
            for (int i = 0; i < lines.Count(); i++) {
                line = lines[i].Replace(Konst.C_TAB, "  ").Trim();
                if (line.Length == 0) {
                    output.AppendLine();
                }
                else {
                    offset = 0;
                    String str = output.ToString();
                    if (line.EndsWith("{")) {
                        anzSpitzAuf++;
                        offset = -1;
                    }
                    if (line.StartsWith("}")) {
                        anzSpitzAuf--;
                        anzSpitzZu++;
                    }
                    output.Append(getTabs(anzSpitzAuf + offset));
                    output.AppendLine(line.Trim());
                }
            }  // for

            modell.EditText = output.ToString();
            modell.Modified = true;
            parseText(output.ToString());

        }  // formatCSSFile

        public void formatCSSFile2() {
            StringBuilder output = new StringBuilder();  // schneller als ein String                
            String line;
            String[] lines = Basis.getLines(EditorText);

            for (int i = 0; i < lines.Count(); i++) {
                line = lines[i].Replace(Konst.C_TAB, "  ").Trim();
                if (line.Length == 0) {
                    output.AppendLine();
                }
                else {
                    String str = output.ToString();
                    bool anzSpitzAuf = line.EndsWith("{");
                    bool anzSpitzZu = line.StartsWith("}");
                    if (anzSpitzZu) {
                        output.AppendLine(line.Trim());
                    }
                    else {
                        if (anzSpitzAuf) {
                            line = line.Replace('\t', ' ');
                            output.AppendLine(line.Trim());
                        }
                        else {
                            line = line.Replace('\t', ' ');
                            output.AppendLine(getTabs(1) + line.Trim());
                        }
                    }
                }
            }  // for

            modell.EditText = output.ToString();
            modell.Modified = true;
            parseText(output.ToString());

        }  // formatCSSFile

        public void formatJavaScriptFile() {
            StringBuilder output = new StringBuilder();  // schneller als ein String                
            int tab = 0;
            String line;
            String[] lines = Basis.getLines(EditorText);
            for (int i = 0; i < lines.Count(); i++) {
                line = lines[i].Replace(Konst.C_TAB, "  ").Trim();
                if (line.Length == 0) {
                    output.AppendLine();
                }
                else {
                    String str = output.ToString();
                    bool anzSpitzAuf = line.EndsWith("{");
                    bool anzSpitzZu = line.StartsWith("}");
                    if (anzSpitzZu) {
                        tab--;  // nur wenn nicht in einer Zeile
                        output.AppendLine(getTabs(tab) + line.Trim());
                        if (tab == 0) output.AppendLine("");
                    }
                    else {
                        if (anzSpitzAuf) {
                            // tab++;
                            line = line.Replace('\t', ' ');
                            output.AppendLine(getTabs(tab) + line.Trim());
                            tab++;
                        }
                        else {
                            line = line.Replace('\t', ' ');
                            String dummy = getTabs(tab) + line.Trim();
                            output.AppendLine(getTabs(tab) + line.Trim());
                        }
                    }
                }
            }  // for
            modell.EditText = output.ToString();
            modell.Modified = true;
            parseText(output.ToString());
        }  // formatJavaScriptFile

        public void format() {
            //int posTop = editor.CaretIndex;

            TextPointer currentPosition = editor.CaretPosition;
            int indexparagraphStart = 0;
            
            Paragraph paragraphStart = currentPosition.Paragraph;
            foreach (Paragraph paragraph in flowdoc.Blocks) {
                if (paragraph == paragraphStart) {
                    break;
                }
                indexparagraphStart++;
            }
            if (indexparagraphStart>1) {
                indexparagraphStart-=2;  
            }



            // check ob es eine *.js datei ist
            if (modell.Filename.ToLower().EndsWith(".js")) {
                formatJavaScriptFile();
                return;
            }
            if (modell.Filename.ToLower().EndsWith(".css")) {
                formatCSSFile();
                return;
            }

            String javascript1 = "<script";
            String javascript2 = "</script";
            String jsp1 = "<%";
            String jsp2 = "%>";
            String php1 = "<?php";
            String php2 = "?>";
            bool javascript = false;
            bool jsp = false;
            bool php = false;

            bool doctype = false;
            bool html = false;
            StringBuilder output = new StringBuilder();  // schneller als ein String                
            int tab = 0;
            int i1, i2;
            String line;
            String[] lines = Basis.getLines(EditorText);
            for (int i = 0; i < lines.Count(); i++) {
                line = lines[i].Replace(Konst.C_TAB, "  ").Trim();
                if (line.Length == 0) {
                    output.AppendLine();
                    continue;
                }


                if (javascript) {
                    i1 = line.IndexOf(javascript2);
                    if (i1 >= 0) {
                        javascript = false;
                        tab--;  // nur wenn nicht in einer Zeile
                        output.AppendLine(getTabs(tab) + line.Trim());
                        if (tab == 0) output.AppendLine("");
                        continue;
                    }
                    else {
                        String str = output.ToString();

                        bool anzSpitzAuf = line.EndsWith("{");
                        bool anzSpitzZu = line.StartsWith("}");

                        //  } else {
                        int indexSpitzAuf = line.IndexOf('{');
                        int indexSpitzZu = line.IndexOf('}');
                        int indexelse = line.IndexOf("else");
                        if (indexSpitzAuf >= 0 && indexSpitzZu >= 0 && indexSpitzZu < indexelse && indexSpitzAuf > indexelse) {
                            line = line.Replace('\t', ' ');
                            tab--;  // nur wenn nicht in einer Zeile
                            output.AppendLine(getTabs(tab) + line.Trim());
                            if (tab == 0) output.AppendLine("");
                            tab++;
                        }
                        else {
                            if (anzSpitzZu) {
                                tab--;  // nur wenn nicht in einer Zeile
                                output.AppendLine(getTabs(tab) + line.Trim());
                                if (tab == 0) output.AppendLine("");
                            }
                            else {
                                if (anzSpitzAuf) {
                                    // tab++;
                                    line = line.Replace('\t', ' ');
                                    output.AppendLine(getTabs(tab) + line.Trim());
                                    i1 = line.IndexOf(javascript2);
                                    tab++;
                                }
                                else {
                                    line = line.Replace('\t', ' ');
                                    output.AppendLine(getTabs(tab) + line.Trim());
                                }
                            }
                        }
                        continue;
                    }
                }
                else {  // noch kein Javascript
                    i1 = line.IndexOf(javascript1);
                    if (i1 >= 0) {
                        javascript = true;
                        line = line.Replace('\t', ' ').Trim();
                        output.AppendLine(getTabs(tab) + line.Trim());
                        tab++;
                        i1 = line.IndexOf(javascript2);
                        if (i1 > 0) {
                            // in einer Zeile:  Anfang und ende
                            javascript = false;
                            tab--;
                        }
                        continue;
                    }
                }  // javascript

                if (php) {
                    i1 = line.IndexOf(php2);
                    if (i1 >= 0) {
                        php = false;
                        tab--;  // nur wenn nicht in einer Zeile
                        output.AppendLine(getTabs(tab) + line.Trim());
                        if (tab == 0) output.AppendLine("");
                        continue;
                    }
                    else {
                        String str = output.ToString();
                        //  } else {
                        int indexSpitzAuf = line.IndexOf('{');

                        // 	$arr[] = new UIPattern('text','Nachname',0,0,'^[A-ZÜÄÖ][a-züäöß]{1,29}$');
                        int indexSpitzZu = line.IndexOf('}');

                        if (indexSpitzAuf>0 && indexSpitzZu>0) {
                            // bestimme Positionen von ^ und $
                            int indexDach = line.IndexOf('^');  
                            int indexDollar = line.LastIndexOf('$');
                            if (indexDach<indexSpitzAuf && indexDach < indexSpitzZu && indexDollar>indexSpitzAuf && indexDollar > indexSpitzZu) {
                                indexSpitzAuf = -1;
                                indexSpitzZu = -1;
                            }
                        }

                        int indexelse = line.IndexOf("else");

                        if (indexSpitzAuf >= 0 && indexSpitzZu >= 0 && indexSpitzZu < indexelse && indexSpitzAuf > indexelse) {
                            line = line.Replace('\t', ' ');
                            tab--;  // nur wenn nicht in einer Zeile
                            output.AppendLine(getTabs(tab) + line.Trim());
                            if (tab == 0) output.AppendLine("");
                            tab++;
                        }
                        else {

                            if (indexSpitzZu >= 0) {
                                tab--;  // nur wenn nicht in einer Zeile
                                output.AppendLine(getTabs(tab) + line.Trim());
                                if (tab == 0) output.AppendLine("");
                            }
                            else {
                                if (indexSpitzAuf >= 0) {
                                    // tab++;
                                    line = line.Replace('\t', ' ');
                                    output.AppendLine(getTabs(tab) + line.Trim());
                                    tab++;
                                }
                                else {
                                    line = line.Replace('\t', ' ');
                                    output.AppendLine(getTabs(tab) + line.Trim());
                                    // tab--;
                                }
                            }
                        }
                        //output.AppendLine(line);
                        continue;
                    }
                }
                else {
                    i1 = line.IndexOf(php1);
                    if (i1 >= 0 && i1<5) {   // vorher if (i1 >= 0) { Grund: <input type="text" name="pindex" value="<?php echo $customer->pindex; ?>"  />
                        php = true;
                        tab = 1;
                        line = line.Replace('\t', ' ').Trim();
                        output.AppendLine(line);
                        continue;
                    }
                }



                if (jsp) {
                    i1 = line.IndexOf(jsp2);
                    if (i1 >= 0) {
                        jsp = false;
                        tab--;  // nur wenn nicht in einer Zeile
                        output.AppendLine(getTabs(tab) + line.Trim());
                        if (tab == 0) output.AppendLine("");
                        continue;
                    }
                    else {
                        String str = output.ToString();
                        bool anzSpitzAuf = line.EndsWith("{");
                        bool anzSpitzZu = line.StartsWith("}");
                        if (anzSpitzZu) {
                            tab--;  // nur wenn nicht in einer Zeile
                            output.AppendLine(getTabs(tab) + line.Trim());
                            if (tab == 0) output.AppendLine("");
                        }
                        else {
                            if (anzSpitzAuf) {
                                // tab++;
                                line = line.Replace('\t', ' ');
                                output.AppendLine(getTabs(tab) + line.Trim());
                                i1 = line.IndexOf(javascript2);
                                tab++;
                            }
                            else {
                                line = line.Replace('\t', ' ');
                                output.AppendLine(getTabs(tab) + line.Trim());
                            }
                        }
                        continue;
                    }
                }
                else {  // noch kein Javascript
                    i1 = line.IndexOf(jsp1);
                    if (i1 >= 0) {
                        jsp = true;
                        line = line.Replace('\t', ' ').Trim();
                        output.AppendLine(getTabs(tab) + line.Trim());
                        tab++;
                        i1 = line.IndexOf(jsp2);
                        if (i1 > 0) {
                            // in einer Zeile:  Anfang und ende
                            jsp = false;
                            tab--;
                        }
                        continue;
                    }
                }  // jsp



                i1 = line.IndexOf("<?xml");  // <?xml version="1.0" encoding="UTF-8" ?>
                i2 = line.ToLower().IndexOf("<!doc");  // <!DOCTYPE html



                if (i1 >= 0 || i2 >= 0) {
                    line = line.Replace('\t', ' ');
                    output.AppendLine(line.Trim());
                    if (i2 >= 0) doctype = true;
                }
                else {
                    // check <html>  doctype=true  html=false
                    if (doctype && !html) {
                        i1 = line.ToLower().IndexOf("<html");
                        if (i1 >= 0) {
                            html = true;
                            line = line.Replace('\t', ' ');
                            output.AppendLine(line.Trim());
                            tab = 1;
                        }
                        else {
                            line = line.Replace('\t', ' ');
                            output.AppendLine(getTabs(tab + 1) + line.Trim());
                            // output.AppendLine("  "+line.Trim());
                        }
                    }
                    else {
                        i1 = line.ToLower().IndexOf("<body");
                        if (i1 >= 0) {
                            line = line.Replace('\t', ' ');
                            output.AppendLine(line.Trim());
                            tab = 1;
                        }
                        else {
                            i1 = line.ToLower().IndexOf("</body>");
                            if (i1 >= 0) {
                                tab--;
                                line = line.Replace('\t', ' ');
                                output.AppendLine(line.Trim());
                                continue;
                            }
                            else {
                                i1 = line.ToLower().IndexOf("</html>");
                                if (i1 >= 0) {
                                    tab--;
                                    line = line.Replace('\t', ' ');
                                    output.AppendLine(line.Trim());
                                    continue;
                                }
                                else {
                                    // bei mehrzeiligen UI-Elementen gibt es am ENde />

                                    // separate </head>
                                    line = line.Replace('\t', ' ').Trim();
                                    // Reihenfolge ist wichtig, ,    </head>      
                                    //     <input type="radio" name="R1" value="CAD1" checked="checked" /> AutoCAD  <br />
                                    // Kommentar
                                    int anzSpitzAuf1 = anzTextProZeile(line, "<!--");
                                    int anzSpitzZu1 = anzTextProZeile(line, "-->");
                                    int diff1 = anzSpitzZu1 - anzSpitzAuf1;
                                    if (anzSpitzZu1 > 0 && anzSpitzAuf1 > 0) {  // in einer Zeile
                                        output.AppendLine(getTabs(tab) + line.Trim());
                                    }
                                    else {
                                        // <legend>Eingabe</legend>
                                        // Problem value="<?php echo $customer->cno; ?>" size="12" />
                                        String lineText = line.Replace("<?php", "!?php").Replace("?>", "!>");
                                        int anzSpitzAuf2 = anzZeichenProZeileOhneSlash(lineText, '<');
                                        int anzSpitzZu2a = anzTextProZeile(lineText, "</");
                                        int anzSpitzZu2b = anzTextProZeile(lineText, "/>");  // <br />  <input .. />
                                        if ((anzSpitzAuf2 > 0 && anzSpitzZu2a > 0) || (anzSpitzAuf2 > 0 && anzSpitzZu2b > 0)) {  // in einer Zeile
                                                output.AppendLine(getTabs(tab) + line.Trim());
                                        }
                                        else {
                                            if (anzSpitzZu2b > 0) {  // /> in einer Zeile
                                                output.AppendLine(getTabs(tab) + line.Trim());
                                                tab--;
                                            }
                                            else {   
                                                int anzSpitzAuf3 = anzZeichenProZeileOhneSlash(lineText, '<');
                                                int anzSpitzZu3 = anzTextProZeile(lineText, "</");
                                                if (anzSpitzAuf3 == 0 && anzSpitzZu3 > 0) {  // ende 
                                                    tab--;
                                                    output.AppendLine(getTabs(tab) + line.Trim());
                                                }
                                                else {
                                                    if (anzSpitzAuf2 > 0) {  // < und /> nicht in einer Zeile
                                                        line = line.Replace('\t', ' ');
                                                        output.AppendLine(getTabs(tab) + line.Trim());
                                                        tab++;
                                                        if (i2 > 0) {
                                                            //tab--;  // ????????????
                                                        }
                                                    }
                                                    else {
                                                        line = line.Replace('\t', ' ');
                                                        output.AppendLine(getTabs(tab) + line.Trim());
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }

                            }




                        }  // else
                    }

                }

            }
            modell.EditText = output.ToString();
            modell.Modified = true;
            parseText(output.ToString());

            //suche letzte Position
            int posi = 0;
            // paragraph = (Paragraph)flowdoc.Blocks.ElementAt(i);
            foreach (Paragraph paragraph in flowdoc.Blocks) {
                if (posi == indexparagraphStart) {

                    editor.CaretPosition = paragraph.ContentStart;
                    break;
                }
                posi++;
            }

            // editor.CaretIndex = posTop;
        }  // format



        public void setFocus() {
            editor.Focus();
        }

        public void checkSpaces() {
            String editortext = EditorText;
            String[] items = { "transform:rotate ", "transform:translateX ", "transform:translateY ", "transform:translate ",
                                  "transform:scaleX ", "transform:scaleY ", "transform:scale ",
                                  "transform:skewX ", "transform:skewY ", "transform:skew ",
                              "linear-gradient ","radial-gradient "};
            foreach (String item in items) {
                if (editortext.IndexOf(item) >= 0) {
                    Random rmd = new Random();
                    if (rmd.NextDouble() < 0.3) {
                        Basis.ErrorMsg("The selector \"" + item.Trim() + "\" must not have one or more spaces\r\n" +
                            "Correct: " + item.Trim() + "(value)\r\n\r\n" +

                          "Filename: " + this.Filename + "\r\n\r\n" +
                        "Please tell everyone in your class, that YOU make an error.", "Error");
                        return;
                    }
                    else {
                        Basis.ErrorMsg("The selector \"" + item.Trim() + "\" must not have one or more spaces\r\n" +
                            "Correct: " + item.Trim() + "(value)\r\n\r\n" +

                          "Filename: " + this.Filename, "Error");
                        return;
                    }
                }
            }
            if (editortext.IndexOf("//") >= 0) {
                Basis.ErrorMsg("The css-file hat a wrong comment '//',\r\nbetter use /* ... */\r\n\r\n" +
                  "Filename: " + this.Filename, "Error");
                return;
            }
            // Attribute sind okay
            if ((editortext.IndexOf("=") >= 0) && (editortext.IndexOf("type=") < 0)) {
                // input[type=text] {
                Basis.ErrorMsg("The css-file hat a wrong char '=,\r\nbetter use ':'\r\n\r\n" +
              "Filename: " + this.Filename, "Error");
                return;
            }
        }  // checkSpace

        private int anzZeichenProZeile(String line, char ch) {
            int summe = 0;
            for (int i = 0; i < line.Length; i++) {
                if (line[i].CompareTo(ch) == 0) {
                    summe++;
                }
            }
            return summe;
        }

        private int anzZeichenProZeileOhneSlash(String line, char ch) {
            int summe = 0;
            int n = line.Length;
            for (int i = 0; i < n; i++) {
                if (line[i].CompareTo(ch) == 0) {
                    // check  <in    oder </
                    if (i < n - 1) {
                        if (line[i + 1].CompareTo('/') != 0) {
                            summe++;
                        }
                    }  // if
                }  // if
            }  // for
            return summe;
        }

        //<input type="radio" name="R1" value="CAD1" checked="checked" /> AutoCAD  <br />
        private int anzTextProZeile(String line, String search) {
            int summe = 0;
            String searchLine = line;
            int i = searchLine.IndexOf(search);
            while (i >= 0) {
                summe++;
                if (i + 2 < searchLine.Length) {
                    searchLine = searchLine.Substring(i + 2);
                    i = searchLine.IndexOf(search);
                }
                else {
                    break;
                }
            }
            return summe;
        }

        public bool compile() {
            String[] lines = Basis.getLines(EditorText);
            int i1 = -1;
            int i2 = -1;
            for (int i = 0; i < lines.Length; i++) {
                String line = lines[i];
                if (line.ToLower().IndexOf("<script type=\"text/javascript\">") >= 0) {
                    i1 = i;
                }
                if (line.ToLower().IndexOf("<script>") >= 0) {
                    i1 = i;
                }
                if (line.ToLower().IndexOf("</script>") >= 0) {
                    i2 = i;
                }
            }
            int anzKlammernAuf = 0;
            int anzKlammernZu = 0;
            int j;
            // suche den Javascript-Abschnitt nach Klammern {   }
            if ((i1 != -1) && (i2 != -1)) {
                for (int i = i1; i <= i2; i++) {
                    String line = lines[i];
                    j = line.IndexOf("//");
                    if (j >= 0) {
                        if (j == 0)
                            line = "";
                        else
                            line = line.Substring(0, j);
                    }
                    anzKlammernAuf += anzZeichenProZeile(line, '{');
                    anzKlammernZu += anzZeichenProZeile(line, '}');

                    if (anzKlammernZu > anzKlammernAuf) {
                        Basis.ErrorMsg("Fehlerhafte Klammerung in Zeile " + (i + 1) + " \r\n" + lines[i], "Fehler");
                        return false;
                    }
                }
                if (anzKlammernAuf != anzKlammernZu) {
                    Basis.ErrorMsg("Fehlerhafte Klammerung im Java-Script-Abschnitt", "Fehler");
                    return false;
                }
            }

            return true;
        }


        TextPointer FindFirstRunInTextContainer() {
            TextPointer position = this.flowdoc.ContentStart;

            // Traverse content in forward direction until the position is immediately after the opening 
            // tag of a Run element, or the end of content is encountered.
            while (position != null) {
                // Is the current position just after an opening element tag?
                if (position.GetPointerContext(LogicalDirection.Backward) == TextPointerContext.ElementStart) {
                    // If so, is the tag a Run?
                    if (position.Parent is Run)
                        break;
                }

                // Not what we're looking for; on to the next position.
                position = position.GetNextContextPosition(LogicalDirection.Forward);
            }

            // This will be either null if no Run is found, or a position just inside of the first Run element in the
            // specifed text container.  Because position is formed from ContentStart, it will have a logical direction
            // of Backward.
            return position;
        }


        void editor_PreviewKeyUp(object sender, KeyEventArgs e) {
            var alt = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Alt);
            var ctrl = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Control);
            var shift = e.KeyboardDevice.Modifiers.HasFlag(ModifierKeys.Shift);
            var altGr = alt & ctrl;
            // es exist a command to insert a winword liste (numeric), the shortkey is Strg+shift+n
            // then it insert a list-element and the undo function crashed
            // now it is disabled
            if (ctrl && shift) {
                switch (e.Key) {
                    case Key.N:
                        e.Handled = true;
                        return;
                }
            }

            if (Keyboard.IsKeyDown(Key.Return) && Keyboard.Modifiers == ModifierKeys.None) {
                //setUndo();
            }
            if (Keyboard.IsKeyDown(Key.Tab) && Keyboard.Modifiers == ModifierKeys.None) {
                e.Handled = true;
                 
                String cliptext = Clipboard.GetText();
                //Clipboard.SetText(Konst.C_TAB);
                Clipboard.SetDataObject(Konst.C_TAB); // Hornemann

                editor.Copy();
                editor.Paste();
                //Clipboard.SetText(cliptext);
                Clipboard.SetDataObject(cliptext); // Hornemann

                TextPointer tp1 = editor.CaretPosition;
                TextPointer tp2 = FindFirstRunInTextContainer();

                //int caretPosition = editor.CaretIndex;
                //int caretPosition = 
                // https://docs.microsoft.com/en-us/dotnet/api/system.windows.documents.textpointer?redirectedfrom=MSDN&view=netframework-4.8

                //int index_aktLine;
                //int lineindex = (editor.GetLineIndexFromCharacterIndex(editor.CaretIndex) + 1);
                //if (lineindex <= 0) {
                //    index_aktLine = 0;
                //}
                //else {
                //    index_aktLine = editor.GetCharacterIndexFromLineIndex(lineindex - 1);
                //}

                //editor.Text = editor.Text.Insert(caretPosition, Konst.C_TAB);
                //editor.CaretIndex = caretPosition + 1; //  tabWidth;

                Modified = true;
                modifiedUndo = true;
            }

            //if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.LeftAlt))) {   
            if (altGr) {
                if (Keyboard.IsKeyDown(Key.Z)) {
                    e.Handled = true;
                }
                return;
            }  // 
            if (e.KeyboardDevice.IsKeyDown(Key.LeftAlt)) {
                e.Handled = false;
            }    
            else {
                if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl))) {
                    switch (e.Key) {
                        case Key.NumPad2:
                        case Key.D2:
                            e.Handled = true;
                            //Editor2NotepadExecuted(null, null);
                            saveFile();
                            Process Prog = new Process();
                            Prog.StartInfo.FileName = "Notepad.exe";
                            Prog.StartInfo.Arguments = getModell().Filename;
                            Prog.Start();
                            break;
                        case Key.OemOpenBrackets:
                            e.Handled = true;
                            break;
                        case Key.A:
                            e.Handled = true;
                            SelectAll();
                            break;
                        case Key.V:
                            e.Handled = true;  // Strg+V
                            Paste();
                            break;
                        case Key.C:
                            e.Handled = true;  // Strg+V
                            //Copy();
                            break;
                        case Key.X:
                            e.Handled = true;  // Strg+V
                            Cut();
                            break;
                        case Key.Y:
                            e.Handled = true;  // Redo
                            redoClick();
                            break;
                        case Key.Z:
                            e.Handled = true;  // Undo
                            undoClick();
                            break;
                    }
                }
            }

            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl)) && e.Key == Key.Space) {
                e.Handled = true;
                // https://stackoverflow.com/questions/3934422/wpf-richtextbox-get-whole-word-at-current-caret-position
                TextPointer currentPosition = editor.CaretPosition;

                TextPointer tp1 = currentPosition.GetLineStartPosition(5);

                //Run runStart = currentPosition.r
                TextPointer tp0 = currentPosition.Paragraph.ContentStart;


                string text111 = currentPosition.GetTextInRun(LogicalDirection.Backward);
                // TextPointer end = currentPosition.GetNextContextPosition(LogicalDirection.Backward);
                // TextPointer end3 = end.GetNextContextPosition(LogicalDirection.Backward);
                // string text3 = end3.GetTextInRun(LogicalDirection.Backward);

                // //string text2 = end.GetTextInRun(LogicalDirection.Backward);

                //// int offset = end.GetOffsetToPosition(end);

                //  = null;
                int i = 0;
                Paragraph paragraphStart = currentPosition.Paragraph;
                foreach (Paragraph paragraph in flowdoc.Blocks) {
                    if (paragraph == paragraphStart) {
                        break;
                    }
                    i++;
                }

                //TextPointer start = end.Paragraph.PreviousBlock;

                String text1 = currentPosition.GetTextInRun(LogicalDirection.Backward);
                String query = text1.Replace(Konst.C_TAB, "");

                if (query.Length > 0) {
                    bool found = false;
                    List<TextBlockIntellisense> texte = new List<TextBlockIntellisense>();

                    if (query.Equals("$")) {
                        String editortext = modell.EditText;
                        String[] deleteItems = { "<", ">", "[", "]", "(", ")", "{", "}", ";", ".", ",", "\"", "'", "+", "-", "*", "/", "=", "\r\n", ":" };
                        foreach (String item in deleteItems) {
                            editortext = editortext.Replace(item, " ");
                        }
                        string[] splitStrings = { " " };
                        string[] bloecke = editortext.Split(splitStrings, StringSplitOptions.None);
                        foreach (String item in bloecke) {
                            String item2 = item.Trim();
                            if (item2.Length > 0) {
                                if (item2.StartsWith("$")) {
                                    texte.Add(createItem(new Intellisense(item2, item2, item2)));
                                    found = true;
                                }
                            }
                        }
                    }
                    else {
                        // Title = query;
                        //var border = (resultStack.Parent as ScrollViewer).Parent as Border;
                        var intellisenseList = IntellisenseManagement.dataHTML;

                        // Clear the list   
                        //resultStack.Children.Clear();
                        listbox.Items.Clear();

                        // Add the result   

                        foreach (Intellisense testitem in intellisenseList) {
                            if (testitem.key.ToLower().StartsWith(query.ToLower())) {
                                texte.Add(createItem(testitem));
                                found = true;
                            }
                        }
                    }


                    if (found) {
                        Hashtable hashIntellisenseSet = new Hashtable();  // using System.Collections;
                        foreach (TextBlockIntellisense block in texte) {
                            hashIntellisenseSet[block.intellisense.showtext] = block;
                        }
                        ICollection coll = hashIntellisenseSet.Keys;
                        texte.Clear();
                        foreach (Object obj in coll) {
                            String key = (String)obj;
                            TextBlockIntellisense block = (TextBlockIntellisense)hashIntellisenseSet[key];
                            texte.Add(block);
                        }
                        texte.Sort();

                        // das PopupFenster braucht den Editor und die Position
                        // siehe unten "setSelectItem"
                        foreach (TextBlockIntellisense block in texte) {
                            block.Tag = editor;
                            //resultStack.Children.Add(block);
                            listbox.Items.Add(block);
                        }
                        // editor.GetCaretPos(out point);
                        // PlacementTarget="{Binding ElementName=myWindow}" Placement="Relative"
                        // VerticalOffset = "30" HorizontalOffset = "100"

                        // listbox.Focus();
                        if (texte.Count > 6) {
                            popup.Height = 300;
                        }
                        else {
                            popup.Height = 175;
                        }
                        popup.PlacementTarget = editor;
                        popup.Placement = PlacementMode.Mouse;
                        //popup.PlacementRectangle
                        popup.HorizontalOffset = 10;
                        popup.VerticalOffset = 10;
                        popup.IsOpen = true;
                        listbox.Focus();
                    }
                    else {

                    }
                }  // if charIndex>0
            }  // Strg+space
            if (Keyboard.IsKeyDown(Key.Z))  {
                //e.Handled = true;
            }
           


        }  // keydown



        private void listbox_keydown(Object sender, KeyEventArgs e) {
            if (listbox.SelectedIndex >= 0 && e.Key == Key.Return) {
                setSelectItem();
            }
            else if (e.Key == Key.Escape) {
                popup.IsOpen = false;
            }
        }  // listbox_keydown

        private void setSelectItem() {
            if (listbox.SelectedIndex >= 0) {
                TextBlockIntellisense block = (TextBlockIntellisense)listbox.SelectedItem;
                Intellisense intellisense = block.intellisense;

                // löschen des Textes in RUN
                //Object[] tags = (Object[])block.Tag;  // { editor };
                //TextBox editor2 = (TextBox)tags;
                //int iStart2 = (int)tags[1];
                //int n2 = (int)tags[2];
                //editor2.Text = editor2.Text.Remove(iStart2, n2);
                //editor2.Text = editor2.Text.Insert(iStart2, block.intellisense.value);
                popup.IsOpen = false;

                TextPointer start = editor.CaretPosition;
                TextPointer end = start.GetNextContextPosition(LogicalDirection.Backward);
                editor.Selection.Select(start, end);

                Clipboard.SetText(block.intellisense.value);
                editor.Paste();

                Modified = true;

                //if (block.intellisense.offset > 0)
                //    editor.CaretIndex = iStart2 + block.intellisense.offset;
                //else
                //    editor.CaretIndex = iStart2 + block.Text.Length;
                editor.Focus();
            }
        }

        private void listbox_MouseDoubleClick(Object sender, MouseButtonEventArgs e) {
            setSelectItem();
        }


        private TextBlockIntellisense createItem(Intellisense intellisense) {
            TextBlockIntellisense block = new TextBlockIntellisense();

            // Add the text   
            block.Text = intellisense.showtext;   // key  showtext
            block.intellisense = intellisense;

            // A little style...   
            block.Margin = new Thickness(2, 3, 2, 3);
            block.Cursor = Cursors.Hand;

            return block;
        }  // createItem

        private void listbox_keyup(Object sender, KeyEventArgs e) {
            if (listbox.SelectedIndex >= 0 && e.Key == Key.Return) {
                setSelectItem();
            }
            else if (e.Key == Key.Escape) {
                popup.IsOpen = false;
            }
        }



        void mn_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)e.Source;
            String mnName = mn.Name.ToString();

            e.Handled = true;  // end of the Routings, else  three times !!

            #region menu definition  

            // if (mnName == "mainHTML")	HTML_Middleware.
            //if (mnName == "mainInsertHTMLBasic")	HTML_Middleware.
            if (mnName == "mnInsertHTML_Basic_XHTML_strict11") {
                Middleware.InsertHTML_Basic_XHTML_strict11(this);
                return;
            }
            if (mnName == "mnInsertHTML_HTML5_strict11") { Middleware.InsertHTML_HTML5_strict11(this); return; }
            if (mnName == "mnInsertHTML_Basic_XHTML") { Middleware.InsertHTML_Basic_XHTML(this); return; }
            if (mnName == "mnInsertHTML_HTML4") { Middleware.InsertHTML_HTML4(this); return; }
            if (mnName == "mnInsertHTML_Basic_Pur") { Middleware.InsertHTML_Basic_Pur(this); return; }
            if (mnName == "mnInsertHTML_Header1_6") { Middleware.InsertHTML_Header1_6(this); return; }
            if (mnName == "mnInsertHTML_Paragraph") { Middleware.InsertHTML_Paragraph(this); return; }

            // Bietz
            if (mnName == "mnInsertHTML_CSSLink") { Middleware.InsertHTML_CSSLink(this); return; }

            //if (mnName == "mainHTML_ListeSub")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_UL") { Middleware.InsertHTML_UL(this); return; }
            if (mnName == "mnInsertHTML_OL") { Middleware.InsertHTML_OL(this); return; }
            //if (mnName == "mainHTML_TableSub")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_Table") { Middleware.InsertHTML_Table(this); return; }
            if (mnName == "mnInsertHTML_TR") { Middleware.InsertHTML_TR(this); return; }
            if (mnName == "mnInsertHTML_HR") { Middleware.InsertHTML_HR(this); return; }
            if (mnName == "mnInsertHTML_FontColor") { Middleware.InsertCSS_FontColor(this); return; }
            if (mnName == "mnInsertHTML_CSS_ColorConstant") { Middleware.InsertCSS_ColorConstant(this); return; }  // CSS + HTML
            if (mnName == "mnInsertHTML_Comment") { Middleware.InsertHTML_Comment(this); return; }
            //if (mnName == "mainLinks")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_EMailLink") { Middleware.InsertHTML_EMailLink(this); return; }
            if (mnName == "mnInsertHTML_Link") { Middleware.InsertHTML_Link(this); return; }
            if (mnName == "mnInsertHTML_Anchor") { Middleware.InsertHTML_Anchor(this); return; }
            //if (mnName == "mainImages")	{ HTML_Middleware.
            if (mnName == "mnInsertImages") {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.DefaultExt = ".XHTML";
                openFileDialog.InitialDirectory = SingVar.LastPath;
                openFileDialog.Filter = "PNG-Files (*.png)|*.png|" +
                                          "JPG-Files (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
                                         "BMP-Files (*.bmp)|*.bmp|" +
                                          "GIF-Files (*.gif)|*.gif|" +
                                          "All files (*.*)|*.*";

                openFileDialog.Multiselect = true;
                openFileDialog.Title = "Open image file";

                if (openFileDialog.ShowDialog(null) == true) {
                    // openFileDialog.FileName
                    if (Basis.readYesNo("Would you want, to insert optionals coords as link?", "Area Shapes"))
                        Middleware.InsertHTML_InsertImage(this, openFileDialog.FileName, true);
                    else
                        Middleware.InsertHTML_InsertImage(this, openFileDialog.FileName, false);
                }
            }

            if (mnName == "mnInsertImageCoords") { Middleware.InsertImageCoords(this); return; }
            if (mnName == "mnImagesCoordsausSHWFile") { Middleware.InsertImageCoordsFromSHWFile(this); return; }
            //if (mnName == "mainFonts")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_Font_Bold") { Middleware.InsertHTML_Font_Bold(this); return; }
            if (mnName == "mnInsertHTML_Font_Italic") { Middleware.InsertHTML_Font_Italic(this); return; }
            if (mnName == "mnInsertHTML_Font_Sup") { Middleware.InsertHTML_Font_Sup(this); return; }
            if (mnName == "mnInsertHTML_Font_Sub") { Middleware.InsertHTML_Font_Sub(this); return; }
            //if (mnName == "mainFont_SpezialChars")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_Font_Char_Space") { Middleware.InsertHTML_Font_Char(this, "&#x0020;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Tab") { Middleware.InsertHTML_Font_Char(this, "&#x0009;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_CR") { Middleware.InsertHTML_Font_Char(this, "&#x000D;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_LF") { Middleware.InsertHTML_Font_Char(this, "&#x000A;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Blank") { Middleware.InsertHTML_Font_Char(this, "&#160;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Dash") { Middleware.InsertHTML_Font_Char(this, "&#173;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Copyright") { Middleware.InsertHTML_Font_Char(this, "&#169;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Copyright_R") { Middleware.InsertHTML_Font_Char(this, "&#174;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Trademark") { Middleware.InsertHTML_Font_Char(this, "&#x8482;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_LT") { Middleware.InsertHTML_Font_Char(this, "&#60;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_GT") { Middleware.InsertHTML_Font_Char(this, "&#62;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_LTLT") { Middleware.InsertHTML_Font_Char(this, "&#171;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_GTGT") { Middleware.InsertHTML_Font_Char(this, "&#187;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Ampersand") { Middleware.InsertHTML_Font_Char(this, "&#38;"); return; }

            // https://wiki.selfhtml.org/wiki/Referenz:HTML/Zeichenreferenz
            if (mnName == "mnInsertHTML_Font_Char_Ae") { Middleware.InsertHTML_Font_Char(this, "&#196;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Oe") { Middleware.InsertHTML_Font_Char(this, "&#214;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_Ue") { Middleware.InsertHTML_Font_Char(this, "&#220;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_ae") { Middleware.InsertHTML_Font_Char(this, "&#228;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_oe") { Middleware.InsertHTML_Font_Char(this, "&#246;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_ue") { Middleware.InsertHTML_Font_Char(this, "&#252;"); return; }
            if (mnName == "mnInsertHTML_Font_Char_ss") { Middleware.InsertHTML_Font_Char(this, "&#223;"); return; }


            if (mnName == "mnInsertHTML_Font_doublequotationmarkfirst") { Middleware.InsertHTML_Font_Char(this, "&#x201C;"); return; }
            if (mnName == "mnInsertHTML_Font_doublequotationmarkend") { Middleware.InsertHTML_Font_Char(this, "&#x201D;"); return; }

            if (mnName == "mnInsertHTML_Font_singlequotationmarkfirst") { Middleware.InsertHTML_Font_Char(this, "&#x2018;"); return; }
            if (mnName == "mnInsertHTML_Font_singlequotationmarkend") { Middleware.InsertHTML_Font_Char(this, "&#x2019;"); return; }

            if (mnName == "mnInsertHTML_Font_anglequotationmarkfirst") { Middleware.InsertHTML_Font_Char(this, "&#xAB;"); return; }
            if (mnName == "mnInsertHTML_Font_anglequotationmarkend") { Middleware.InsertHTML_Font_Char(this, "&#xBB;"); return; }

            //if (mnName == "mainCSS")	{ HTML_Middleware.
            if (mnName == "mnInsertHTML_CSSReferenzExtern") { Middleware.InsertHTML_CSSReferenzExtern(this); return; }
            if (mnName == "mnInsertHTML_CSSReferenzLocal") { Middleware.InsertHTML_CSSReferenzLocal(this); return; }

            //if (mnName == "mnInsertCSS_Body")	{ HTML_Middleware.
            //if (mnName == "mnInsertCSS_xx")	{ HTML_Middleware.
            ////if (mnName == "mainCSSBsp")	{ HTML_Middleware.
            //if (mnName == "mnInsert_CSSBlock_H2")	{ HTML_Middleware.
            //if (mnName == "mnInsert_CSSBlock_OL")	{ HTML_Middleware.
            //if (mnName == "mnInsert_CSSBlock_UL")	{ HTML_Middleware.
            //if (mnName == "mnInsert_CSSBlock_TH")	{ HTML_Middleware.
            //if (mnName == "mnInsert_CSSBlock_TD")	{ HTML_Middleware.
            //if (mnName == "mnInsert_HTMLBlock_Scrolling")	{ HTML_Middleware.

            //if (mnName == "mainForms")	{ HTML_Middleware.
            if (mnName == "mnInsertForm_Formrange1") { Middleware.InsertForm_Formrange1(this); return; }
            if (mnName == "mnInsertForm_Formrange2") { Middleware.InsertForm_Formrange2(this); return; }

            // html
            if (mnName == "mnInsertForm_FieldsetLegend") { Middleware.InsertForm_FieldsetLegend(this); return; }

            if (mnName == "mnInsertForm_Gridlayout1") { Middleware.InsertForm_InsertForm_Gridlayout1(this); return; }
            if (mnName == "mnInsertForm_Flexlayout1") { Middleware.InsertForm_InsertForm_Flexlayout1(this); return; }
            if (mnName == "mnInsertForm_Flexlayout2") { Middleware.InsertForm_InsertForm_Flexlayout2(this); return; }

            if (mnName == "mnInsertForm_Label") { Middleware.InsertForm_Label(this); return; }
            if (mnName == "mnInsertForm_Textfeld") { Middleware.InsertForm_Textfeld1(this); return; }
            if (mnName == "mnInsertForm_Textfeld2") { Middleware.InsertForm_Textfeld2(this); return; }
            if (mnName == "mnInsertForm_TextfeldPattern") { Middleware.InsertForm_TextfeldPattern(this); return; }
            if (mnName == "mnInsertForm_Textarea") { Middleware.InsertForm_Textarea(this); return; }
            if (mnName == "mnInsertForm_Hidden") { Middleware.InsertForm_Hidden(this); return; }
            if (mnName == "mnInsertForm_CheckBox") { Middleware.InsertForm_CheckBox(this); return; }
            if (mnName == "mnInsertForm_MultiCheckBox") { Middleware.InsertForm_MultiCheckBox(this); return; }

            if (mnName == "mnInsertForm_RadioButton") { Middleware.InsertForm_RadioButton(this); return; }
            if (mnName == "mnInsertForm_ComboBox") { Middleware.InsertForm_ComboBox(this); return; }
            if (mnName == "mnInsertForm_Password") { Middleware.InsertForm_Password(this); return; }

            if (mnName == "mnHTML5_Formelements_div_ajax") {Middleware.InsertForm_div_ajax(this); return;    }
            


            if (mnName == "mnForm_Event_onClick") { Middleware.InsertJavaScript_Event_onClick(this); return; }
            if (mnName == "mnForm_Event_onDblclick") { Middleware.InsertJavaScript_onDblclick(this); return; }
            if (mnName == "mnForm_Event_onMouseDown") { Middleware.InsertJavaScript_Event_onMouseDown(this); return; }
            if (mnName == "mnForm_Event_onMouseUp") { Middleware.InsertJavaScript_Event_onMouseUp(this); return; }
            if (mnName == "mnForm_Event_onMouseOver") { Middleware.InsertJavaScript_Event_onMouseOver(this); return; }
            if (mnName == "mnForm_Event_onMouseMove") { Middleware.InsertJavaScript_Event_onMouseMove(this); return; }
            if (mnName == "mnForm_Event_onMouseOut") { Middleware.InsertJavaScript_Event_onMouseOut(this); return; }
            if (mnName == "mnForm_Event_onFocus") { Middleware.InsertJavaScript_Event_onFocus(this); return; }
            if (mnName == "mnForm_Event_onBlur") { Middleware.InsertJavaScript_Event_onBlur(this); return; }
            if (mnName == "mnForm_Event_onKeypress") { Middleware.InsertJavaScript_Event_onKeypress(this); return; }
            if (mnName == "mnForm_Event_onKeydown") { Middleware.InsertJavaScript_Event_onKeydown(this); return; }
            if (mnName == "mnForm_Event_onKeypup") { Middleware.InsertJavaScript_Event_onKeypup(this); return; }
            if (mnName == "mnForm_Event_onSelect") { Middleware.InsertJavaScript_Event_onSelect(this); return; }
            if (mnName == "mnForm_Event_onChange") { Middleware.InsertJavaScript_Event_onChange(this); return; }

            if (mnName == "mnInsertForm_Submit") { Middleware.InsertForm_Submit(this); return; }
            if (mnName == "mnInsertForm_Button") { Middleware.InsertForm_Button(this); return; }
            if (mnName == "mnInsertForm_Reset") { Middleware.InsertForm_Reset(this); return; }

            if (mnName == "mnInsertForm_onSubmitEvent") { Middleware.InsertForm_onSubmitEvent(this); return; }

            if (mnName == "mnInsertForm_SubmitFormAction") { Middleware.InsertForm_SubmitFormAction(this); return; }
            if (mnName == "mnInsertForm_CompletSample") { Middleware.InsertForm_CompletSample(this); return; }
            //if (mnName == "mainJavaScript")	{ HTML_Middleware.
            if (mnName == "mnJavaScript_InsertSector") { Middleware.InsertJavaScript_InsertSector(this); return; }


            if (mnName == "mnJavaScript_IncludeJavascript") {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.DefaultExt = ".js";
                openFileDialog.InitialDirectory = SingVar.LastPath;
                openFileDialog.Filter = "Javascript-Files (*.js)|*.js|" + "All files (*.*)|*.*";
                openFileDialog.Multiselect = false;
                openFileDialog.Title = "Open javascript file";
                if (openFileDialog.ShowDialog(null) == true) {
                    Middleware.JavaScript_IncludeJavascript(this, Basis.getFilename(openFileDialog.FileName));
                }
                return;
            }




            if (mnName == "mnJavaScript_Function") { Middleware.InsertJavaScript_Function(this); return; }

            if (mnName == "mnJavaScript_FormArray") { Middleware.JavaScript_FormArray(this); return; }

            if (mnName == "mnJavaScript_FormValidation") { Middleware.JavaScript_FormValidation(this); return; }

            

            if (mnName == "mnJavaScript_validation") {
                Middleware.JavaScript_JavaScript_validation(this); return;
            }
       


            if (mnName == "mnJavaScript_Consolelog") { Middleware.InsertJavaScript_Consolelog(this); return; }


            // mn2 = createMenuItem(mn1, "mainJavaScript_AccessUI", "Access to form-elements in java-script");
            if (mnName == "mnJavaScript_Access_form0") { Middleware.mnJavaScript_Insert(this, "  let f=document.forms[0];"); return; }
            if (mnName == "mnJavaScript_Access_formName") { Middleware.mnJavaScript_Insert(this, "  let f=form.theName1;"); return; }
            if (mnName == "mnJavaScript_Access_textValue") { Middleware.mnJavaScript_Insert(this, "  let s = form.myTextbox.value;"); return; }
            if (mnName == "mnJavaScript_Access_checkbox") { Middleware.mnJavaScript_Insert(this, "   if (form.myChk.checked ) {\r\n}"); return; }
            if (mnName == "mnJavaScript_Access_multicheckbox") { Middleware.mnJavaScript_Accessmulticheckbox(this); return; }
            if (mnName == "mnJavaScript_Access_radiobutton") { Middleware.mnJavaScript_AccessRadiobutton(this); return; }
            if (mnName == "mnJavaScript_Access_comboboxSingle") {
                Middleware.mnJavaScript_Insert(this, "  index = form.myCombobox.selectedIndex;  // form.myCombobox.options[i].value"); return;
            }
            if (mnName == "mnJavaScript_Access_comboboxMultiple") {
                Middleware.JavaScript_Access_comboboxMultiple(this); return;
            }



            //jQuery
            if (mnName == "mnJavaScript_jQuery_link") { Middleware.InsertJavaScript_JQUery_link(this); return; }
            if (mnName == "mnJavaScript_jQuery_ajax") { Middleware.InsertJavaScript_JQUery_ajax(this); return; }


            //if (mnName == "mainJavaScript_Event")	{ HTML_Middleware.
            if (mnName == "mnJavaScript_Event_onload") { Middleware.InsertJavaScript_Event_onload(this); return; }
            if (mnName == "mnJavaScript_Event_onUnload") { Middleware.InsertJavaScript_Event_onUnload(this); return; }

            if (mnName == "mnJavaScript_Event_onClick") { Middleware.InsertJavaScript_Event_onClick(this); return; }
            if (mnName == "mnJavaScript_Event_onDblclick") { Middleware.InsertJavaScript_onDblclick(this); return; }


            if (mnName == "mnJavaScript_ajax_getElementById") { Middleware.InsertJavaScript_ajax_getElementById(this); return; }
            if (mnName == "mnJavaScript_ajax_getElementsByClassName") { Middleware.InsertJavaScript_ajax_getElementsByClassName(this); return; }
            if (mnName == "mnJavaScript_ajax_getElementsByName") { Middleware.InsertJavaScript_ajax_getElementsByName(this); return; }
            if (mnName == "mnJavaScript_ajax_getElementsByTagName") { Middleware.InsertJavaScript_ajax_getElementsByTagName(this); return; }

            if (mnName == "mnJavaScript_ajax_innerhtml") { Middleware.InsertJavaScript_ajax_innerhtml(this); return; }

            if (mnName == "mnJavaScript_Display_None") { Middleware.InsertJavaScript_Display_None(this); return; }
            if (mnName == "mnJavaScript_Display_Inline") { Middleware.InsertJavaScript_Display_Inline(this); return; }
            if (mnName == "mnJavaScript_Display_Block") { Middleware.InsertJavaScript_Display_Block(this); return; }

            if (mnName == "mnJavaScript_jsonforloop") { Middleware.InsertJavaScript_jsonforloop(this); return; }


            if (mnName == "mnJavaScript_ajaxStructur") { Middleware.InsertJavaScript_ajaxStructur((Window)mainParent, this); return; }



            //if (mnName == "mainJavaScript_IfWhile")	{ HTML_Middleware.
            if (mnName == "mnJavaScript_If") { Middleware.InsertJavaScript_If(this); return; }
            if (mnName == "mnJavaScript_If_Else") { Middleware.InsertJavaScript_If_Else(this); return; }
            if (mnName == "mnJavaScript_Dowhile") { Middleware.InsertJavaScript_Dowhile(this); return; }
            if (mnName == "mnJavaScript_While") { Middleware.InsertJavaScript_While(this); return; }

            if (mnName == "mnJavaScript_For_i") { Middleware.InsertJavaScript_For_i(this); return; }

            if (mnName == "mnJavaScript_Foreach") { Middleware.InsertJavaScript_Foreach(this); return; }
            if (mnName == "mnJavaScript_ForeachOf") { Middleware.InsertJavaScript_ForeachOf(this); return; }


            if (mnName == "mnJavaScript_Switch") { Middleware.InsertJavaScript_Switch(this); return; }
            //if (mnName == "mainJavaScript_Numeric")	{ HTML_Middleware.
            if (mnName == "mnJavaScript_ParseInt") { Middleware.InsertJavaScript_ParseInt(this); return; }
            if (mnName == "mnJavaScript_ParseFloat") { Middleware.InsertJavaScript_ParseFloat(this); return; }
            if (mnName == "mnJavaScript_isNaN") { Middleware.InsertJavaScript_isNaN(this); return; }

            if (mnName == "mnJavaScript_toExponential") { Middleware.mnJavaScript_toExponential(this); return; }
            if (mnName == "mnJavaScript_toPrecision") { Middleware.mnJavaScript_toPrecision(this); return; }
            if (mnName == "mnJavaScript_toFixed") { Middleware.InsertJavaScript_toFixed(this); return; }
            if (mnName == "mnJavaScript_toString") { Middleware.mnJavaScript_toString(this); return; }
            if (mnName == "mnJavaScript_komma2Point") { Middleware.InsertJavaScript_komma2Point(this); return; }


            if (mnName == "mnJavaScript_E") { Middleware.mnJavaScript_Insert(this, "Math.E"); return; }
            if (mnName == "mnJavaScript_LN2") { Middleware.mnJavaScript_Insert(this, "Math.LN2"); return; }
            if (mnName == "mnJavaScript_Ln10") { Middleware.mnJavaScript_Insert(this, "Math.LN10"); return; }
            if (mnName == "mnJavaScript_Ln2e") { Middleware.mnJavaScript_Insert(this, "Math.LOG2E"); return; }
            if (mnName == "mnJavaScript_Log10E") { Middleware.mnJavaScript_Insert(this, "Math.LOG10E"); return; }
            if (mnName == "mnJavaScript_Pi") { Middleware.mnJavaScript_Insert(this, "Math.PI"); return; }
            if (mnName == "mnJavaScript_Sqrt1_2") { Middleware.mnJavaScript_Insert(this, "Math.SQRT1_2"); return; }
            if (mnName == "mnJavaScript_Sqrt2") { Middleware.mnJavaScript_Insert(this, "Math.SQRT2"); return; }


            if (mnName == "mnJavaScript_Abs") { Middleware.mnJavaScript_Insert(this, "Math.abs(-3)"); return; }
            if (mnName == "mnJavaScript_Acos") { Middleware.mnJavaScript_Insert(this, "Math.acos(0.5) // radient"); return; }
            if (mnName == "mnJavaScript_Asin") { Middleware.mnJavaScript_Insert(this, "Math.asin(0.5) // radient"); return; }
            if (mnName == "mnJavaScript_Atan") { Middleware.mnJavaScript_Insert(this, "Math.atan(2) // radient"); return; }
            if (mnName == "mnJavaScript_Atan2") { Middleware.mnJavaScript_Insert(this, "Math.atan2(8,4) // radient"); return; }
            if (mnName == "mnJavaScript_Ceil") { Middleware.mnJavaScript_Insert(this, "Math.ceil(1.4); // result 2"); return; }
            if (mnName == "mnJavaScript_Cos") { Middleware.mnJavaScript_Insert(this, "Math.cos(3) // radient"); return; }

            if (mnName == "mnJavaScript_Exp") { Middleware.mnJavaScript_Insert(this, "Math.exp(1)"); return; }
            if (mnName == "mnJavaScript_Floor") { Middleware.mnJavaScript_Insert(this, "Math.floor(1.6); // result 1"); return; }
            if (mnName == "mnJavaScript_Log") { Middleware.mnJavaScript_Insert(this, "Math.log(2)  // =ln(2)"); return; }
            if (mnName == "mnJavaScript_Max") { Middleware.mnJavaScript_Insert(this, "Math.max(3,6,2)"); return; }
            if (mnName == "mnJavaScript_Min") { Middleware.mnJavaScript_Insert(this, "Math.min(3,6,2)"); return; }
            if (mnName == "mnJavaScript_Pow") { Middleware.mnJavaScript_Insert(this, "Math.pow(2,4); // result 16"); return; }
            if (mnName == "mnJavaScript_Random1") { Middleware.mnJavaScript_Insert(this, "=Math.random(); // result 0>=x<1"); return; }
            if (mnName == "mnJavaScript_Random2") { Middleware.mnJavaScript_Insert(this, "=Math.floor( random()*10 );"); return; }
            if (mnName == "mnJavaScript_Round") { Middleware.mnJavaScript_Insert(this, "Math.round(2.5); // result = 3"); return; }
            if (mnName == "mnJavaScript_Sqrt") { Middleware.mnJavaScript_Insert(this, "Math.sqrt(2);"); return; }
            if (mnName == "mnJavaScript_Tan") { Middleware.mnJavaScript_Insert(this, "Math.tan(0.785);  // radient"); return; }

            if (mnName == "mnJavaScript_Show_Popupwindow") { Middleware.InsertJavaScript_Popupwindow(this); return; }

            if (mnName == "mnJavaScript_Location") { Middleware.InsertJavaScript_WindowLocation(this); return; }


            if (mnName == "mnJavaScript_charAt") { Middleware.mnJavaScript_charAt(this); return; }
            if (mnName == "mnJavaScript_charCodeAt") { Middleware.mnJavaScript_charCodeAt(this); return; }
            if (mnName == "mnJavaScript_concat") { Middleware.mnJavaScript_concat(this); return; }
            if (mnName == "mnJavaScript_length") { Middleware.mnJavaScript_length(this); return; }
            if (mnName == "mnJavaScript_fromCharCode") { Middleware.mnJavaScript_fromCharCode(this); return; }
            if (mnName == "mnJavaScript_indexOf") { Middleware.mnJavaScript_indexOf(this); return; }
            if (mnName == "mnJavaScript_lastIndexOf") { Middleware.mnJavaScript_lastIndexOf(this); return; }
            if (mnName == "mnJavaScript_localeCompare") { Middleware.mnJavaScript_localeCompare(this); return; }
            if (mnName == "mnJavaScript_match") { Middleware.mnJavaScript_match(this); return; }
            if (mnName == "mnJavaScript_replace") { Middleware.mnJavaScript_replace(this); return; }
            if (mnName == "mnJavaScript_replaceAll") { Middleware.mnJavaScript_replaceAll(this); return; }

            if (mnName == "mnJavaScript_search") { Middleware.mnJavaScript_search(this); return; }
            if (mnName == "mnJavaScript_slice") { Middleware.mnJavaScript_slice(this); return; }
            if (mnName == "mnJavaScript_split") { Middleware.mnJavaScript_split(this); return; }
            if (mnName == "mnJavaScript_substr") { Middleware.mnJavaScript_substr(this); return; }
            if (mnName == "mnJavaScript_substring") { Middleware.mnJavaScript_substring(this); return; }
            if (mnName == "mnJavaScript_toLocaleLowerCase") { Middleware.mnJavaScript_toLocaleLowerCase(this); return; }
            if (mnName == "mnJavaScript_toLocaleUpperCase") { Middleware.mnJavaScript_toLocaleUpperCase(this); return; }
            if (mnName == "mnJavaScript_toLowerCase") { Middleware.mnJavaScript_toLowerCase(this); return; }
            if (mnName == "mnJavaScript_toString") { Middleware.mnJavaScript_toString(this); return; }
            if (mnName == "mnJavaScript_toUpperCase") { Middleware.mnJavaScript_toUpperCase(this); return; }
            if (mnName == "mnJavaScript_trim") { Middleware.mnJavaScript_trim(this); return; }
            if (mnName == "mnJavaScript_valueOf") { Middleware.mnJavaScript_valueOf(this); return; }

            //mn2 = createMenuItem(mn1, "mainJavaScript_Arrays", "Arrays");
            if (mnName == "mnJavaScript_Arrays_createArray") { Middleware.JavaScript_Arrays_createArray(this); return; }
            if (mnName == "mnJavaScript_Arrays_createMultidimArray") { Middleware.JavaScript_Arrays_createMultidimArray(this); return; }
            if (mnName == "mnJavaScript_lengthArray") { Middleware.JavaScript_lengthArray(this); return; }
            if (mnName == "mnJavaScript_Arrays_pushArray") { Middleware.JavaScript_Arrays_pushArray(this); return; }
            if (mnName == "mnJavaScript_Arrays_sliceArray") { Middleware.JavaScript_Arrays_sliceArray(this); return; }

            // mn2 = createMenuItem(mn1, "mainJavaScript_Class", "Class");
            if (mnName == "mnJavaScript_Class_createClass") { Middleware.JavaScript_Class_createClass(this); return; }
            if (mnName == "mnJavaScript_Class_StaticAttribut") { Middleware.JavaScript_Class_StaticAttribut(this); return; }
            if (mnName == "mnJavaScript_regex") { Middleware.mnJavaScript_regex(this); return; }


            if (mnName == "mnJavaScript_Concat") { Middleware.mnJavaScript_Insert(this, ".concat(\"abc\");  // joins two or more strings"); return; }
            if (mnName == "mnJavaScript_length") { Middleware.mnJavaScript_length(this); return; }
            if (mnName == "mnJavaScript_IndexOf") { Middleware.mnJavaScript_Insert(this, ".indexOf(\"abc\");  // search a item in the array, -1 not found"); return; }
            if (mnName == "mnJavaScript_Join") { Middleware.mnJavaScript_Insert(this, ".join();  // return all elements in a string"); return; }
            if (mnName == "mnJavaScript_LastIndexOf") { Middleware.mnJavaScript_Insert(this, ".lastIndexOf; // search a item in the array from the end, -1 not found"); return; }
            if (mnName == "mnJavaScript_Pop") { Middleware.mnJavaScript_Insert(this, ".pop();  // remove the last element"); return; }
            if (mnName == "mnJavaScript_Push") { Middleware.mnJavaScript_Insert(this, ".push(\"abc\");  // add a element to the end"); return; }
            if (mnName == "mnJavaScript_Reverse") { Middleware.mnJavaScript_Insert(this, ".reverse();  // radient"); return; }
            if (mnName == "mnJavaScript_Shift") { Middleware.mnJavaScript_Insert(this, ".shift();  // remove the first element"); return; }
            if (mnName == "mnJavaScript_Slice") { Middleware.mnJavaScript_Insert(this, ".slice(1,3);  // return the 1. until 3. elements (0->n-1)"); return; }
            if (mnName == "mnJavaScript_Sort") { Middleware.mnJavaScript_Insert(this, ".sort();"); return; }
            if (mnName == "mnJavaScript_Splice") { Middleware.mnJavaScript_Insert(this, ".splice(2, 0, \"abc\", \"def\");  // add elements params: elements add, elements remove, new items "); return; }
            if (mnName == "mnJavaScript_Unshift") { Middleware.mnJavaScript_Insert(this, "unshift(\"abc\", \"def\");  // add new elements to the begin"); return; }


            // mn3 = createMenuItem(mn2, "mainJavaScript_GetMethods", "get methods");
            if (mnName == "mnJavaScript_GetDate") { Middleware.mnJavaScript_Insert(this, ".getDate()"); return; }
            if (mnName == "mnJavaScript_GetDay") { Middleware.mnJavaScript_Insert(this, ".getDay()  // 0 -> 6"); return; }
            if (mnName == "mnJavaScript_GetFullYear") { Middleware.mnJavaScript_Insert(this, ".getFullYear()"); return; }
            if (mnName == "mnJavaScript_GetHours") { Middleware.mnJavaScript_Insert(this, ".getHours()"); return; }
            if (mnName == "mnJavaScript_GetMilliseconds") { Middleware.mnJavaScript_Insert(this, ".getMilliseconds()"); return; }
            if (mnName == "mnJavaScript_GetMinutes") { Middleware.mnJavaScript_Insert(this, ".getMinutes()"); return; }
            if (mnName == "mnJavaScript_GetSeconds") { Middleware.mnJavaScript_Insert(this, ".getSeconds()"); return; }
            if (mnName == "mnJavaScript_GetTime") { Middleware.mnJavaScript_Insert(this, ".getTime()"); return; }
            if (mnName == "mnJavaScript_GetTimezoneOffset") { Middleware.mnJavaScript_Insert(this, ".getTimezoneOffset()"); return; }
            if (mnName == "mnJavaScript_GetUTCDate") { Middleware.mnJavaScript_Insert(this, ".getUTCDate()"); return; }
            if (mnName == "mnJavaScript_GetUTCDay") { Middleware.mnJavaScript_Insert(this, ".getUTCDay()"); return; }
            if (mnName == "mnJavaScript_GetUTCFullYear") { Middleware.mnJavaScript_Insert(this, ".getUTCFullYear()"); return; }
            if (mnName == "mnJavaScript_GetUTCHours") { Middleware.mnJavaScript_Insert(this, ".getUTCHours()"); return; }
            if (mnName == "mnJavaScript_GetUTCMilliseconds") { Middleware.mnJavaScript_Insert(this, ".getUTCMilliseconds()"); return; }
            if (mnName == "mnJavaScript_GetUTCMinutes") { Middleware.mnJavaScript_Insert(this, ".getUTCMinutes()"); return; }
            if (mnName == "mnJavaScript_GetUTCMonth") { Middleware.mnJavaScript_Insert(this, ".getUTCMonth()"); return; }
            if (mnName == "mnJavaScript_GetUTCSeconds") { Middleware.mnJavaScript_Insert(this, ".getUTCSeconds()"); return; }
            if (mnName == "mnJavaScript_GetYear") { Middleware.mnJavaScript_Insert(this, ".getYear()"); return; }

            if (mnName == "mnJavaScript_Parse") { Middleware.mnJavaScript_Insert(this, ".parse(\"March 21, 2015\")"); return; }

            // mn3 = createMenuItem(mn2, "mainJavaScript_SetMethods", "set methods");
            if (mnName == "mnJavaScript_SetDate") { Middleware.mnJavaScript_Insert(this, ".setDate(15) // set the day to 15"); return; }
            if (mnName == "mnJavaScript_SetFullYear") { Middleware.mnJavaScript_Insert(this, ".setFullYear(2015)"); return; }
            if (mnName == "mnJavaScript_SetHours") { Middleware.mnJavaScript_Insert(this, "setHours(13);"); return; }

            if (mnName == "mnJavaScript_SetMilliseconds") { Middleware.mnJavaScript_Insert(this, ".setMilliseconds(23);"); return; }
            if (mnName == "mnJavaScript_SetMinutes") { Middleware.mnJavaScript_Insert(this, ".setMinutes(34);"); return; }
            if (mnName == "mnJavaScript_setMonth") { Middleware.mnJavaScript_Insert(this, ".setMonth(11);"); return; }
            if (mnName == "mnJavaScript_setSeconds") { Middleware.mnJavaScript_Insert(this, ".setSeconds()"); return; }
            if (mnName == "mnJavaScript_setTime") { Middleware.mnJavaScript_Insert(this, ".setTime(47);"); return; }

            if (mnName == "mnJavaScript_setUTCDate") { Middleware.mnJavaScript_Insert(this, ".setUTCDate(15) // set the day"); return; }
            if (mnName == "mnJavaScript_setUTCFullYear") { Middleware.mnJavaScript_Insert(this, ".setUTCFullYear(2017);"); return; }
            if (mnName == "mnJavaScript_setUTCHours") { Middleware.mnJavaScript_Insert(this, ".setUTCHours(11);"); return; }
            if (mnName == "mnJavaScript_setUTCMilliseconds") { Middleware.mnJavaScript_Insert(this, ".setUTCMilliseconds(115);"); return; }

            if (mnName == "mnJavaScript_setUTCMinutes") { Middleware.mnJavaScript_Insert(this, ".setUTCMinutes(14);"); return; }
            if (mnName == "mnJavaScript_setUTCMonth") { Middleware.mnJavaScript_Insert(this, ".setUTCMonth(7);"); return; }
            if (mnName == "mnJavaScript_setUTCSeconds") { Middleware.mnJavaScript_Insert(this, ".setUTCSeconds(26);"); return; }

            if (mnName == "mnJavaScript_setYear") { Middleware.mnJavaScript_Insert(this, ".setYear(2017);"); return; }
            //mn3 = createMenuItem(mn2, "mainJavaScript_ToMethods", "to methods");
            if (mnName == "mnJavaScript_toDateString") { Middleware.mnJavaScript_Insert(this, ".toDateString();"); return; }

            if (mnName == "mnJavaScript_toISOString") { Middleware.mnJavaScript_Insert(this, ".toISOString();"); return; }
            if (mnName == "mnJavaScript_toJSON") { Middleware.mnJavaScript_Insert(this, ".toJSON();"); return; }
            if (mnName == "mnJavaScript_toLocaleDateString") { Middleware.mnJavaScript_Insert(this, ".toLocaleDateString();"); return; }
            if (mnName == "mnJavaScript_toLocaleTimeString") { Middleware.mnJavaScript_Insert(this, ".toLocaleTimeString();"); return; }
            if (mnName == "mnJavaScript_toLocaleString") { Middleware.mnJavaScript_Insert(this, ".toLocaleString();"); return; }
            if (mnName == "mnJavaScript_toString") { Middleware.mnJavaScript_Insert(this, ".toString()"); return; }
            if (mnName == "mnJavaScript_toTimeString") { Middleware.mnJavaScript_Insert(this, ".toTimeString();"); return; }
            if (mnName == "mnJavaScript_toUTCString") { Middleware.mnJavaScript_Insert(this, "toUTCString();"); return; }
            if (mnName == "mnJavaScript_UTC") { Middleware.mnJavaScript_Insert(this, ".UTC()"); return; }


            if (mnName == "mnPHP_If") { Middleware.InsertPHP_If(this); return; }
            if (mnName == "mnPHP_If_Else") { Middleware.InsertPHP_If_Else(this); return; }

            if (mnName == "mnPHP_If_ElseIf") { Middleware.InsertPHP_If_ElseIf(this); return; }

            

            if (mnName == "mnPHP_Dowhile") { Middleware.InsertPHP_Dowhile(this); return; }
            if (mnName == "mnPHP_While") { Middleware.InsertPHP_While(this); return; }
            if (mnName == "mnPHP_For_i") { Middleware.InsertPHP_For_i(this); return; }
            if (mnName == "mnPHP_Foreach") { Middleware.InsertPHP_Foreach(this); return; }
            if (mnName == "mnPHP_Switch") { Middleware.InsertPHP_Switch(this); return; }


            //if (mnName == "mainPHP")	{ HTML_Middleware.
            if (mnName == "mnPHP_InsertPHP_Sector") { Middleware.InsertPHP_Sector(this); return; }
            if (mnName == "mnPHP_ClassResult") { Middleware.PHP_ClassResult(this); return; }
            if (mnName == "mnPHP_ClassNumber") { Middleware.PHP_ClassNumber(this); return; }

            if (mnName == "mnPHP_Function") { Middleware.InsertPHP_Funktion(this); return; }

            // absabs
            if (mnName == "mnPHP_numberformat") { Middleware.InsertPHP_Numberformat(this);  return;  }
            if (mnName == "mnPHP_round") { Middleware.InsertPHP_Round(this);  return;  }
            if (mnName == "mnPHP_sprintf") { Middleware.InsertPHP_Sprintf(this);  return;  }
            if (mnName == "mnPHP_printf") { Middleware.InsertPHP_Printf(this);  return;  }


            if (mnName == "mnPHP_abs") { Middleware.InsertPHP_Abs(this); return;  }
            if (mnName == "mnPHP_ceil") { Middleware.InsertPHP_Ceil(this); return; }
            if (mnName == "mnPHP_dechex") { Middleware.InsertPHP_Dechex(this); return;  }
            if (mnName == "mnPHP_decoct") { Middleware.InsertPHP_Decoct(this); return; }
            if (mnName == "mnPHP_floor") { Middleware.InsertPHP_Floor(this); return; }
            if (mnName == "mnPHP_intdiv") { Middleware.InsertPHP_Intdiv(this); return; }
            if (mnName == "mnPHP_max") { Middleware.InsertPHP_Max(this); return; }
            if (mnName == "mnPHP_min") { Middleware.InsertPHP_Min(this); return; }
            if (mnName == "mnPHP_pi") { Middleware.InsertPHP_Pi(this); return; }
            if (mnName == "mnPHP_pow") { Middleware.InsertPHP_Pow(this); return;  }

            if (mnName == "mnPHP_Attribute") { Middleware.PHP_AttributeSetGet(this); return; }

            if (mnName == "mnPHP_JSon_encodepur") { Middleware.PHP_JSon_encodepur(this); return; }
            if (mnName == "mnPHP_JSon") { Middleware.PHP_JSon(this); return; }
            if (mnName == "mnPHP_json_encode") { Middleware.PHP_json_encode(this); return; }



            if (mnName == "mnPHP_Include_oncePHPFile") {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.DefaultExt = ".php";
                openFileDialog.InitialDirectory = SingVar.LastPath;
                openFileDialog.Filter = "PHP-Files (*.php)|*.php|" + "All files (*.*)|*.*";
                openFileDialog.Multiselect = false;
                openFileDialog.Title = "Open php file";
                if (openFileDialog.ShowDialog(null) == true) {
                    Middleware.PHP_IncludePHPFile(this, Basis.getFilename(openFileDialog.FileName));
                }
                return;
            }

            if (mnName == "mnPHP_Require_oncePHPFile") {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.DefaultExt = ".php";
                openFileDialog.InitialDirectory = SingVar.LastPath;
                openFileDialog.Filter = "PHP-Files (*.php)|*.php|" + "All files (*.*)|*.*";
                openFileDialog.Multiselect = false;
                openFileDialog.Title = "Open php file";
                if (openFileDialog.ShowDialog(null) == true) {
                    Middleware.PHP_RequirePHPFile(this, Basis.getFilename(openFileDialog.FileName));
                }
                return;
            }



            if (mnName == "mnPHP_InsertPHP_ISSET") { Middleware.PHP_InsertPHP_isset(this); return; }
            if (mnName == "mnPHP_InsertPHP_issetSelectMultiple") { Middleware.PHP_InsertPHP_issetSelectMultiple(this); return; }

            if (mnName == "mnPHP_InsertcheckIssetInt") { Middleware.PHP_InsertcheckIssetInt(this); return; }
            if (mnName == "mnPHP_InsertcheckIssetFloat") { Middleware.PHP_InsertcheckIssetFloat(this); return; }



            if (mnName == "mnPHP_IsnumericInt") { Middleware.InsertPHP_IsnumericInt(this); return; }
            if (mnName == "mnPHP_IsnumericFloat") {  Middleware.InsertPHP_IsnumericInt(this);   return;    }
            if (mnName == "mnPHP_IsInt") { Middleware.InsertPHP_IsInt(this); return; }
            if (mnName == "mnPHP_IsFloat") { Middleware.InsertPHP_IsFloat(this); return; }

            if (mnName == "mnPHP_IsBool") { Middleware.InsertPHP_IsBool(this); return; }
            if (mnName == "mnPHP_IsString") { Middleware.InsertPHP_IsString(this); return; }
            if (mnName == "mnPHP_IsArray") { Middleware.InsertPHP_IsArray(this); return; }
            if (mnName == "mnPHP_IsObject") { Middleware.InsertPHP_IsObject(this); return; }


            if (mnName == "mnPHP_Intval") { Middleware.InsertPHP_IntVal(this); return; }


            if (mnName == "mnPHP_Arrays_createArray") { Middleware.InsertPHP_createArray(this); return; }
            if (mnName == "mnPHP_Arrays_createArrayWithItems") { Middleware.InsertPHP_createArrayWithItems(this); return; }
            if (mnName == "mnPHP_Arrays_createMultidimArray") { Middleware.InsertPHP_createMultidimArray(this); return; }
            if (mnName == "mnPHP_Arrays_pushArray") { Middleware.InsertPHP_pushArray(this); return; }
            if (mnName == "mnPHP_Arrays_arrayLength") { Middleware.InsertPHP_Arrays_arrayLength(this); return; }
            if (mnName == "mnPHP_Arrays_foreach") { Middleware.InsertPHP_Arrays_foreach(this); return; }


            if (mnName == "mnPHP_Arrays_InsertPHP_Matrix") { Middleware.InsertPHP_Matrix(this); return; }


            if (mnName == "mnPHP_regex") { Middleware.InsertPHP_Regex(this); return; }


            if (mnName == "mnPHP_char") { Middleware.InsertPHP_char(this); return; }

            if (mnName == "mnPHP_explode") { Middleware.InsertPHP_Explode(this); return; }

            if (mnName == "mnPHP_ltrim") { Middleware.InsertPHP_Ltrim(this); return; }
            if (mnName == "mnPHP_rtrim") { Middleware.InsertPHP_Rtrim(this); return; }
            if (mnName == "mnPHP_trim") { Middleware.InsertPHP_Trim(this); return; }

            if (mnName == "mnPHP_strlen") { Middleware.InsertPHP_Strlen(this); return; }

            if (mnName == "mnPHP_replace") {  Middleware.InsertPHP_Replace(this);   return;     }
            

            if (mnName == "mnPHP_bin2hex") { Middleware.InsertPHP_Bin2Hex(this); return; }

            if (mnName == "mnPHP_str_split") { Middleware.InsertPHP_Str_split(this); return; }

            if (mnName == "mnPHP_strtok") { Middleware.InsertPHP_Strtok(this); return; }

            if (mnName == "mnPHP_ord") { Middleware.InsertPHP_ord(this); return; }


            if (mnName == "mnPHP_substr") { Middleware.InsertPHP_Substr(this); return; }

            if (mnName == "mnPHP_strtolower") { Middleware.InsertPHP_Strtolower(this); return; }

            if (mnName == "mnPHP_strtoupper") { Middleware.InsertPHP_Strtoupper(this); return; }

            if (mnName == "mnPHP_Startwith") { Middleware.PHP_Startwith(this); return; }





            if (mnName == "mnPHP_echoText") { Middleware.InsertPHP_echoText(this); return; }
            if (mnName == "mnPHP_echoStringAndVariable") { Middleware.InsertPHP_echoStringAndVariable(this); return; }
            if (mnName == "mnPHP_echoStringAndVariable_withPoint") { Middleware.InsertPHP_echoStringAndVariable_withPoint(this); return; }

            if (mnName == "mnPHP_weiterleitung") { Middleware.InsertPHP_weiterleitung(this); return; }



            // if (mnName == "mnJSP_InsertJSP_Directive") { HTML_Middleware.InsertJSP_Directive(this); return; }

            if (mnName == "mnJSP_InsertJSP_Directive_util") { Middleware.InsertJSP_Directive(this, "import = \"java.util.* \""); return; }
            if (mnName == "mnJSP_InsertJSP_Directive_io") { Middleware.InsertJSP_Directive(this, "import = \"java.io.* \""); return; }
            if (mnName == "mnJSP_InsertJSP_Directive_text") { Middleware.InsertJSP_Directive(this, "import = \"java.text.* \""); return; }
            if (mnName == "mnJSP_InsertJSP_Directive_reflect") { Middleware.InsertJSP_Directive(this, "import = \"java.lang.reflect.* \""); return; }


            if (mnName == "mnJSP_InsertJSP_Deklaration") { Middleware.InsertJSP_Deklaration(this); return; }
            if (mnName == "mnJSP_InsertJSP_Scriptlet") { Middleware.InsertJSP_Scriptlet(this); return; }
            if (mnName == "mnJSP_InsertJSP_Expression") { Middleware.InsertJSP_Expression(this); return; }
            if (mnName == "mnJSP_InsertJSP_Comment") { Middleware.InsertJSP_Comment(this); return; }


            if (mnName == "mnJSP_IncludeJSP") {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.DefaultExt = ".jsp";
                openFileDialog.InitialDirectory = SingVar.LastPath;
                openFileDialog.Filter = "JSP-Files (*.jsp)|*.jsp|" + "All files (*.*)|*.*";
                openFileDialog.Multiselect = false;
                openFileDialog.Title = "Open jsp file";
                if (openFileDialog.ShowDialog(null) == true) {
                    Middleware.JavaJSP_IncludeJSP(this, Basis.getFilename(openFileDialog.FileName));
                }
                return;
            }




            if (mnName == "mnJSP_Json") { Middleware.mnJSP_Json(this); return; }


            if (mnName == "mnJSP_getIntNumber") { Middleware.InsertJSP_parseInt(this); return; }
            if (mnName == "mnJSP_getDoubleNumber") { Middleware.InsertJSP_parseDouble(this); return; }
            if (mnName == "mnJSP_echoText") { Middleware.InsertJSP_echoText(this); return; }
            if (mnName == "mnJSP_echoStringAndVariable") { Middleware.InserJSP_echoStringAndVariable(this); return; }

            if (mnName == "mnJSP_SimpleDateFormat") { Middleware.mnJSP_SimpleDateFormat(this); return; }
            if (mnName == "mnJSP_Calender") { Middleware.mnJSP_Calender(this); return; }


            if (mnName == "mnJSP_codePointAt") { Middleware.mnJSP_codePointAt(this); return; }
            if (mnName == "mnJSP_getBytes") { Middleware.mnJSP_getBytes(this); return; }
            if (mnName == "mnJSP_charAt") { Middleware.mnJSP_charAt(this); return; }
            if (mnName == "mnJSP_ord") { Middleware.mnJSP_ord(this); return; }

            if (mnName == "mnJSP_toCharArray") { Middleware.mnJSP_toCharArray(this); return; }


            if (mnName == "mnJSP_indexOf") { Middleware.mnJSP_indexOf(this); return; }
            if (mnName == "mnJSP_indexOfStr") { Middleware.mnJSP_indexOfStr(this); return; }
            if (mnName == "mnJSP_lastIndexOf") { Middleware.mnJSP_lastIndexOf(this); return; }

            if (mnName == "mnJSP_ltrim") { Middleware.mnJSP_ltrim(this); return; }
            if (mnName == "mnJSP_rtrim") { Middleware.mnJSP_rtrim(this); return; }
            if (mnName == "mnJSP_trim") { Middleware.mnJSP_trim(this); return; }
            if (mnName == "mnJSP_strlen") { Middleware.mnJSP_strlen(this); return; }

            if (mnName == "mnJSP_split") { Middleware.mnJSP_split(this); return; }

            if (mnName == "mnJSP_substring") { Middleware.mnJSP_substring(this); return; }
            if (mnName == "mnJSP_toLowerCase") { Middleware.mnJSP_toLowerCase(this); return; }

            if (mnName == "mnJSP_toUpperCase") { Middleware.mnJSP_toUpperCase(this); return; }

            if (mnName == "mnJSP_Startswith") { Middleware.mnJSP_Startswith(this); return; }



            if (mnName == "mnJSP_getParam") { Middleware.InserJSP_getParam(this); return; }
            if (mnName == "mnJSP_getParams") { Middleware.InserJSP_getParams(this); return; }



            //if (mnName == "mainHTML5")	{ HTML_Middleware.
            //if (mnName == "mainHTML5Sectors")	{ HTML_Middleware.
            if (mnName == "mnHTML5_Header") { Middleware.InsertForm_HTML5_Header(this); return; }
            if (mnName == "mnHTML5_Nav_Hori") { Middleware.InsertForm_HTML5_Nav_Hori(this); return; }
            if (mnName == "mnHTML5_Nav_Verti") { Middleware.InsertForm_HTML5_Nav_Verti(this); return; }


            if (mnName == "mnHTML5_Section") { Middleware.InsertForm_HTML5_Section(this); return; }
            if (mnName == "mnHTML5_Aside") { Middleware.InsertForm_HTML5_Aside(this); return; }
            if (mnName == "mnHTML5_Footer") { Middleware.InsertForm_HTML5_Footer(this); return; }
            if (mnName == "mnHTML5_Article") { Middleware.InsertForm_HTML5_Arcticle(this); return; }


            //if (mnName == "mainHTML5_Auszeichungen")	{ HTML_Middleware.
            if (mnName == "mnHTML5_Abbr") { Middleware.InsertForm_HTML5_Abbr(this); return; }
            if (mnName == "mnHTML5_B") { Middleware.InsertForm_HTML5_B(this); return; }
            if (mnName == "mnHTML5_Bdi") { Middleware.InsertForm_HTML5_Bdi(this); return; }
            if (mnName == "mnHTML5_Cite") { Middleware.InsertForm_HTML5_Cite(this); return; }
            if (mnName == "mnHTML5_Code") { Middleware.InsertForm_HTML5_Code(this); return; }
            if (mnName == "mnHTML5_DEL") { Middleware.InsertForm_HTML5_Del(this); return; }
            if (mnName == "mnHTML5_DL") { Middleware.InsertForm_HTML5_Dl(this); return; }
            if (mnName == "mnHTML5_Dfn") { Middleware.InsertForm_HTML5_Dfn(this); return; }
            if (mnName == "mnHTML5_Em") { Middleware.InsertForm_HTML5_Em(this); return; }
            if (mnName == "mnHTML5_I") { Middleware.InsertForm_HTML5_I(this); return; }
            if (mnName == "mnHTML5_Ins") { Middleware.InsertForm_HTML5_Ins(this); return; }
            if (mnName == "mnHTML5_Kdb") { Middleware.InsertForm_HTML5_Kdb(this); return; }
            if (mnName == "mnHTML5_Mark") { Middleware.InsertForm_HTML5_Mark(this); return; }
            if (mnName == "mnHTML5_Q") { Middleware.InsertForm_HTML5_Q(this); return; }
            if (mnName == "mnHTML5_S") { Middleware.InsertForm_HTML5_S(this); return; }
            if (mnName == "mnHTML5_Samp") { Middleware.InsertForm_HTML5_Samp(this); return; }
            if (mnName == "mnHTML5_Small") { Middleware.InsertForm_HTML5_Small(this); return; }
            if (mnName == "mnHTML5_Strong") { Middleware.InsertForm_HTML5_Strong(this); return; }
            if (mnName == "mnHTML5_U") { Middleware.InsertForm_HTML5_U(this); return; }
            if (mnName == "mnHTML5_Var") { Middleware.InsertForm_HTML5_Var(this); return; }
            if (mnName == "mnHTML5_Wbr") { Middleware.InsertForm_HTML5_Wbr(this); return; }

            if (mnName == "mnHTML5_Summary") { Middleware.InsertForm_HTML5_Summary(this); return; }
            if (mnName == "mnHTML5_Details") { Middleware.InsertForm_HTML5_Details(this); return; }


            //if (mnName == "mainHTML5FormsElements")	{ HTML_Middleware.

            // InsertForm_HTML5_Address

            if (mnName == "mnHTML5_Formelements_Figure") { Middleware.InsertForm_HTML5_Figure(this); return; }
            if (mnName == "mnHTML5_Formelements_Progress") { Middleware.InsertForm_HTML5_Progress(this); return; }
            if (mnName == "mnHTML5_Formelements_Meter") { Middleware.InsertForm_HTML5_Meter(this); return; }
            if (mnName == "mnHTML5_Formelements_Datalist") { Middleware.InsertForm_HTML5_Datalist(this); return; }
            if (mnName == "mnHTML5_Formelements_keygen") { Middleware.InsertForm_HTML5_Keygen(this); return; }
            if (mnName == "mnHTML5_Formelements_Output") { Middleware.InsertForm_HTML5_Output(this); return; }
            if (mnName == "mnHTML5_Formelements_Tel") { Middleware.InsertForm_HTML5_Tel(this); return; }
            if (mnName == "mnHTML5_Formelements_Search") { Middleware.InsertForm_HTML5_Search(this); return; }
            if (mnName == "mnHTML5_Formelements_Url") { Middleware.InsertForm_HTML5_Url(this); return; }
            if (mnName == "mnHTML5_Formelements_EMail") { Middleware.InsertForm_HTML5_EMail(this); return; }
            if (mnName == "mnHTML5_Formelements_DateTime") { Middleware.InsertForm_HTML5_Datetime(this); return; }
            if (mnName == "mnHTML5_Formelements_Date") { Middleware.InsertForm_HTML5_Date(this); return; }
            if (mnName == "mnHTML5_Formelements_Month") { Middleware.InsertForm_HTML5_Month(this); return; }
            if (mnName == "mnHTML5_Formelements_Week") { Middleware.InsertForm_HTML5_Week(this); return; }
            if (mnName == "mnHTML5_Formelements_Time") { Middleware.InsertForm_HTML5_Time(this); return; }
            if (mnName == "mnHTML5_Formelements_Datetime_local") { Middleware.InsertForm_HTML5_Date_local(this); return; }
            if (mnName == "mnHTML5_Formelements_Number") { Middleware.InsertForm_HTML5_Number(this); return; }
            if (mnName == "mnHTML5_Formelements_Range1") { Middleware.InsertForm_HTML5_Range1(this); return; }
            if (mnName == "mnHTML5_Formelements_Range2") { Middleware.InsertForm_HTML5_Range2(this); return; }
            if (mnName == "mnHTML5_Formelements_Color") { Middleware.InsertForm_HTML5_Color(this); return; }

            if (mnName == "mnHTML5_Video1") { Middleware.InsertForm_HTML5_Video1(this); return; }
            if (mnName == "mnHTML5_Video2") { Middleware.InsertForm_HTML5_Video2(this); return; }
            if (mnName == "mnHTML5_Video3") { Middleware.InsertForm_HTML5_Video3(this); return; }
            if (mnName == "mnHTML5_Audio1") { Middleware.InsertForm_HTML5_Audio1(this); return; }
            if (mnName == "mnHTML5_Audio2") { Middleware.InsertForm_HTML5_Audio2(this); return; }

            if (mnName == "mnHTML5_Canvas_GameLoop1") { Middleware.HTML5_Canvas_GameLoop1(this); return; }
            if (mnName == "mnHTML5_Canvas_GameLoop2") { Middleware.HTML5_Canvas_GameLoop2(this); return; }
            if (mnName == "mnHTML5_Canvas_GameLoop3") { Middleware.HTML5_Canvas_GameLoop3(this); return; }


            if (mnName == "mnHTML5_Canvas_Line1") { Middleware.HTML5_Canvas_Line1(this); return; }
            if (mnName == "mnHTML5_Canvas_Line2") { Middleware.HTML5_Canvas_Line2(this); return; }
            if (mnName == "mnHTML5_Canvas_Rect") { Middleware.HTML5_Canvas_Rect(this); return; }
            if (mnName == "mnHTML5_Canvas_StrokeRect") { Middleware.HTML5_Canvas_StrokeRect(this); return; }
            if (mnName == "mnHTML5_Canvas_FillRect") { Middleware.HTML5_Canvas_FillRect(this); return; }
            if (mnName == "mnHTML5_Canvas_ClearRect") { Middleware.HTML5_Canvas_ClearRect(this); return; }
            if (mnName == "mnHTML5_Canvas_Arc") { Middleware.HTML5_Canvas_Arc(this); return; }
            if (mnName == "mnHTML5_Canvas_FillArc") { Middleware.HTML5_Canvas_FillArc(this); return; }
            if (mnName == "mnHTML5_Canvas_StrokeText") { Middleware.HTML5_Canvas_StrokeText(this); return; }
            if (mnName == "mnHTML5_Canvas_FillText") { Middleware.HTML5_Canvas_FillText(this); return; }
            if (mnName == "mnHTML5_Canvas_BezierCurveTo") { Middleware.HTML5_Canvas_BezierCurveTo(this); return; }
            if (mnName == "mnHTML5_Canvas_DrawImage") { Middleware.HTML5_Canvas_DrawImage(this); return; }
            if (mnName == "mnHTML5_Canvas_Drawmarker1") { Middleware.HTML5_Canvas_Drawmarker1(this); return; }
            if (mnName == "mnHTML5_Canvas_Drawmarker2") { Middleware.HTML5_Canvas_Drawmarker2(this); return; }


            //if (mnName == "mainCSS")	
            if (mnName == "mnInsertCSS_Body") { Middleware.InsertCSS_Body(this); return; }
            if (mnName == "mnInsertCSS") { Middleware.InsertCSS(this); return; }
            if (mnName == "mnInsertCSS_H2") { Middleware.InsertCSS_H2(this); return; }
            if (mnName == "mnInsertCSS_PositionAbsolute") { Middleware.InsertCSS_PositionAbsolute(this); return; }
            if (mnName == "mnInsertCSS_PositionRelativ") { Middleware.InsertCSS_PositionRelativ(this); return; }
            if (mnName == "mnInsertCSS_Multidefinition") { Middleware.InsertCSS_Multidefinition(this); return; }
            if (mnName == "mnInsertCSS_SelektorenBehind") { Middleware.InsertCSS_SelektorenBehind(this); return; }
            if (mnName == "mnInsertCSS_SelektorenTopDown") { Middleware.InsertCSS_SelektorenTopDown(this); return; }
            if (mnName == "mnInsertCSS_LeftRightSelektor") { Middleware.InsertCSS_LeftRightSelektor(this); return; }
            //if (mnName == "mainCSSBsp")	{ HTML_Middleware.
            if (mnName == "mnInsert_CSSBlock_H2") { Middleware.InsertCSS_H2(this); return; }
            if (mnName == "mnInsert_CSSBlock_OL") { Middleware.InsertCSS_OL(this); return; }
            if (mnName == "mnInsert_CSSBlock_UL") { Middleware.InsertCSS_UL(this); return; }
            if (mnName == "mnInsert_CSSBlock_TH") { Middleware.InsertCSS_TH(this); return; }
            if (mnName == "mnInsert_CSSBlock_TD") { Middleware.InsertCSS_TD(this); return; }
            if (mnName == "mnInsert_HTMLBlock_Scrolling") { Middleware.InsertHTML_Scrolling(this); return; }
            // if (mnName == "mainCSS_Image")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_background_image") { Middleware.InsertCSS_background_image(this); return; }
            if (mnName == "mnInsertCSS_Body_backgroundrepeat") { Middleware.InsertCSS_Body_backgroundrepeat(this); return; }
            if (mnName == "mnInsertCSS_Bodybackgroundattachment") { Middleware.InsertCSS_Bodybackgroundattachment(this); return; }
            if (mnName == "mnInsertCSS_Body_backgroundposition") { Middleware.InsertCSS_Body_backgroundposition(this); return; }
            if (mnName == "mainCSS_Colors") { Middleware.InsertCSS_background_image(this); return; }
            // if (mnName == "mnInsertHTML_CSS_ColorConstant") { HTML_Middleware.InsertCSS_ColorConstant(this); return; }  // html und css
            if (mnName == "mnInsertCSS_Farbe") { Middleware.InsertCSS_FontColor(this); return; }
            if (mnName == "mnInsert_CSS_Backgroundcolor") { Middleware.InsertCSS_BackgroundColor(this); return; }
            // if (mnName == "mainCSS_Fonts")	
            if (mnName == "mnInsertCSS_Schrift12em") { Middleware.InsertCSS_FontSize_12em(this); return; }
            if (mnName == "mnInsertCSS_FontColor") { Middleware.InsertCSS_FontColor(this); return; }
            if (mnName == "mnInsertCSS_FontWeight") { Middleware.InsertCSS_FontWeight(this); return; }
            // if (mnName == "mainCSS_Fonts")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_VerdanaArialHelveticaSwiss") { Middleware.InsertCSS_Fonttyp_Verdana(this); return; }
            if (mnName == "mnInsertCSS_CourierNew") { Middleware.InsertCSS_Fonttyp_CourierNew(this); return; }
            if (mnName == "mnInsertCSS_Monospace") { Middleware.InsertCSS_Fonttyp_Monospace(this); return; }
            // if (mnName == "mainInsertCSS_SmallFont")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_SmallestFont") { Middleware.InsertCSS_SmallestFont(this); return; }
            if (mnName == "mnInsertCSS_SmallerFont") { Middleware.InsertCSS_SmallerFont(this); return; }
            if (mnName == "mnInsertCSS_BiggerFont") { Middleware.InsertCSS_BiggerFont(this); return; }
            if (mnName == "mnInsertCSS_BigFont") { Middleware.InsertCSS_BigFont(this); return; }
            if (mnName == "mnInsertCSS_FontSize_15Em2") { Middleware.InsertCSS_FontSize_15Em(this); return; }


            if (mnName == "mnInsertCSS_Bigger_Percentage") { Middleware.InsertCSS_Bigger_Percentage(this); return; }
            if (mnName == "mnInsertCSS_WordSpacing") { Middleware.InsertCSS_WordSpacing(this); return; }
            if (mnName == "mnInsertCSS_LetterSpacing") { Middleware.InsertCSS_LetterSpacing(this); return; }
            //if (mnName == "mainInsertCSS_Textdecoration")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_Textdecoration_None") { Middleware.InsertCSS_Textdecoration_None(this); return; }
            if (mnName == "mnInsertCSS_Textdecoration_Underline") { Middleware.InsertCSS_Textdecoration_Underline(this); return; }
            if (mnName == "mnInsertCSS_Textdecoration_Overline") { Middleware.InsertCSS_Textdecoration_Overline(this); return; }
            if (mnName == "mnInsertCSS_Textdecoration_Blinkend") { Middleware.InsertCSS_Textdecoration_blink(this); return; }
            if (mnName == "mnInsertCSS_Textdecoration_Italic") { Middleware.InsertCSS_Textdecoration_Italic(this); return; }
            //if (mnName == "mainInsertCSS_Texttransform")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_Texttransform_None") { Middleware.InsertCSS_TextTransform_none(this); return; }
            if (mnName == "mnInsertCSS_Texttransform_Uppercase") { Middleware.InsertCSS_TextTransform_uppercase(this); return; }
            if (mnName == "mnInsertCSS_Texttransform_Lowercase") { Middleware.InsertCSS_TextTransform_lowercase(this); return; }
            if (mnName == "mnInsertCSS_Texttransform_Capitalize") { Middleware.InsertCSS_TextTransform_capitalize(this); return; }

            if (mnName == "mnInsertCSS_Text_Indent") { Middleware.InsertCSS_Text_Indent(this); return; }

            //if (mnName == "mainCSS_Lists")	{ HTML_Middleware.
            //if (mnName == "mainCSS_Lists_UL")	{ HTML_Middleware.
            if (mnName == "mnCSS_Lists_UL_None") { Middleware.InsertCSS_UL_liste_None(this); return; }
            if (mnName == "mnCSS_Lists_UL_Circle") { Middleware.InsertCSS_UL_Liste_circle(this); return; }
            if (mnName == "mnCSS_Lists_UL_Square") { Middleware.InsertCSS_UL_Liste_square(this); return; }
            if (mnName == "mnCSS_Lists_UL_Disc") { Middleware.InsertCSS_UL_Liste_disc(this); return; }
            //if (mnName == "mainCSS_Lists_OL")	{ HTML_Middleware.
            if (mnName == "mnCSS_Lists_OL_None") { Middleware.InsertCSS_OL_Liste_None(this); return; }
            if (mnName == "mnCSS_Lists_OL_Decimal") { Middleware.InsertCSS_OL_Liste_decimal(this); return; }
            if (mnName == "mnCSS_Lists_OL_Decimalleadingzero") { Middleware.InsertCSS_OL_Liste_decimalleadingzero(this); return; }
            if (mnName == "mnCSS_Lists_OL_Lowerroman") { Middleware.InsertCSS_OL_Liste_lowerroman(this); return; }
            if (mnName == "mnCSS_Lists_OL_Upperroman") { Middleware.InsertCSS_OL_Liste_upperroman(this); return; }
            if (mnName == "mnCSS_Lists_OL_Lowergreek") { Middleware.InsertCSS_OL_Liste_lowergreek(this); return; }
            if (mnName == "mnCSS_Lists_OL_Lowerlatin") { Middleware.InsertCSS_OL_Liste_lowerlatin(this); return; }
            if (mnName == "mnCSS_Lists_OL_Upperlatin") { Middleware.InsertCSS_OL_Liste_Upperlatin(this); return; }
            //if (mnName == "mainCSS_Lists_Liststyleposition")	{ HTML_Middleware.
            if (mnName == "mnCSS_Lists_Inside") { Middleware.InsertCSS_ListStylePosition_inside(this); return; }
            if (mnName == "mnCSS_Lists_Outside") { Middleware.InsertCSS_ListStylePosition_outside(this); return; }
            //if (mnName == "mainCSS_Tables")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_TR") { Middleware.InsertCSS_BlockTR(this); return; }
            if (mnName == "mnInsertCSS_TH") { Middleware.InsertCSS_BlockTH(this); return; }
            if (mnName == "mnInsertCSS_TD") { Middleware.InsertCSS_BlockTD(this); return; }
            if (mnName == "mnInsertCSS_Table_th_td_Border") { Middleware.InsertCSS_Table_th_td_Border(this); return; }

            if (mnName == "mnInsertCSS_Table_css_hover") {
                Middleware.InsertCSS_Table_css_hover(this); return;
            }


            //if (mnName == "mainCSS_Borders")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_BorderColor") { Middleware.InsertCSS_Bordercolor(this); return; }
            //if (mnName == "mainInsertCSS_BorderStyles")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_Border_None") { Middleware.InsertCSS_Border_None(this); return; }
            if (mnName == "mnInsertCSS_Border_Hidden") { Middleware.InsertCSS_Border_Hidden(this); return; }
            if (mnName == "mnInsertCSS_Border_Dotted") { Middleware.InsertCSS_Border_Dotted(this); return; }
            if (mnName == "mnInsertCSS_Border_Dashed") { Middleware.InsertCSS_Border_Dashed(this); return; }
            if (mnName == "mnInsertCSS_Border_Solid") { Middleware.InsertCSS_Border_Solid(this); return; }
            if (mnName == "mnInsertCSS_Border_Double") { Middleware.InsertCSS_Border_Double(this); return; }
            if (mnName == "mnInsertCSS_Border_Groove") { Middleware.InsertCSS_Border_Groove(this); return; }
            if (mnName == "mnInsertCSS_Border_Ridge") { Middleware.InsertCSS_Border_Ridge(this); return; }
            if (mnName == "mnInsertCSS_Border_Inset") { Middleware.InsertCSS_Border_Inset(this); return; }
            if (mnName == "mnInsertCSS_Border_Outset") { Middleware.InsertCSS_Border_Outset(this); return; }
            if (mnName == "mnInsertCSS_BorderWidth") { Middleware.InsertCSS_BorderWidth(this); return; }
            //if (mnName == "mainInsertCSS_Padding")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_Padding_OneForFour") { Middleware.InsertCSS_PaddingOneForfour(this); return; }
            if (mnName == "mnInsertCSS_Padding_TwoForTwo") { Middleware.InsertCSS_PaddingTwoForTwo(this); return; }
            if (mnName == "mnInsertCSS_Padding_FourForFour") { Middleware.InsertCSS_PaddingFourForFour(this); return; }
            if (mnName == "mnInsertCSS_Padding_Top") { Middleware.InsertCSS_PaddingTop(this); return; }
            if (mnName == "mnInsertCSS_Padding_Left") { Middleware.InsertCSS_PaddingLeft(this); return; }
            if (mnName == "mnInsertCSS_Padding_Bottom") { Middleware.InsertCSS_PaddingBottom(this); return; }
            if (mnName == "mnInsertCSS_Padding_Right") { Middleware.InsertCSS_Paddingright(this); return; }
            //if (mnName == "mainInsertCSS_Margin")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_Margin_OneForFour") { Middleware.InsertCSS_MarginOneForFour(this); return; }
            if (mnName == "mnInsertCSS_Margin_TwoForTwo") { Middleware.InsertCSS_MarginTwoForTwo(this); return; }
            if (mnName == "mnInsertCSS_Margin_FourForFour") { Middleware.InsertCSS_MarginFourForFour(this); return; }
            if (mnName == "mnInsertCSS_Margin_Top") { Middleware.InsertCSS_MarginTop(this); return; }
            if (mnName == "mnInsertCSS_Margin_Left") { Middleware.InsertCSS_MarginLeft(this); return; }
            if (mnName == "mnInsertCSS_Margin_Bottom") { Middleware.InsertCSS_MarginBottom(this); return; }
            if (mnName == "mnInsertCSS_Margin_Right") { Middleware.InsertCSS_MarginRight(this); return; }
            //if (mnName == "mainCSS_Links")	{ HTML_Middleware.
            if (mnName == "mnCSS_Links_NoneVisited") { Middleware.InsertCSS_Links_NoneVisited(this); return; }
            if (mnName == "mnCSS_Links_Visited") { Middleware.InsertCSS_Links_Visited(this); return; }
            if (mnName == "mnCSS_Links_Activate") { Middleware.InsertCSS_Links_Activate(this); return; }
            if (mnName == "mnCSS_Links_ThreeLinks") { Middleware.InsertCSS_Links_ThreeLinks(this); return; }
            if (mnName == "mnCSS_Links_ThreeLinksTogether") { Middleware.InsertCSS_Links_ThreeLinksTogether(this); return; }
            //if (mnName == "mainCSS_Alignments")	{ HTML_Middleware.
            //if (mnName == "mainCSS_HAlign")	{ HTML_Middleware.            
            if (mnName == "mnCSS_HAlign_Left") { Middleware.InsertCSS_Textalign_left(this); return; }
            if (mnName == "mnCSS_HAlign_Center") { Middleware.InsertCSS_Textalign_center(this); return; }
            if (mnName == "mnCSS_HAlign_Right") { Middleware.InsertCSS_Textalign_center(this); return; }
            if (mnName == "mnCSS_HAlign_Justify") { Middleware.InsertCSS_Textalign_justify(this); return; }
            //if (mnName == "mainCSS_VAlign")	{ HTML_Middleware.

            if (mnName == "mnCSS_VAlign_Baseline") { Middleware.InsertCSS_Valign_baseline(this); return; }
            if (mnName == "mnCSS_VAlign_Sub") { Middleware.InsertCSS_Valign_Sub(this); return; }
            if (mnName == "mnCSS_VAlign_Sup") { Middleware.InsertCSS_Valign_Super(this); return; }

            if (mnName == "mnCSS_VAlign_Sub03em") { Middleware.InsertCSS_Valign_Sub03em(this); return; }
            if (mnName == "mnCSS_VAlign_Sup03em") { Middleware.InsertCSS_VAlign_Sup03em(this); return; }



            if (mnName == "mnCSS_VAlign_Texttop") { Middleware.InsertCSS_Valign_texttop(this); return; }
            if (mnName == "mnCSS_VAlign_Textbottom") { Middleware.InsertCSS_Valign_texttop(this); return; }
            if (mnName == "mnCSS_VAlign_Middle") { Middleware.InsertCSS_Valign_middle(this); return; }
            if (mnName == "mnCSS_VAlign_Top") { Middleware.InsertCSS_Valign_top(this); return; }
            if (mnName == "mnCSS_VAlign_Bottom") { Middleware.InsertCSS_Valign_bottom(this); return; }
            if (mnName == "mnCSS_VAlign_Percentage") { Middleware.InsertCSS_Valign_percentage(this); return; }

            // CSS
            if (mnName == "mnCSS_FieldsetLegend") { Middleware.InsertCSS_FieldsetLegend(this); return; }
            if (mnName == "mnCSS_GridlayoutDialog") { Middleware.InsertCSS_GridlayoutDialog(this); return; }

            if (mnName == "mnCSS_Flexlayout1") { Middleware.InsertCSS_Flexlayout1a(this); return; }
            if (mnName == "mnCSS_Flexlayout2") { Middleware.InsertCSS_Flexlayout2(this); return; }

            if (mnName == "mainInsertCSS_Input_required") { Middleware.InsertCSS_Input_required(this); return; }
            if (mnName == "mainInsertCSS_Input_invalid") { Middleware.InsertCSS_Input_invalid(this); return; }


            // mainCSS_Layout
            if (mnName == "mnInsertCSS_FlexLayout_DisplayFlex") { Middleware.InsertCSS__DisplayFlex(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_Direction") { Middleware.InsertCSS_FlexLayout_Direction(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_Wrap") { Middleware.InsertCSS_FlexLayout_Wrap(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_justify_content") { Middleware.InsertCSS_FlexLayout_justify_content(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_align_items") { Middleware.InsertCSS_FlexLayout_align_items(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_align_content") { Middleware.InsertCSS_FlexLayout_align_content(this); return; }

            if (mnName == "mnInsertCSS_FlexLayout_flex_basis") { Middleware.InsertCSS_FlexLayout_flex_basis(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_flex_grow") { Middleware.InsertCSS_FlexLayout_flex_grow(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_flex_shrink") { Middleware.InsertCSS_FlexLayout_flex_shrink(this); return; }
            if (mnName == "mnInsertCSS_FlexLayout_align_self") { Middleware.InsertCSS_mnInsertCSS_FlexLayout_align_self(this); return; }




            //if (mnName == "mainCSSHTML5")	{ HTML_Middleware.
            //if (mnName == "mainCSSHTML5Sectors")	{ HTML_Middleware.
            if (mnName == "mnInsertCSS_HTML5_Header") { Middleware.InsertCSS_HTML5_Header(this); return; }
            if (mnName == "mnInsertCSS_HTML5_Nav") { Middleware.InsertCSS_HTML5_Nav(this); return; }
            if (mnName == "mnInsertCSS_HTML5_Section") { Middleware.InsertCSS_HTML5_Section(this); return; }
            if (mnName == "mnInsertCSS_HTML5_Aside") { Middleware.InsertCSS_HTML5_Aside(this); return; }
            if (mnName == "mnInsertCSS_HTML5_Footer") { Middleware.InsertCSS_HTML5_Footer(this); return; }
            if (mnName == "mnInsertCSS_HTML5_Article") { Middleware.InsertCSS_HTML5_Article(this); return; }

            if (mnName == "mnInsertCSS_HTML5_Required") { Middleware.InsertCSS_HTML5_Required(this); return; }



            //if (mnName == "mainCSSHTML5_Auszeichungen")	{ HTML_Middleware.
            if (mnName == "mnCSS_HTML5_Abbr") { Middleware.InsertCSS_HTML5_item(this, "abbr"); return; }
            if (mnName == "mnCSS_HTML5_B") { Middleware.InsertCSS_HTML5_item(this, "b"); return; }
            if (mnName == "mnCSS_HTML5_Bdi") { Middleware.InsertCSS_HTML5_item(this, "bdi"); return; }
            if (mnName == "mnCSS_HTML5_Cite") { Middleware.InsertCSS_HTML5_item(this, "cite"); return; }
            if (mnName == "mnCSS_HTML5_Code") { Middleware.InsertCSS_HTML5_item(this, "code"); return; }
            if (mnName == "mnCSS_HTML5_DEL") { Middleware.InsertCSS_HTML5_item(this, "del"); return; }
            if (mnName == "mnCSS_HTML5_DL") { Middleware.InsertCSS_HTML5_item(this, "dl"); return; }
            if (mnName == "mnCSS_HTML5_Dfn") { Middleware.InsertCSS_HTML5_item(this, "dfn"); return; }
            if (mnName == "mnCSS_HTML5_Em") { Middleware.InsertCSS_HTML5_item(this, "em"); return; }
            if (mnName == "mnCSS_HTML5_I") { Middleware.InsertCSS_HTML5_item(this, "i"); return; }
            if (mnName == "mnCSS_HTML5_Ins") { Middleware.InsertCSS_HTML5_item(this, "ins"); return; }
            if (mnName == "mnCSS_HTML5_Kdb") { Middleware.InsertCSS_HTML5_item(this, "kdb"); return; }
            if (mnName == "mnCSS_HTML5_Mark") { Middleware.InsertCSS_HTML5_item(this, "mark"); return; }
            if (mnName == "mnCSS_HTML5_Q") { Middleware.InsertCSS_HTML5_item(this, "q"); return; }
            if (mnName == "mnCSS_HTML5_S") { Middleware.InsertCSS_HTML5_item(this, "s"); return; }
            if (mnName == "mnCSS_HTML5_Samp") { Middleware.InsertCSS_HTML5_item(this, "samp"); return; }
            if (mnName == "mnCSS_HTML5_Small") { Middleware.InsertCSS_HTML5_item(this, "small"); return; }
            if (mnName == "mnCSS_HTML5_Strong") { Middleware.InsertCSS_HTML5_item(this, "strong"); return; }
            if (mnName == "mnCSS_HTML5_U") { Middleware.InsertCSS_HTML5_item(this, "u"); return; }
            if (mnName == "mnCSS_HTML5_Var") { Middleware.InsertCSS_HTML5_item(this, "var"); return; }
            if (mnName == "mnCSS_HTML5_Wbr") { Middleware.InsertCSS_HTML5_item(this, "abbr"); return; }

            if (mnName == "mnCSS_HTML5_Summary") { Middleware.InsertCSS_HTML5_item(this, "summary"); return; }
            if (mnName == "mnCSS_HTML5_Details") { Middleware.InsertCSS_HTML5_item(this, "details"); return; }

            if (mnName == "mnCSS_HTML5_Transition_Ease") { Middleware.InsertCSS_HTML5_InsertTransition(this, "ease"); return; }
            if (mnName == "mnCSS_HTML5_Transition_Ease_In") { Middleware.InsertCSS_HTML5_InsertTransition(this, "ease-in"); return; }
            if (mnName == "mnCSS_HTML5_Transition_Ease_Out") { Middleware.InsertCSS_HTML5_InsertTransition(this, "ease-out"); return; }
            if (mnName == "mnCSS_HTML5_Transition_Ease_In_Out") { Middleware.InsertCSS_HTML5_InsertTransition(this, "ease-in-out"); return; }

            if (mnName == "mnCSS_HTML5_AnimationBlock") { Middleware.InsertCSS_HTML5_InsertAnimationBlock(this); return; }
            if (mnName == "mnCSS_HTML5_keyframesFromTo") { Middleware.InsertCSS_HTML5_InsertkeyframesFromTo(this); return; }
            if (mnName == "mnCSS_HTML5_keyframesProzent") { Middleware.InsertCSS_HTML5_InsertkeyframesProzent(this); return; }



            if (mnName == "mnCSS_HTML5_Transform_Rotate") { Middleware.CSS_HTML5_Transform_Rotate(this); return; }

            if (mnName == "mnCSS_HTML5_Transform_TranslateX") { Middleware.CSS_HTML5_Transform_TranslateX(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_TranslateY") { Middleware.CSS_HTML5_Transform_TranslateY(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_TranslateXY") { Middleware.CSS_HTML5_Transform_TranslateXY(this); return; }

            if (mnName == "mnCSS_HTML5_Transform_ScaleX") { Middleware.CSS_HTML5_Transform_ScaleX(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_ScaleY") { Middleware.CSS_HTML5_Transform_ScaleY(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_ScaleXY") { Middleware.CSS_HTML5_Transform_ScaleXY(this); return; }

            if (mnName == "mnCSS_HTML5_Transform_SkewX") { Middleware.CSS_HTML5_Transform_SkewX(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_SkewY") { Middleware.CSS_HTML5_Transform_SkewY(this); return; }
            if (mnName == "mnCSS_HTML5_Transform_SkewXY") { Middleware.CSS_HTML5_Transform_SkewXY(this); return; }


            // mn2 = createMenuItem(mn1, "mainCSSHTML5_Gradient", "Background-gradient");
            // mn3 = createMenuItem(mn2, "mainCSSHTML5_Lin_Gradient", "Linear-gradient");
            //                                                                                           background:linear-gradient(to top, green 0%, blue 100%);
            if (mnName == "mnCSS_HTML5_Lin_Gradient1") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to top, green 0%, blue 100%);"); return; }

            if (mnName == "mnCSS_HTML5_Lin_Gradient2") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to top right, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient3") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to right, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient4") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to bottom right, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient5") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to bottom, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient6") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to bottom left, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient7") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to left, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient8") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(to top left, green 0%, blue 100%);"); return; }
            if (mnName == "mnCSS_HTML5_Lin_Gradient9") { Middleware.InsertCSS_HTML5_Gradient(this, "background:linear gradient(45deg, green 0%, blue 100%);"); return; }


            // mn3 = createMenuItem(mn2, "mainCSSHTML5_Radial_Gradient", "Radial-gradient");
            if (mnName == "mnCSS_HTML5_Radial_Gradient1") {
                Middleware.InsertCSS_HTML5_Gradient(this, "background:radial-gradient(red, yellow, green);"); return;
            }
            if (mnName == "mnCSS_HTML5_Radial_Gradient2") {
                Middleware.InsertCSS_HTML5_Gradient(this, "/* farthest-side farthest-corner */\r\nbackground:radial-gradient(ellipse farthest-side at 100px 300px, white, yellow, green);"); return;
            }
            if (mnName == "mnCSS_HTML5_Radial_Gradient3") {
                Middleware.InsertCSS_HTML5_Gradient(this, "/* farthest-side farthest-corner */\r\nbackground:radial-gradient(circle, red, yellow, green);"); return;
            }


            // mn3 = createMenuItem(mn2, "mainCSSHTML5_Size_Gradient", "Radial Size-gradient");
            if (mnName == "mnCSS_HTML5_Size_Gradient1") { Middleware.InsertCSS_HTML5_Gradient(this, "background:radial-gradient(ellipse closest-side at 45px 45px ,red, yellow, green);"); return; }
            if (mnName == "mnCSS_HTML5_Size_Gradient2") { Middleware.InsertCSS_HTML5_Gradient(this, "background:radial-gradient(ellipse closest-corner at 45px 45px ,red, yellow, green);"); return; }
            if (mnName == "mnCSS_HTML5_Size_Gradient3") { Middleware.InsertCSS_HTML5_Gradient(this, "background:radial-gradient(ellipse farthest-side at 45px 45px ,red, yellow, green);"); return; }
            if (mnName == "mnCSS_HTML5_Size_Gradient4") { Middleware.InsertCSS_HTML5_Gradient(this, "background:radial-gradient(ellipse farthest-corner at 45px 45px ,red, yellow, green);"); return; }

            #endregion
            // InsertCSS_HTML5_InsertTransform_Scale
        }  // mnClick


        private void  createmenus(TextBoxTyp editorTyp) {
            MenuItem mn, mn1, mn2, mn3;

            switch (editorTyp) {
                    case TextBoxTyp.HTML:
                        mn1 = createMenuItem(null, "mainHTML", "Basic html");
                        mainMenu.Items.Add(mn1);

                        mn2 = createMenuItem(mn1, "mainInsertHTMLBasic", "Basic pattern (strukture)");
                mn = createMenuItem(mn2, "mnInsertHTML_Basic_XHTML_strict11", "with doctype for new CSS-pages, XHTML (Version 1.01)");
                mn = createMenuItem(mn2, "mnInsertHTML_HTML5_strict11", "HTML5 Strict");
                mn = createMenuItem(mn2, "mnInsertHTML_Basic_XHTML", "With doctype for new CSS-pages, XHTML (HTML Version 4.01)");
                mn = createMenuItem(mn2, "mnInsertHTML_HTML4", "With doctype for old pages");
                mn = createMenuItem(mn2, "mnInsertHTML_Basic_Pur", "only HTML, without doctype");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertHTML_Header1_6", "Header (h1..h6)");
                mn = createMenuItem(mn1, "mnInsertHTML_Paragraph", "_Paragraph");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainHTML_ListeSub", "Lists");
                mn = createMenuItem(mn2, "mnInsertHTML_UL", "Unordered list");
                mn = createMenuItem(mn2, "mnInsertHTML_OL", "Ordered list (numeric list)");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainHTML_TableSub", "Tables");
                mn = createMenuItem(mn2, "mnInsertHTML_Table", "Insert table");
                mn = createMenuItem(mn2, "mnInsertHTML_TR", "Insert a row");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertHTML_HR", "Horizontal row");
                mn = createMenuItem(mn1, "mnInsertHTML_FontColor", "Colordialog (hexadecimal)");
                mn = createMenuItem(mn1, "mnInsertHTML_CSS_ColorConstant", "Color from constant of text");
                mn = createMenuItem(mn1, "mnInsertHTML_Comment", "Comment");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainLinks", "Links");
                mn = createMenuItem(mn2, "mnInsertHTML_EMailLink", "Link for an email");
                mn = createMenuItem(mn2, "mnInsertHTML_Link", "Link");
                mn = createMenuItem(mn2, "mnInsertHTML_Anchor", "Anchor");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainImages", "Images");
                mn = createMenuItem(mn2, "mnInsertImages", "Images");
                mn = createMenuItem(mn2, "mnInsertImageCoords", "Images-Coords");

                mn = createMenuItem(mn2, "mnImagesCoordsausSHWFile", "Images-Coords from a shw-file");


                mn1 = createMenuItem(null, "mainFonts", "Fonts");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertHTML_Font_Bold", "Bold");
                mn = createMenuItem(mn1, "mnInsertHTML_Font_Italic", "Italic (kursiv)");
                mn = createMenuItem(mn1, "mnInsertHTML_Font_Sup", "Sup");
                mn = createMenuItem(mn1, "mnInsertHTML_Font_Sub", "Sub");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainFont_SpezialChars", "Spezial chars");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Space", "Space (&#x0020;)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Tab", "Tab (&#x0009;)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_CR", "Carriage Return (&#x000D;)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_LF", "Line Feed (&#x000A;)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Blank", "Non breaking space");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Dash", "Character separator");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Copyright", "Copyright (c)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Copyright_R", "Copyright (R)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Trademark", "Trademark TM");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_LT", "< (less than)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_GT", "> (greater than)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_LTLT", "<< (less than)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_GTGT", ">> (greater than)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Ampersand", "& (Ampersand)");


                mn2 = createMenuItem(mn1, "mainFont_Umlaute", "Special german chars");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Ae", "Ä");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Oe", "Ö");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_Ue", "Ü");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_ae", "ä");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_oe", "ö");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_ue", "ü");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_Char_ss", "ß");

                mn2 = createMenuItem(mn1, "mainFont_Anfuehrungszeichen", "quotation mark chars");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_doublequotationmarkfirst", "double quotation mark (first)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_doublequotationmarkend", "double quotation mark (end)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_singlequotationmarkfirst", "single quotation mark (first)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_singlequotationmarkend", "single quotation mark (end)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_anglequotationmarkfirst", "angle quotation mark (<<)");
                mn = createMenuItem(mn2, "mnInsertHTML_Font_anglequotationmarkend", "angle quotation mark (>>)");


                mn1 = createMenuItem(null, "mainCSS", "CSS");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertHTML_CSSReferenzExtern", "Insert CSS-reference extern");
                mn = createMenuItem(mn1, "mnInsertHTML_CSSReferenzLocal", "Insert CSS-reference local");
                mn = createMenuItem(mn1, "mnInsertCSS_Body", "CSS-basic structure");
                mn = createMenuItem(mn1, "mnInsertCSS_xx", "Empty selector");

                mn2 = createMenuItem(mn1, "mainCSSBsp", "Complete CSS selectors");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_H2", "H2");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_OL", "OL");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_UL", "UL");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_TH", "TH");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_TD", "TD");


                mn = createMenuItem(mn1, "mnInsert_HTMLBlock_Scrolling", "Scrolling selector");

                mn2 = createMenuItem(mn1, "mainCSS_Image", "Images in the body");
                mn = createMenuItem(mn2, "mnInsertCSS_background_image", "Body: background-image");
                mn = createMenuItem(mn2, "mnInsertCSS_Body_backgroundrepeat", "Body: background-repeat");
                mn = createMenuItem(mn2, "mnInsertCSS_Bodybackgroundattachment", "Body: background-attachment");
                mn = createMenuItem(mn2, "mnInsertCSS_Body_backgroundposition", "Body: background-position");

                mn2 = createMenuItem(mn1, "mainCSS_Colors", "Colors");
                mn = createMenuItem(mn2, "mnInsertHTML_CSS_ColorConstant", "Color from constant of text");
                mn = createMenuItem(mn2, "mnInsertCSS_Farbe", "Colordialog (hexadecimal)");
                mn = createMenuItem(mn2, "mnInsert_CSS_Backgroundcolor", "Background color");

                mn2 = createMenuItem(mn1, "mainCSS_Fonts", "Fonts");
                mn = createMenuItem(mn2, "mnInsertCSS_Schrift12em", "Size=1,2em");
                mn = createMenuItem(mn2, "mnInsertCSS_FontColor", "Font color");
                mn = createMenuItem(mn2, "mnInsertCSS_FontWeight", "Font weight");

                mn3 = createMenuItem(mn2, "mainCSS_Fonts", "Fonttype");
                mn = createMenuItem(mn3, "mnInsertCSS_VerdanaArialHelveticaSwiss", "Verdana, Arial, Helvetica, Swiss");
                mn = createMenuItem(mn3, "mnInsertCSS_CourierNew", "Courier New");
                mn = createMenuItem(mn3, "mnInsertCSS_Monospace", "Monospace");

                mn3 = createMenuItem(mn2, "mainInsertCSS_SmallFont", "relative Fontsize");
                mn = createMenuItem(mn3, "mnInsertCSS_SmallestFont", "Smallest font");
                mn = createMenuItem(mn3, "mnInsertCSS_SmallerFont", "Smaller");
                mn = createMenuItem(mn3, "mnInsertCSS_BiggerFont", "Greater");
                mn = createMenuItem(mn3, "mnInsertCSS_BigFont", "Big font");
                mn = createMenuItem(mn3, "mnInsertCSS_FontSize_15Em2", "Font greater as (em)");
                mn = createMenuItem(mn3, "mnInsertCSS_Bigger_Percentage", "Font greater as (%)");


                mn = createMenuItem(mn2, "mnInsertCSS_WordSpacing", "Word-Spacing");
                mn = createMenuItem(mn3, "mnInsertCSS_LetterSpacing", "Letter-Spacing");

                mn3 = createMenuItem(mn2, "mainInsertCSS_Textdecoration", "Text-decoration");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_None", "None");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_Underline", "Underline");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_Overline", "Overline");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_Linethrough", "Struck through");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_Blinkend", "Flashing");
                mn = createMenuItem(mn3, "mnInsertCSS_Textdecoration_Italic", "Italic/kursiv");

                mn3 = createMenuItem(mn2, "mainInsertCSS_Texttransform", "Text-transform");
                mn = createMenuItem(mn3, "mnInsertCSS_Texttransform_None", "None");
                mn = createMenuItem(mn3, "mnInsertCSS_Texttransform_Uppercase", "Uppercase");
                mn = createMenuItem(mn3, "mnInsertCSS_Texttransform_Lowercase", "Lowercase");
                mn = createMenuItem(mn3, "mnInsertCSS_Texttransform_Capitalize", "Capitalize");

                                createMenuItem(mn2, "mnInsertCSS_Text_Indent", "Text-indent (Texteinrückung)");


                mn2 = createMenuItem(mn1, "mainCSS_Lists", "Lists");
                mn3 = createMenuItem(mn2, "mainCSS_Lists_UL", "Ul");
                mn = createMenuItem(mn3, "mnCSS_Lists_UL_None", "None");
                mn = createMenuItem(mn3, "mnCSS_Lists_UL_Circle", "Circle");
                mn = createMenuItem(mn3, "mnCSS_Lists_UL_Square", "Square");
                mn = createMenuItem(mn3, "mnCSS_Lists_UL_Disc", "Disc");

                mn3 = createMenuItem(mn2, "mainCSS_Lists_OL", "Ol");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_None", "None");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Decimal", "Decimal");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Decimalleadingzero", "Decimal-leading-zero");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Lowerroman", "Lower-roman");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Upperroman", "Upper-roman");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Lowergreek", "Lower-greek");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Lowerlatin", "Lower-latin");
                mn = createMenuItem(mn3, "mnCSS_Lists_OL_Upperlatin", "Upper-latin");

                mn3 = createMenuItem(mn2, "mainCSS_Lists_Liststyleposition", "List-style-position");
                mn = createMenuItem(mn3, "mnCSS_Lists_Inside", "Inside");
                mn = createMenuItem(mn3, "mnCSS_Lists_Outside", "Outside");

                mn2 = createMenuItem(mn1, "mainCSS_Tables", "Tables");
                mn = createMenuItem(mn2, "mnInsertCSS_TR", "Tr");
                mn = createMenuItem(mn2, "mnInsertCSS_TH", "Th");
                mn = createMenuItem(mn2, "mnInsertCSS_TD", "Td");
                mn = createMenuItem(mn2, "mnInsertCSS_Table_th_td_Border", "Table with border");
                mn = createMenuItem(mn2, "mnInsertCSS_Table_css_hover", "Table with css hover");

                // flexlayout

                mn = createMenuItem(mn2, "mnInsertCSS_TH", "Th");
                mn = createMenuItem(mn2, "mnInsertCSS_TD", "Td");
                mn = createMenuItem(mn2, "mnInsertCSS_Table_th_td_Border", "Table with border");
                mn = createMenuItem(mn2, "mnInsertCSS_Table_css_hover", "Table with css hover");



                mn2 = createMenuItem(mn1, "mainCSS_Borders", "Borders");
                mn = createMenuItem(mn2, "mnInsertCSS_BorderColor", "Color of a border");
                mn3 = createMenuItem(mn2, "mainInsertCSS_BorderStyles", "Border-Styles");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_None", "None");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Hidden", "Hidden");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Dotted", "Dotted");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Dashed", "Dashed");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Solid", "Solid");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Double", "Double");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Groove", "Groove");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Ridge", "Ridge");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Inset", "Inset");
                mn = createMenuItem(mn3, "mnInsertCSS_Border_Outset", "Outset");

                mn = createMenuItem(mn1, "mnInsertCSS_BorderWidth", "Border-Width");
                // CSS-Datei

                mn2 = createMenuItem(mn1, "mainInsertCSS_Padding", "Padding (Innenrand)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_OneForFour", "One value for all paddings");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_TwoForTwo", "Two values for all paddings (top/bottom  und left/right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_FourForFour", "Four values for all paddings (top,bottom,left,right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Top", "Padding-top");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Left", "Padding-left");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Bottom", "Padding-Bottom");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Right", "Padding-right");

                mn2 = createMenuItem(mn1, "mainInsertCSS_Margin", "Margin (Außenrand)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_OneForFour", "One value for all margins");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_TwoForTwo", "Two values for all margins (top/bottom  und left/right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_FourForFour", "Four values for all margins (top,bottom,left,right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Top", "Margin-top");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Left", "Margin-left");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Bottom", "Margin-Bottom");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Right", "Margin-right");

                mn2 = createMenuItem(mn1, "mainCSS_Links", "Links");
                mn = createMenuItem(mn2, "mnCSS_Links_NoneVisited", "None visited");
                mn = createMenuItem(mn2, "mnCSS_Links_Visited", "Visited");
                mn = createMenuItem(mn2, "mnCSS_Links_Activate", "Activate");
                mn = createMenuItem(mn2, "mnCSS_Links_ThreeLinks", "All three types of links (separate)");
                mn = createMenuItem(mn2, "mnCSS_Links_ThreeLinksTogether", "All three types of links (together)");

                mn2 = createMenuItem(mn1, "mainCSS_HAlign", "Horizontal Alignment");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Left", "Left");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Center", "Center");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Right", "Right");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Justify", "Justify (Blocksatz)");

                mn2 = createMenuItem(mn1, "mainnCSS_VAlign", "Vertical Alignment");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Baseline", "Baseline");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sub", "Sub");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sup", "Sup");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sub03em", "-0.3em");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sup03em", "+0.3em");


                mn = createMenuItem(mn2, "mnCSS_VAlign_Texttop", "Text-top");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Textbottom", "Text-bottom");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Middle", "Middle");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Top", "Top");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Bottom", "Bottom");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Percentage", "Percentage");

                mn = createMenuItem(mn1, "mnCSS_FieldsetLegend", "Fieldset/Legend");

                mn = createMenuItem(mn1, "mnCSS_GridlayoutDialog", "Gridlayout (label / input text)");
                mn = createMenuItem(mn1, "mnCSS_Flexlayout1", "Flexlayout (label / input text)");
                mn = createMenuItem(mn1, "mnCSS_Flexlayout2", "Flexlayout (input text / input text)");



                mn1 = createMenuItem(null, "mainForms", "_Forms");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertForm_Formrange1", "Insert form sector");
                mn = createMenuItem(mn1, "mnInsertForm_Formrange2", "Insert form sector with action-script");
                mn1.Items.Add(new Separator());

                    mn = createMenuItem(mn1, "mnInsertForm_FieldsetLegend", "Fieldset / Legend");

                mn2 = createMenuItem(mn1, "mainnForm_Layout", "Layouts");
                mn = createMenuItem(mn2, "mnInsertForm_Gridlayout1", "Grid Layout (label/input text)");
                mn = createMenuItem(mn2, "mnInsertForm_Flexlayout1", "Flex Layout (label/input text)");
                mn = createMenuItem(mn2, "mnInsertForm_Flexlayout2", "Flex Layout (input text / input text)");
                mn1.Items.Add(new Separator());

                                mn = createMenuItem(mn1, "mnInsertForm_Label", "Label");
                mn = createMenuItem(mn1, "mnInsertForm_Textfeld", "Simple textfield");
                mn = createMenuItem(mn1, "mnInsertForm_Textfeld2", "Textfield with properties");
                mn = createMenuItem(mn1, "mnInsertForm_TextfeldPattern", "Textfield with pattern");
                mn = createMenuItem(mn1, "mnInsertForm_Textarea", "Textarea (mehrzeiligen Editor)");
                mn = createMenuItem(mn1, "mnInsertForm_Hidden", "Hidden element");
                mn = createMenuItem(mn1, "mnInsertForm_CheckBox", "CheckBox");
                mn = createMenuItem(mn1, "mnInsertForm_MultiCheckBox", "Multi-CheckBox");


                mn = createMenuItem(mn1, "mnInsertForm_RadioButton", "RadioButton");
                mn = createMenuItem(mn1, "mnInsertForm_ComboBox", "ComboBox / List");
                mn = createMenuItem(mn1, "mnInsertForm_Password", "Password");
                mn = createMenuItem(mn1, "mnHTML5_Formelements_Number", "Number");
                mn = createMenuItem(mn1, "mnHTML5_Formelements_div_ajax", "div Ajax");

                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainForm_Event", "Events");
                mn = createMenuItem(mn2, "mnForm_Event_onClick", "OnClick");
                mn = createMenuItem(mn2, "mnForm_Event_onDblclick", "OnDblclick");
                mn = createMenuItem(mn2, "mnForm_Event_onMouseDown", "OnMousedDown");
                mn = createMenuItem(mn2, "mnForm_Event_onMouseUp", "OnMouseUp");
                mn = createMenuItem(mn2, "mnForm_Event_onMouseOver", "OnMouseOver");
                mn = createMenuItem(mn2, "mnForm_Event_onMouseMove", "OnMouseMove");
                mn = createMenuItem(mn2, "mnForm_Event_onMouseOut", "OnMouseOut");
                mn = createMenuItem(mn2, "mnForm_Event_onFocus", "OnFocus");
                mn = createMenuItem(mn2, "mnForm_Event_onBlur", "OnBlur (outFocus)");
                mn = createMenuItem(mn2, "mnForm_Event_onKeypress", "OnKeypress");
                mn = createMenuItem(mn2, "mnForm_Event_onKeydown", "OnKeydown");
                mn = createMenuItem(mn2, "mnForm_Event_onKeypup", "OnKeypup");
                mn = createMenuItem(mn2, "mnForm_Event_onSubmit", "OnSubmit");
                mn = createMenuItem(mn2, "mnForm_Event_onReset", "OnReset");
                mn = createMenuItem(mn2, "mnForm_Event_onSelect", "OnSelect");
                mn = createMenuItem(mn2, "mnForm_Event_onChange", "OnChange");

                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertForm_Submit", "Submit button");
                mn = createMenuItem(mn1, "mnInsertForm_Button", "Button button");
                mn = createMenuItem(mn1, "mnInsertForm_Reset", "Reset button");

                    mn = createMenuItem(mn1, "mnInsertForm_onSubmitEvent", "Submit-Schalter mit onSubmit-Event");

                    

                mn = createMenuItem(mn1, "mnInsertForm_SubmitFormAction", "Submit button (FormAction)");


                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainInsertCSS_Input", "Input");
                mn = createMenuItem(mn2, "mainInsertCSS_Input_required", "input:required");
                mn = createMenuItem(mn2, "mainInsertCSS_Input_invalid", "input:invalid");

                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertForm_CompletSample", "Complete sample");


                mn1 = createMenuItem(null, "mainJavaScript", "_Java script");
                mainMenu.Items.Add(mn1);
                mn = createMenuItem(mn1, "mnJavaScript_InsertSector", "Insert Java-script sector");
                mn = createMenuItem(mn1, "mnJavaScript_IncludeJavascript", "Include Javascript (statisch)");

                mn1.Items.Add(new Separator());
                //mn2 = createMenuItem(mn1, "mainJavaScript_form", "form");
                mn = createMenuItem(mn1, "mnJavaScript_FormArray", "Get form-Array");

                    mn2 = createMenuItem(mn1, "mainJavaScript_form", "validation");
                    mn = createMenuItem(mn2, "mnJavaScript_FormValidation", "form validation");

                    mn = createMenuItem(mn2, "mnJavaScript_validation","Insert Validation Script");

                mn1.Items.Add(new Separator());
                mn = createMenuItem(mn1, "mnJavaScript_Function", "function");
                mn = createMenuItem(mn1, "mnJavaScript_Consolelog", "console.log");

                    mn1.Items.Add(new Separator());
                    // Bietz
                    mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_jQuery", "jQuery");
                mn = createMenuItem(mn2, "mnJavaScript_jQuery_link", "jQuery Include Link");
                mn = createMenuItem(mn2, "mnJavaScript_jQuery_ajax", "jQuery AJAX Struktur");


                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_Event", "Events");
                mn = createMenuItem(mn2, "mnJavaScript_Event_onload", "Onload");
                mn = createMenuItem(mn2, "mnJavaScript_Event_onUnload", "OnUnload");

                mn1.Items.Add(new Separator());
                mn2 = createMenuItem(mn1, "mainJavaScript_ajax", "AJAX");
                mn = createMenuItem(mn2, "mnJavaScript_ajaxStructur", "Ajax Structur");
                mn2.Items.Add(new Separator());

                mn = createMenuItem(mn2, "mnJavaScript_ajax_getElementById", "getElementById");

                mn = createMenuItem(mn2, "mnJavaScript_ajax_getElementsByClassName", "getElementsByClassName");
                mn = createMenuItem(mn2, "mnJavaScript_ajax_getElementsByName", "getElementsByName");
                mn = createMenuItem(mn2, "mnJavaScript_ajax_getElementsByTagName", "getElementsByTagName");



                mn = createMenuItem(mn2, "mnJavaScript_ajax_innerhtml", "innerHTML");
                mn = createMenuItem(mn2, "mnJavaScript_jsonforloop", "Json for each loop");
                mn1.Items.Add(new Separator());


                mn2 = createMenuItem(mn1, "mainJavaScript_AccessUI", "Access to form-elements in java-script");
                mn = createMenuItem(mn2, "mnJavaScript_Access_form0", " get form[0]");
                mn = createMenuItem(mn2, "mnJavaScript_Access_formName", " get form with name");
                mn = createMenuItem(mn2, "mnJavaScript_Access_textValue", " text value");
                mn = createMenuItem(mn2, "mnJavaScript_Access_checkbox", " checkbox");
                mn = createMenuItem(mn2, "mnJavaScript_Access_multicheckbox", " multi checkbox");
                mn = createMenuItem(mn2, "mnJavaScript_Access_radiobutton", " radiobutton");
                mn = createMenuItem(mn2, "mnJavaScript_Access_comboboxSingle", " combobox single-selection");
                mn = createMenuItem(mn2, "mnJavaScript_Access_comboboxMultiple", " combobox multiple-selection");


                mn2 = createMenuItem(mn1, "mainJavaScript_IfWhile", "If/While/Switch");
                mn = createMenuItem(mn2, "mnJavaScript_If", "If");
                mn = createMenuItem(mn2, "mnJavaScript_If_Else", "If else");
                mn = createMenuItem(mn2, "mnJavaScript_Dowhile", "Do...while");
                mn = createMenuItem(mn2, "mnJavaScript_While", "While");
                mn = createMenuItem(mn2, "mnJavaScript_For_i", "For (i)");
                mn = createMenuItem(mn2, "mnJavaScript_Foreach", "Foreach (i)");
                mn = createMenuItem(mn2, "mnJavaScript_ForeachOf", "Foreach (x of list)");

                mn = createMenuItem(mn2, "mnJavaScript_Switch", "Switch");
                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_Numeric", "Parse / isNaN");
                mn = createMenuItem(mn2, "mnJavaScript_ParseInt", "ParseInt");
                mn = createMenuItem(mn2, "mnJavaScript_ParseFloat", "ParseFloat");
                mn = createMenuItem(mn2, "mnJavaScript_isNaN", "IsNaN");

                mn2 = createMenuItem(mn1, "mainJavaScript_StringMethode", "String methods");
                mn = createMenuItem(mn2, "mnJavaScript_charAt", "charAt");
                mn = createMenuItem(mn2, "mnJavaScript_charCodeAt", "charCodeAt");
                mn = createMenuItem(mn2, "mnJavaScript_concat", "concat");
                mn = createMenuItem(mn2, "mnJavaScript_length", "length");


                mn = createMenuItem(mn2, "mnJavaScript_fromCharCode", "String.fromCharCode (65 return A)");
                mn = createMenuItem(mn2, "mnJavaScript_indexOf", "indexOf");
                mn = createMenuItem(mn2, "mnJavaScript_lastIndexOf", "lastIndexOf");
                mn = createMenuItem(mn2, "mnJavaScript_localeCompare", "localeCompare");
                mn = createMenuItem(mn2, "mnJavaScript_match", "match");
                mn = createMenuItem(mn2, "mnJavaScript_replace", "replace");
                mn = createMenuItem(mn2, "mnJavaScript_replaceAll", "replace all");


                mn = createMenuItem(mn2, "mnJavaScript_search", "search");
                mn = createMenuItem(mn2, "mnJavaScript_slice", "slice");
                mn = createMenuItem(mn2, "mnJavaScript_split", "split");
                mn = createMenuItem(mn2, "mnJavaScript_substr", "substr (start<= ch <= end)");
                mn = createMenuItem(mn2, "mnJavaScript_substring", "substring (start<= ch < end)");
                mn = createMenuItem(mn2, "mnJavaScript_toLocaleLowerCase", "toLocaleLowerCase");
                mn = createMenuItem(mn2, "mnJavaScript_toLocaleUpperCase", "toLocaleUpperCase");
                mn = createMenuItem(mn2, "mnJavaScript_toLowerCase", "toLowerCase");
                mn = createMenuItem(mn2, "mnJavaScript_toString", "toString");
                mn = createMenuItem(mn2, "mnJavaScript_toUpperCase", "toUpperCase");
                mn = createMenuItem(mn2, "mnJavaScript_trim", "trim");
                mn = createMenuItem(mn2, "mnJavaScript_valueOf", "valueOf");

                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_Arrays", "Arrays");
                mn = createMenuItem(mn2, "mnJavaScript_Arrays_createArray", "create an array");
                mn = createMenuItem(mn2, "mnJavaScript_Arrays_createMultidimArray", "create a Multidim-Array");
                mn = createMenuItem(mn2, "mnJavaScript_lengthArray", "get length of an array");
                mn = createMenuItem(mn2, "mnJavaScript_Arrays_pushArray", "add element to an array");
                mn = createMenuItem(mn2, "mnJavaScript_Arrays_sliceArray", "delete element from an array");

                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_Class", "Class");
                mn = createMenuItem(mn2, "mnJavaScript_Class_createClass", "create Class");
                mn = createMenuItem(mn2, "mnJavaScript_Class_StaticAttribut", "insert static attribut");

                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_NumberMethoden", "Number methods");
                mn = createMenuItem(mn2, "mnJavaScript_toExponential", "toExponential");
                mn = createMenuItem(mn2, "mnJavaScript_toFixed", "toFixed (Nachkommazahlen)");
                mn = createMenuItem(mn2, "mnJavaScript_toPrecision", "toPrecision");
                mn = createMenuItem(mn2, "mnJavaScript_toString", "toString");
                mn = createMenuItem(mn2, "mnJavaScript_komma2Point", "Komma2Point");

                mn2 = createMenuItem(mn1, "mainJavaScript_MathMethoden", "Math constants");
                mn = createMenuItem(mn2, "mnJavaScript_E", "e = 2.718281828459045");
                mn = createMenuItem(mn2, "mnJavaScript_LN2", "ln(2) = 0.6931471805599453");
                mn = createMenuItem(mn2, "mnJavaScript_Ln10", "ln(10) = 2.302585092994046");
                mn = createMenuItem(mn2, "mnJavaScript_Ln2e", "log2(e) = 1.4426950408889634");
                mn = createMenuItem(mn2, "mnJavaScript_Log10E", "lg(e) = 0.4342944819032518");
                mn = createMenuItem(mn2, "mnJavaScript_Pi", "Pi = 3.141592653589793");
                mn = createMenuItem(mn2, "mnJavaScript_Sqrt1_2", "Sqrt(1/2) = 0.7071067811865476");
                mn = createMenuItem(mn2, "mnJavaScript_Sqrt2", "Sqrt(2) = 1.4142135623730951");

                mn2 = createMenuItem(mn1, "mainJavaScript_MathMethoden", "Math methods");
                mn = createMenuItem(mn2, "mnJavaScript_Abs", "abs(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Acos", "acos(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Asin", "asin(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Atan", "atan(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Atan2", "atan2(y,x)");
                mn = createMenuItem(mn2, "mnJavaScript_Ceil", "ceil(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Cos", "cos(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Exp", "exp(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Floor", "floor(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Log", "log(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Max", "max(x,y,z,...,n)");
                mn = createMenuItem(mn2, "mnJavaScript_Min", "min(x,y,z,...,n)");
                mn = createMenuItem(mn2, "mnJavaScript_Pow", "pow(x,y)  x^y");
                mn = createMenuItem(mn2, "mnJavaScript_Random1", "random()");
                mn = createMenuItem(mn2, "mnJavaScript_Random2", "  Math.floor( random()*10 );");
                mn = createMenuItem(mn2, "mnJavaScript_Round", "round(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Sin", "sin(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Sqrt", "sqrt(x)");
                mn = createMenuItem(mn2, "mnJavaScript_Tan", "tan(x)");

                mn2 = createMenuItem(mn1, "mainJavaScript_Array", "Array methods");
                mn = createMenuItem(mn2, "mnJavaScript_Concat", "concat");
                mn = createMenuItem(mn2, "mnJavaScript_length", "length");
                mn = createMenuItem(mn2, "mnJavaScript_IndexOf", "indexOf");
                mn = createMenuItem(mn2, "mnJavaScript_Join", "join");
                mn = createMenuItem(mn2, "mnJavaScript_LastIndexOf", "lastIndexOf");
                mn = createMenuItem(mn2, "mnJavaScript_Pop", "pop (remove last)");
                mn = createMenuItem(mn2, "mnJavaScript_Push", "push (add at end)");
                mn = createMenuItem(mn2, "mnJavaScript_Reverse", "reverse");
                mn = createMenuItem(mn2, "mnJavaScript_Shift", "shift (remove first)");
                mn = createMenuItem(mn2, "mnJavaScript_Slice", "slice (part of array)");
                mn = createMenuItem(mn2, "mnJavaScript_Sort", "sort");
                mn = createMenuItem(mn2, "mnJavaScript_Splice", "splice (add/remove)");
                mn = createMenuItem(mn2, "mnJavaScript_Unshift", "unshift (add at begin)");

                mn2 = createMenuItem(mn1, "mainJavaScript_Dates", "date methods");
                mn3 = createMenuItem(mn2, "mainJavaScript_GetMethods", "get methods");
                mn = createMenuItem(mn3, "mnJavaScript_GetDate", "getDate (actual date)");
                mn = createMenuItem(mn3, "mnJavaScript_GetDay", "getDay (from 0 to 6)");
                mn = createMenuItem(mn3, "mnJavaScript_GetFullYear", "getFullYear (4 digits)");
                mn = createMenuItem(mn3, "mnJavaScript_GetHours", "getHours");
                mn = createMenuItem(mn3, "mnJavaScript_GetMilliseconds", "getMilliseconds");
                mn = createMenuItem(mn3, "mnJavaScript_GetMinutes", "getMinutes");
                mn = createMenuItem(mn3, "mnJavaScript_GetSeconds", "getSeconds");
                mn = createMenuItem(mn3, "mnJavaScript_GetTime", "getTime");
                mn = createMenuItem(mn3, "mnJavaScript_GetTimezoneOffset", "getTimezoneOffset");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCDate", "getUTCDate (day of the universal time)");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCDay", "getUTCDay (day of week)");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCFullYear", "getUTCFullYear");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCHours", "getUTCHours");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCMilliseconds", "getUTCMilliseconds");

                mn = createMenuItem(mn3, "mnJavaScript_GetUTCMinutes", "getUTCMinutes");
                mn = createMenuItem(mn3, "mnJavaScript_GgetUTCMonth", "getUTCMonth");
                mn = createMenuItem(mn3, "mnJavaScript_GetUTCSeconds", "getUTCSeconds");
                mn = createMenuItem(mn3, "mnJavaScript_GetYear", "getYear");

                mn3 = createMenuItem(mn2, "mainJavaScript_SetMethods", "set methods");
                mn = createMenuItem(mn3, "mnJavaScript_SetDate", "setDate(15)  setday");
                mn = createMenuItem(mn3, "mnJavaScript_SetFullYear", "setFullYear");
                mn = createMenuItem(mn3, "mnJavaScript_SetHours", "setHours");
                mn = createMenuItem(mn3, "mnJavaScript_SetMilliseconds", "setMilliseconds");
                mn = createMenuItem(mn3, "mnJavaScript_SetMinutes", "setMinutes");
                mn = createMenuItem(mn3, "mnJavaScript_setMonth", "setMonth");
                mn = createMenuItem(mn3, "mnJavaScript_setSeconds", "setSeconds");
                mn = createMenuItem(mn3, "mnJavaScript_setTime", "setTime");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCDate", "setUTCDate(15)");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCFullYear", "setUTCFullYear(2017)");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCHours", "setUTCHours");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCMilliseconds", "setUTCMilliseconds");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCMinutes", "setUTCMinutes");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCMonth", "setUTCMonth");
                mn = createMenuItem(mn3, "mnJavaScript_setUTCSeconds", "setUTCSeconds");

                mn3 = createMenuItem(mn2, "mainJavaScript_ToMethods", "to methods");
                mn = createMenuItem(mn3, "mnJavaScript_toDateString", "toDateString");
                mn = createMenuItem(mn3, "mnJavaScript_toISOString", "toISOString (ISO Standard)");
                mn = createMenuItem(mn3, "mnJavaScript_toJSON", "toJSON (JSON Format)");
                mn = createMenuItem(mn3, "mnJavaScript_toLocaleDateString", "toLocaleDateString");
                mn = createMenuItem(mn3, "mnJavaScript_toLocaleTimeString", "toLocaleTimeString");
                mn = createMenuItem(mn3, "mnJavaScript_toLocaleString", "toLocaleString");
                mn = createMenuItem(mn3, "mnJavaScript_toString", "toString");
                mn = createMenuItem(mn3, "mnJavaScript_toTimeString", "toTimeString");
                mn = createMenuItem(mn3, "mnJavaScript_toUTCString", "toUTCString");

                mn = createMenuItem(mn2, "mnJavaScript_Parse", "parse(\"March 21, 2015\")");
                mn = createMenuItem(mn2, "mnJavaScript_UTC", "UTC, milliseconds 1,1,1970");

                mn1.Items.Add(new Separator());
                                mn2 = createMenuItem(mn1, "mainJavaScript_Window", "Window methods");
                mn = createMenuItem(mn2, "mnJavaScript_Show_Popupwindow", "insert popupwindow");
                mn = createMenuItem(mn2, "mnJavaScript_Location", "Location (next link)");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnJavaScript_regex", "Regex");


                mn1 = createMenuItem(null, "mainPHP", "_PHP");
                mainMenu.Items.Add(mn1);
                mn = createMenuItem(mn1, "mnPHP_InsertPHP_Sector", "PHP-sector");

                mn2 = createMenuItem(mn1, "mainPHP_isSet", "isSet...");
                mn = createMenuItem(mn2, "mnPHP_InsertPHP_ISSET", "Isset");

                mn = createMenuItem(mn2, "mnPHP_InsertcheckIssetInt", "InsertcheckIssetInt");
                    mn = createMenuItem(mn2, "mnPHP_InsertcheckIssetFloat", "InsertcheckIssetFloat");




                    mn = createMenuItem(mn2, "mnPHP_InsertPHP_issetSelectMultiple", "Isset Select multiple");
                mn = createMenuItem(mn2, "mnPHP_IsnumericInt", "Is_numeric (Int)");
                mn = createMenuItem(mn2, "mnPHP_IsnumericFloat", "Is_numeric (Float)");

                    mn = createMenuItem(mn2, "mnPHP_Intval", "Intval");
                mn = createMenuItem(mn2, "mnPHP_Floatval", "Floatval"); 

                    mn1.Items.Add(new Separator());
                mn2 = createMenuItem(mn1, "mainPHP_is", "is...");
                    mn = createMenuItem(mn2, "mnPHP_IsInt", "Is_int");
                    mn = createMenuItem(mn2, "mnPHP_IsFloat", "Is_float");
                    mn = createMenuItem(mn2, "mnPHP_IsBool", "Is_bool");
                    mn = createMenuItem(mn2, "mnPHP_IsString", "Is_string");
                    mn = createMenuItem(mn2, "mnPHP_IsArray", "Is_array");
                    mn = createMenuItem(mn2, "mnPHP_IsObject", "Is_object");

                    mn1.Items.Add(new Separator());

                    mn2 = createMenuItem(mn1, "mainPHPScript_IfWhile", "If/While/Switch");
                    mn = createMenuItem(mn2, "mnPHP_If", "If");
                    mn = createMenuItem(mn2, "mnPHP_If_Else", "If else");
                    mn = createMenuItem(mn2, "mnPHP_If_ElseIf", "If elseif else");
                    mn = createMenuItem(mn2, "mnPHP_Dowhile", "Do...while");
                    mn = createMenuItem(mn2, "mnPHP_While", "While");
                    mn = createMenuItem(mn2, "mnJavaScript_For_i", "For (i)");
                    mn = createMenuItem(mn2, "mnPHP_Foreach", "Foreach");
                    mn = createMenuItem(mn2, "mnPHP_Switch", "Switch");

                    mn2 = createMenuItem(mn1, "mainPHP_Arrays", "Arrays");
                    mn = createMenuItem(mn2, "mnPHP_Arrays_createArray", "create Array");  // $feld = array();
                    mn = createMenuItem(mn2, "mnPHP_Arrays_createArrayWithItems", "create Array with items");  // $cars = array("Volvo", "BMW", "Toyota");
                    mn = createMenuItem(mn2, "mnPHP_Arrays_createMultidimArray", "create Multidim-Array");  //

                    mn = createMenuItem(mn2, "mnPHP_Arrays_InsertPHP_Matrix", "Insert createMatrix");  //


                    mn = createMenuItem(mn2, "mnPHP_Arrays_pushArray", "add element to Array");  // $mitarbeiter[] = "Bob";
                    mn = createMenuItem(mn2, "mnPHP_Arrays_arrayLength", "Array length");  // count(feld)

                    mn = createMenuItem(mn2, "mnPHP_Arrays_foreach", "foreach Array");  // foreach ($blumen as $meine_blume)  echo $meine_blume,"<br />";


                    mn1.Items.Add(new Separator());

                mn2 = createMenuItem(mn1, "mainPHP_Class", "Class");
                mn = createMenuItem(mn2, "mnPHP_ClassResult", "Insert class Result");
                    mn = createMenuItem(mn2, "mnPHP_ClassNumber", "Insert class Number");
                    mn = createMenuItem(mn2, "mnPHP_Attribute", "PHP-Attribute (set/get)");

                mn1.Items.Add(new Separator());

                mn2 = createMenuItem(mn1, "mainPHP_Funktions", "Funktions");
                 mn = createMenuItem(mn2, "mnPHP_Function", "create a function");
                    mn2.Items.Add(new Separator());
                    mn = createMenuItem(mn2, "mnPHP_numberformat", "number_format");
                    mn = createMenuItem(mn2, "mnPHP_numberformat", "number_format");
                    mn = createMenuItem(mn2, "mnPHP_round", "round");
                    mn = createMenuItem(mn2, "mnPHP_sprintf", "sprintf");
                    mn = createMenuItem(mn2, "mnPHP_printf", "printf");
                    mn2.Items.Add(new Separator());
                    // absabs

                    mn = createMenuItem(mn2, "mnPHP_abs", "abs");
                    mn = createMenuItem(mn2, "mnPHP_ceil", "ceil");
                    mn = createMenuItem(mn2, "mnPHP_dechex", "dechex");
                    mn = createMenuItem(mn2, "mnPHP_decoct", "decoct");
                    mn = createMenuItem(mn2, "mnPHP_floor", "floor");
                    mn = createMenuItem(mn2, "mnPHP_intdiv", "intdiv");
                    mn = createMenuItem(mn2, "mnPHP_max", "max");
                    mn = createMenuItem(mn2, "mnPHP_pi", "pi");
                    mn = createMenuItem(mn2, "mnPHP_pow", "pow");

                mn1.Items.Add(new Separator());

                mn = createMenuItem(mn1, "mnPHP_Include_oncePHPFile", "Include_once PHP-File");
                mn = createMenuItem(mn1, "mnPHP_Require_oncePHPFile", "Require_once PHP-File");

                    mn1.Items.Add(new Separator());

            
                    mn2 = createMenuItem(mn1, "mainPHP_JSon", "Json");
                mn = createMenuItem(mn2, "mnPHP_JSon_encodepur", "JSon json_encode (pur)");
                mn = createMenuItem(mn2, "mnPHP_JSon", "JSon-method in class (private attrib)");
                mn = createMenuItem(mn2, "mnPHP_json_encode", "json_encode  (public attrib)");

               

                mn = createMenuItem(mn1, "mnPHP_regex", "Regex");

                mn2 = createMenuItem(mn1, "mainPHP_StringMethoden", "String Methoden");
                mn = createMenuItem(mn2, "mnPHP_char", "char (65==>A)");
                mn = createMenuItem(mn2, "mnPHP_explode", "explode");
                mn = createMenuItem(mn2, "mnPHP_ltrim", "ltrim");
                mn = createMenuItem(mn2, "mnPHP_rtrim", "rtrim");
                mn = createMenuItem(mn2, "mnPHP_trim", "trim");
                mn = createMenuItem(mn2, "mnPHP_strlen", "strlen");

                mn = createMenuItem(mn2, "mnPHP_replace", "replace");

                mn = createMenuItem(mn2, "mnPHP_bin2hex", "bin2hex");
                mn = createMenuItem(mn2, "mnPHP_str_split", "str_split (splitten nach Anzahl)");
                mn = createMenuItem(mn2, "mnPHP_strtok", "strtok");
                mn = createMenuItem(mn2, "mnPHP_ord", "ord (A==>65)");


                mn = createMenuItem(mn2, "mnPHP_substr", "substr");
                mn = createMenuItem(mn2, "mnPHP_strtolower", "strtolower");
                mn = createMenuItem(mn2, "mnPHP_strtoupper", "strtoupper");

                mn = createMenuItem(mn2, "mnPHP_Startwith", "startwith");



                // neu

                mn = createMenuItem(mn1, "mnPHP_echoText", "Echo text");
                mn = createMenuItem(mn1, "mnPHP_echoStringAndVariable", "Echo text and a variable");
                mn = createMenuItem(mn1, "mnPHP_echoStringAndVariable_withPoint", "echo text und Variable (separator ,)");
                mn = createMenuItem(mn1, "mnPHP_weiterleitung", "Weiterleitung");



                mn1 = createMenuItem(null, "mainJSP", "_JSP");
                mainMenu.Items.Add(mn1);
                                mn2 = createMenuItem(mn1, "mainJSP_ImportDirective", "Directive (import ...)");
                mn = createMenuItem(mn2, "mnJSP_InsertJSP_Directive_util", "java.util.* (ArrayList, Calendar)");
                mn = createMenuItem(mn2, "mnJSP_InsertJSP_Directive_io", "java.io.*");
                mn = createMenuItem(mn2, "mnJSP_InsertJSP_Directive_text", "java.text.* (SimpleDateFormat)");
                mn = createMenuItem(mn2, "mnJSP_InsertJSP_Directive_reflect", "reflect.* (Json-Objekt)");

                mn = createMenuItem(mn1, "mnJSP_InsertJSP_Deklaration", "Deklaration");
                mn = createMenuItem(mn1, "mnJSP_InsertJSP_Scriptlet", "Scriptlet");
                mn = createMenuItem(mn1, "mnJSP_InsertJSP_Expression", "Expression, direkte Ausgabe");
                mn = createMenuItem(mn1, "mnJSP_InsertJSP_Comment", "Comment");
                mn = createMenuItem(mn1, "mnJSP_IncludeJSP", "Include JSP file");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnJSP_Json", "Json (3 methods)");
                mn = createMenuItem(mn1, "mnJSP_getIntNumber", "getIntNumber");
                mn = createMenuItem(mn1, "mnJSP_getDoubleNumber", "getDoubleNumber");

                // ?????????????????????????????????????????????????

                mn2 = createMenuItem(mn1, "mainJSP_StringMethoden", "String Methoden");
                mn = createMenuItem(mn2, "mnJSP_codePointAt", "codePointAt (65==>A)");
                mn = createMenuItem(mn2, "mnJSP_getBytes", "getBytes()");
                mn = createMenuItem(mn2, "mnJSP_charAt", "charAt(i)");
                mn = createMenuItem(mn2, "mnJSP_ord", "ord (A==>65)");
                mn = createMenuItem(mn2, "mnJSP_toCharArray", "toCharArray()");


                mn = createMenuItem(mn2, "mnJSP_indexOf", "indexOf(i)");
                mn = createMenuItem(mn2, "mnJSP_indexOfStr", "indexOf(String)");
                mn = createMenuItem(mn2, "mnJSP_lastIndexOf", "lastIndexOf(i)");

                mn = createMenuItem(mn2, "mnJSP_ltrim", "ltrim");
                mn = createMenuItem(mn2, "mnJSP_rtrim", "rtrim");
                mn = createMenuItem(mn2, "mnJSP_trim", "trim");
                mn = createMenuItem(mn2, "mnJSP_strlen", "length");

                mn = createMenuItem(mn2, "mnJSP_split", "split");

                mn = createMenuItem(mn2, "mnJSP_substring", "substring");
                mn = createMenuItem(mn2, "mnJSP_toLowerCase", "toLowerCase");
                mn = createMenuItem(mn2, "mnJSP_toUpperCase", "toUpperCase");

                mn = createMenuItem(mn2, "mnJSP_Startswith", "startdwith");


                // ?????????????????????????????????????????????????


                mn = createMenuItem(mn1, "mnJSP_echoText", "Echo text");
                mn = createMenuItem(mn1, "mnJSP_echoStringAndVariable", "Echo text and a variable");
                mn1.Items.Add(new Separator());

                                mn2 = createMenuItem(mn1, "mainJSP_Datum", "Datum");
                mn = createMenuItem(mn2, "mnJSP_SimpleDateFormat", "SimpleDateFormat");
                mn = createMenuItem(mn2, "mnJSP_Calender", "Calender");


                mn1.Items.Add(new Separator());

                                mn = createMenuItem(mn1, "mnJSP_getParam", "getParam");
                mn = createMenuItem(mn1, "mnJSP_getParams", "getParams, mutiple");



                mn1 = createMenuItem(null, "mainHTML5", "HTML_5");
                mainMenu.Items.Add(mn1);
                                mn2 = createMenuItem(mn1, "mainHTML5Sectors", "HTML5 elements");
                mn = createMenuItem(mn2, "mnHTML5_Article", "Article selector");
                mn = createMenuItem(mn2, "mnHTML5_Header", "Header selector");
                mn = createMenuItem(mn2, "mnHTML5_Section", "Section selector");
                mn = createMenuItem(mn2, "mnHTML5_Aside", "ASide selector");
                mn = createMenuItem(mn2, "mnHTML5_Footer", "Footer selector");
                mn2.Items.Add(new Separator());

                                mn = createMenuItem(mn2, "mnHTML5_Nav_Hori", "Navigator selector (horizontal)");
                mn = createMenuItem(mn2, "mnHTML5_Nav_Verti", "Navigator selector (vertical)");

                mn2 = createMenuItem(mn1, "mainHTML5_Group_selectors", "group selectors");
                mn = createMenuItem(mn2, "mnHTML5_Summary", "Summary");
                mn = createMenuItem(mn2, "mnHTML5_Details", "Details");



                mn2 = createMenuItem(mn1, "mainHTML5_Auszeichungen", "text-level semantics");

                mn = createMenuItem(mn2, "mnHTML5_Abbr", "Abbr");
                mn = createMenuItem(mn2, "mnHTML5_B", "B (Firmennamen)");
                mn = createMenuItem(mn2, "mnHTML5_Bdi", "Bdi");
                mn = createMenuItem(mn2, "mnHTML5_Cite", "Cite");
                mn = createMenuItem(mn2, "mnHTML5_Code", "Code");
                mn = createMenuItem(mn2, "mnHTML5_DEL", "Del");
                mn = createMenuItem(mn2, "mnHTML5_DL", "DL");
                mn = createMenuItem(mn2, "mnHTML5_Dfn", "Dfn");
                mn = createMenuItem(mn2, "mnHTML5_Em", "Em");
                mn = createMenuItem(mn2, "mnHTML5_I", "I (Fachausdrücke)");
                mn = createMenuItem(mn2, "mnHTML5_Ins", "Ins (del,s)");
                mn = createMenuItem(mn2, "mnHTML5_Kdb", "Kdb (Keybord)");
                mn = createMenuItem(mn2, "mnHTML5_Mark", "Mark");
                mn = createMenuItem(mn2, "mnHTML5_Q", "Q (Zitat)");
                mn = createMenuItem(mn2, "mnHTML5_S", "S Struck through");
                mn = createMenuItem(mn2, "mnHTML5_Samp", "Samp");

                mn = createMenuItem(mn2, "mnHTML5_Small", "Small");
                mn = createMenuItem(mn2, "mnHTML5_Strong", "Strong");
                mn = createMenuItem(mn2, "mnHTML5_U", "U (wrong spelling)");
                mn = createMenuItem(mn2, "mnHTML5_Var", "Var");
                mn = createMenuItem(mn2, "mnHTML5_Wbr", "Wbr");



                mn2 = createMenuItem(mn1, "mainHTML5NewElements", "HTML5 Tag's for spezific content");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Figure", "Figure");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_keygen", "Keygen");


                mn2 = createMenuItem(mn1, "mainHTML5FormsElements", "HTML5 active form elements");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Color", "Color");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Date", "Date");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_DateTime", "DateTime");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Datetime_local", "DateTime local");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Datalist", "Datalist");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_EMail", "E-Mail");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Month", "Month");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Number", "Number");


                mn = createMenuItem(mn2, "mnHTML5_Formelements_Meter", "Meter");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Output", "Output");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Progress", "Progress");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Range1", "Range");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Range2", "Range with Textfield");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Search", "Search");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Tel", "Tel");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Time", "Time");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Url", "Url");
                mn = createMenuItem(mn2, "mnHTML5_Formelements_Week", "Week");

                mn2 = createMenuItem(mn1, "mainHTML5VideoAudios", "HTML5 Video / Audio");
                mn = createMenuItem(mn2, "mnHTML5_Video1", "simple Video-Definition");
                mn = createMenuItem(mn2, "mnHTML5_Video2", "complex Video-Definition");
                mn = createMenuItem(mn2, "mnHTML5_Video3", "complex Video-Definition with Tracks");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn2, "mnHTML5_Audio1", "simple Audio-Definition");
                mn = createMenuItem(mn2, "mnHTML5_Audio2", "complex Audio-Definition");





                mn1 = createMenuItem(null, "mainHTML5Canvas", "Canvas");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_Canvas_Element", "Canvas-Element");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_GameLoop1", "Canvas mit Game-Loop (setInterval)");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_GameLoop2", "Canvas mit Game-Loop (requestAnimationFrame)");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_GameLoop3", "ZWEI Canvas mit Game-Loop (requestAnimationFrame)");

                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_Line1", "simple line");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_Line2", "line with path");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_Rect", "rect");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_StrokeRect", "strokeRect");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_FillRect", "fillRect");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_ClearRect", "clearRect");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_Arc", "arc");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_FillArc", "FillArc");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_StrokeText", "strokeText");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_FillText", "fillText");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_BezierCurveTo", "moveTo, bezierCurveTo");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_DrawImage", "drawImage");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnHTML5_Canvas_Drawmarker1", "drawMarker1");
                mn = createMenuItem(mn1, "mnHTML5_Canvas_Drawmarker2", "drawMarker2");



                                // http://www.html5rocks.com/de/tutorials/forms/html5forms/
                                break;
                            case TextBoxTyp.CSS:
                                mn1 = createMenuItem(null, "mainCSS", "Basic CSS");
                mainMenu.Items.Add(mn1);

                                mn = createMenuItem(mn1, "mnInsertCSS_Body", "Basic selectors");
                mn = createMenuItem(mn1, "mnInsertCSS", "Empty selector");
                mn = createMenuItem(mn1, "mnInsertCSS_H2", "H2");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertCSS_PositionAbsolute", "Position absolute");
                mn = createMenuItem(mn1, "mnInsertCSS_PositionRelativ", "Position relativ");
                mn = createMenuItem(mn1, "mnInsertCSS_Multidefinition", "Multiple selectors");
                // Descendand  *
                mn = createMenuItem(mn1, "mnInsertCSS_SelektorenBehind", "Child selector (Nachfahr: body > h2)");
                mn = createMenuItem(mn1, "mnInsertCSS_SelektorenTopDown", "Adjacent sibling selectors (h1+h2)");
                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mnInsertCSS_LeftRightSelektor", "Left / Right selectors");


                mn2 = createMenuItem(mn1, "mainCSSBsp", "Complete CSS selectors");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_H2", "H2");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_OL", "OL");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_UL", "UL");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_TH", "TH");
                mn = createMenuItem(mn2, "mnInsert_CSSBlock_TD", "TD");
                mn = createMenuItem(mn1, "mnInsert_HTMLBlock_Scrolling", "Scrolling selector");

                mn1 = createMenuItem(null, "mainCSS_Image", "Images");
                mainMenu.Items.Add(mn1);

                                mn = createMenuItem(mn1, "mnInsertCSS_background_image", "Body: background-image");
                mn = createMenuItem(mn1, "mnInsertCSS_Body_backgroundrepeat", "Body: background-repeat");
                mn = createMenuItem(mn1, "mnInsertCSS_Bodybackgroundattachment", "Body: background-attachment");
                mn = createMenuItem(mn1, "mnInsertCSS_Body_backgroundposition", "Body: background-position");

                mn1 = createMenuItem(null, "mainCSS_Colors", "Colors");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertHTML_CSS_ColorConstant", "Color from constant of text");
                mn = createMenuItem(mn1, "mnInsertCSS_Farbe", "Colordialog (hexadecimal)");
                mn = createMenuItem(mn1, "mnInsert_CSS_Backgroundcolor", "Background color");

                mn1 = createMenuItem(null, "mainCSS_Fonts", "Fonts");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertCSS_Schrift12em", "Size=1,2em");
                mn = createMenuItem(mn1, "mnInsertCSS_FontColor", "Font color");
                mn = createMenuItem(mn1, "mnInsertCSS_FontWeight", "Font weight");

                mn2 = createMenuItem(mn1, "mainCSS_Fonts", "Fonttype");
                mn = createMenuItem(mn2, "mnInsertCSS_VerdanaArialHelveticaSwiss", "Verdana, Arial, Helvetica, Swiss");
                mn = createMenuItem(mn2, "mnInsertCSS_CourierNew", "Courier New");
                mn = createMenuItem(mn2, "mnInsertCSS_Monospace", "Monospace");

                mn2 = createMenuItem(mn1, "mainInsertCSS_SmallFont", "relative Fontsize");
                mn = createMenuItem(mn2, "mnInsertCSS_SmallestFont", "Smallest font");
                mn = createMenuItem(mn2, "mnInsertCSS_SmallerFont", "Smaller");
                mn = createMenuItem(mn2, "mnInsertCSS_BiggerFont", "Greater");
                mn = createMenuItem(mn2, "mnInsertCSS_BigFont", "Big font");
                mn = createMenuItem(mn2, "mnInsertCSS_FontSize_15Em2", "Font greater as (em)");
                mn = createMenuItem(mn2, "mnInsertCSS_Bigger_Percentage", "Font greater as (%)");


                mn = createMenuItem(mn1, "mnInsertCSS_WordSpacing", "Word-Spacing");
                mn = createMenuItem(mn1, "mnInsertCSS_LetterSpacing", "Letter-Spacing");

                mn2 = createMenuItem(mn1, "mainInsertCSS_Textdecoration", "Text-decoration");
                mn = createMenuItem(mn2, "mnInsertCSS_Textdecoration_None", "None");
                mn = createMenuItem(mn2, "mnInsertCSS_Textdecoration_Underline", "Underline");
                mn = createMenuItem(mn2, "mnInsertCSS_Textdecoration_Overline", "Overline");
                mn = createMenuItem(mn2, "mnInsertCSS_Textdecoration_Blinkend", "Flashing");
                mn = createMenuItem(mn2, "mnInsertCSS_Textdecoration_Italic", "Italic/kursiv");

                mn2 = createMenuItem(mn1, "mainInsertCSS_Texttransform", "Text-transform");
                mn = createMenuItem(mn2, "mnInsertCSS_Texttransform_None", "None");
                mn = createMenuItem(mn2, "mnInsertCSS_Texttransform_Uppercase", "Uppercase");
                mn = createMenuItem(mn2, "mnInsertCSS_Texttransform_Lowercase", "Lowercase");
                mn = createMenuItem(mn2, "mnInsertCSS_Texttransform_Capitalize", "Capitalize");

                                createMenuItem(mn1, "mnInsertCSS_Text_Indent", "Text-indent (Texteinrückung)");



                mn1 = createMenuItem(null, "mainCSS_Lists", "Lists");
                mainMenu.Items.Add(mn1);
                                mn2 = createMenuItem(mn1, "mainCSS_Lists_UL", "Ul");
                mn = createMenuItem(mn2, "mnCSS_Lists_UL_None", "None");
                mn = createMenuItem(mn2, "mnCSS_Lists_UL_Circle", "Circle");
                mn = createMenuItem(mn2, "mnCSS_Lists_UL_Square", "Square");
                mn = createMenuItem(mn2, "mnCSS_Lists_UL_Disc", "Disc");

                mn2 = createMenuItem(mn1, "mainCSS_Lists_OL", "Ol");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_None", "None");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Decimal", "Decimal");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Decimalleadingzero", "Decimal-leading-zero");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Lowerroman", "Lower-roman");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Upperroman", "Upper-roman");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Lowergreek", "Lower-greek");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Lowerlatin", "Lower-latin");
                mn = createMenuItem(mn2, "mnCSS_Lists_OL_Upperlatin", "Upper-latin");

                mn2 = createMenuItem(mn1, "mainCSS_Lists_Liststyleposition", "List-style-position");
                mn = createMenuItem(mn2, "mnCSS_Lists_Inside", "Inside");
                mn = createMenuItem(mn2, "mnCSS_Lists_Outside", "Outside");

                mn1 = createMenuItem(null, "mainCSS_Tables", "Tables");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertCSS_TH", "Tr");
                mn = createMenuItem(mn1, "mnInsertCSS_TH", "Th");
                mn = createMenuItem(mn1, "mnInsertCSS_TD", "Td");
                mn = createMenuItem(mn1, "mnInsertCSS_Table_th_td_Border", "Table with border");
                mn = createMenuItem(mn1, "mnInsertCSS_Table_css_hover", "Table with css hover");


                mn1 = createMenuItem(null, "mainCSS_Legends", "Forms");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnCSS_FieldsetLegend", "Fieldset/Legend");



                mn1.Items.Add(new Separator());
                                mn = createMenuItem(mn1, "mainInsertCSS_Input_required", "input:required");
                mn = createMenuItem(mn1, "mainInsertCSS_Input_invalid", "input:invalid");

                mn1 = createMenuItem(null, "mainCSS_Layout", "Layouts");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnCSS_GridlayoutDialog", "Gridlayout (label / input text)");
                mn = createMenuItem(mn1, "mnCSS_Flexlayout1", "Flexlayout (label / input text)");
                mn = createMenuItem(mn1, "mnCSS_Flexlayout2", "Flexlayout (input text / input text)");
                mn1.Items.Add(new Separator());

                                mn2 = createMenuItem(mn1, "mainInsertCSS_FlexLayout_Parent", "FlexLayout Parent");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_DisplayFlex", "Display:flex");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_Direction", "Display:direction");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_Wrap", "Display:wrap");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_justify_content", "Display:justify-content");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_align_items", "align-items");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_align_content", "align-content");
                mn2 = createMenuItem(mn1, "mainInsertCSS_FlexLayout_Childs", "FlexLayout Childs");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_flex_basis", "flex-basis");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_flex_grow", "flex-grow");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_flex_shrink", "flex-shrink");
                mn = createMenuItem(mn2, "mnInsertCSS_FlexLayout_align_self", "align-self");



                mn1 = createMenuItem(null, "mainCSS_Borders", "Borders");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnInsertCSS_BorderColor", "Color of a border");
                mn2 = createMenuItem(mn1, "mainInsertCSS_BorderStyles", "Border-Styles");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_None", "None");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Hidden", "Hidden");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Dotted", "Dotted");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Dashed", "Dashed");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Solid", "Solid");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Double", "Double");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Groove", "Groove");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Ridge", "Ridge");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Inset", "Inset");
                mn = createMenuItem(mn2, "mnInsertCSS_Border_Outset", "Outset");

                mn = createMenuItem(mn1, "mnInsertCSS_BorderWidth", "Border-Width");

                mn2 = createMenuItem(mn1, "mainInsertCSS_Padding", "Padding (Innenrand)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_OneForFour", "One value for all paddings");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_TwoForTwo", "Two values for all paddings (top/bottom  und left/right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_FourForFour", "Four values for all paddings (top,bottom,left,right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Top", "Padding-top");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Left", "Padding-left");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Bottom", "Padding-Bottom");
                mn = createMenuItem(mn2, "mnInsertCSS_Padding_Right", "Padding-right");

                mn2 = createMenuItem(mn1, "mainInsertCSS_Margin", "Margin (Außenrand)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_OneForFour", "One value for all margins");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_TwoForTwo", "Two values for all margins (top/bottom  und left/right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_FourForFour", "Four values for all margins (top,bottom,left,right)");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Top", "Margin-top");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Left", "Margin-left");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Bottom", "Margin-Bottom");
                mn = createMenuItem(mn2, "mnInsertCSS_Margin_Right", "Margin-right");

                mn1 = createMenuItem(null, "mainCSS_Links", "Links");
                mainMenu.Items.Add(mn1);
                                mn = createMenuItem(mn1, "mnCSS_Links_NoneVisited", "None visited");
                mn = createMenuItem(mn1, "mnCSS_Links_Visited", "Visited");
                mn = createMenuItem(mn1, "mnCSS_Links_Activate", "Activate");
                mn = createMenuItem(mn1, "mnCSS_Links_ThreeLinks", "All three types of links (separate)");
                mn = createMenuItem(mn1, "mnCSS_Links_ThreeLinksTogether", "All three types of links (together)");

                mn1 = createMenuItem(null, "mainCSS_Alignments", "Alignment");
                mainMenu.Items.Add(mn1);
                                mn2 = createMenuItem(mn1, "mainCSS_HAlign", "Horizontal Alignment");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Left", "Left");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Center", "Center");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Right", "Right");
                mn = createMenuItem(mn2, "mnCSS_HAlign_Justify", "Justify (Blocksatz)");

                mn2 = createMenuItem(mn1, "mainCSS_VAlign", "Vertical Alignment");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Baseline", "Baseline");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sub", "Sub");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Sup", "Sup");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Texttop", "Text-top");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Textbottom", "Text-bottom");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Middle", "Middle");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Top", "Top");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Bottom", "Bottom");
                mn = createMenuItem(mn2, "mnCSS_VAlign_Percentage", "Percentage");



                mn1 = createMenuItem(null, "mainCSSHTML5", "HTML5");
                mainMenu.Items.Add(mn1);
                                mn2 = createMenuItem(mn1, "mainCSSHTML5Sectors", "HTML5 sectors");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Article", "Article selector");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Header", "Header selector");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Section", "Section selector");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Nav", "Navigator selector");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Aside", "ASide selector");
                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Footer", "Footer selector");

                mn2.Items.Add(new Separator());
                                mn = createMenuItem(mn2, "mnInsertCSS_HTML5_Required", "Textbox Required");

                mn2 = createMenuItem(mn1, "mainCSSHTML5_Auszeichungen", "text-level semantics");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Abbr", "Abbr");
                mn = createMenuItem(mn2, "mnCSS_HTML5_B", "B (Firmennamen)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Bdi", "Bdi");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Cite", "Cite");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Code", "Code");
                mn = createMenuItem(mn2, "mnCSS_HTML5_DEL", "Del");
                mn = createMenuItem(mn2, "mnCSS_HTML5_DL", "DL");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Dfn", "Dfn");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Em", "Em");
                mn = createMenuItem(mn2, "mnCSS_HTML5_I", "I (Fachausdrücke)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Ins", "Ins (del,s)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Kdb", "Kdb (Keybord)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Mark", "Mark");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Q", "Q (Zitat)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_S", "Struck through");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Samp", "Samp");

                mn = createMenuItem(mn2, "mnCSS_HTML5_Small", "Small");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Strong", "Strong");
                mn = createMenuItem(mn2, "mnCSS_HTML5_U", "U (wrong spelling)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Var", "Var");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Wbr", "Wbr");

                mn2 = createMenuItem(mn1, "mainCSS_HTML5_Group_selectors", "group selectors");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Summary", "Summary");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Details", "Details");

                mn2 = createMenuItem(mn1, "mainCSSHTML5_Transition", "Transition");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transition_Ease", "ease");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transition_Ease_In", "ease-in");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transition_Ease_Out", "ease-out");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transition_Ease_In_Out", "ease-in-out");

                mn2 = createMenuItem(mn1, "mainCSSHTML5Animation", "Animation");
                mn = createMenuItem(mn2, "mnCSS_HTML5_AnimationBlock", "Animationsblock");
                mn = createMenuItem(mn2, "mnCSS_HTML5_keyframesFromTo", "keyframes (from to)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_keyframesProzent", "keyframes (Prozent)");



                // InsertCSS_HTML5_InsertTransform_Scale
                mn2 = createMenuItem(mn1, "mainCSSHTML5_Transform", "Transform");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_Rotate", "rotate(12°)");
                mn2.Items.Add(new Separator());
                                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_TranslateX", "translateX(3px)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_TranslateY", "translateY(3px)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_TranslateXY", "translate(3px,4px)");
                mn2.Items.Add(new Separator());
                                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_ScaleX", "scaleX(2.76)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_ScaleY", "scaleY(2.76)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_ScaleXY", "scale(1.45,2.76)");
                mn2.Items.Add(new Separator());
                                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_SkewX", "skewX(1.55°)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_SkewY", "skewY(1.55°)");
                mn = createMenuItem(mn2, "mnCSS_HTML5_Transform_Skew", "skewX(1.45°, 1.55°)");

                mn2.Items.Add(new Separator());

                                mn2 = createMenuItem(mn1, "mainCSSHTML5_Gradient", "Background-gradient");
                mn3 = createMenuItem(mn2, "mainCSSHTML5_Lin_Gradient", "Linear-gradient");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient1", "linear gradient( to top, 0°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient2", "linear gradient( to top right, 45°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient3", "linear gradient( to right, 90°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient4", "linear gradient( to bottom right, 135°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient5", "linear gradient( to bottom, 90°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient6", "linear gradient( to bottom left, 225°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient7", "linear gradient( to left, 270°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient8", "linear gradient( to top left, 315°)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Lin_Gradient9", "linear gradient( 315°)");




                mn3 = createMenuItem(mn2, "mainCSSHTML5_Radial_Gradient", "Radial-gradient");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Radial_Gradient1", "radial-gradient(red, yellow, green)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Radial_Gradient2", "radial-gradient(ellipse, red, yellow, green)");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Radial_Gradient3", "radial-gradient(circle, red, yellow, green)");


                mn3 = createMenuItem(mn2, "mainCSSHTML5_Size_Gradient", "Radial Size-gradient");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Size_Gradient1", "closest-side");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Size_Gradient2", "closest-corner");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Size_Gradient3", "farthest-side");
                mn = createMenuItem(mn3, "mnCSS_HTML5_Size_Gradient4", "farthest-corner");
                        break;
                }  // switch
        } // setCreateMenu

      
    }  // class
  }

/*
 * Suchen
                // index = editor.Text.IndexOf(search, position);
                //TextPointer currentPosition = editor.Document.ContentStart;
                //indexTextPointerSuchen = -1;
                //while (currentPosition!=null) {
                //    // String s = currentPosition.GetTextInRun(LogicalDirection.Backward) + currentPosition.GetTextInRun(LogicalDirection.Forward);
                //    paragraph = currentPosition.Paragraph;
                //    indexTextPointerSuchen++;
                //    columnSuchen = 0;
                //    if (paragraph != null) {
                //        for (int i=0; i< paragraph.Inlines.Count; i++) {
                //            run = (Run)paragraph.Inlines.ElementAt(i);
                //            indexInlinesSuchen = i;
                //            String s = run.Text;
                //            if (s.Equals(search)) {
                //                // editor.CaretPosition
                //                editor.CaretPosition = currentPosition;  // Nur Zeilenanfang
                //                gefunden = true;
                //                break;
                //            }
                //            else {
                //                columnSuchen += s.Length;
                //            }
                //        }
                //        if (gefunden) {
                //            break;
                //        }
                //    }
                //    //    String s = currentPosition.Parent.Text;
                //    currentPosition = currentPosition.GetNextInsertionPosition(LogicalDirection.Forward);
                //}
 */
